-*- coding: utf-8 -*-

commit 95aff214687a5e12c3eb57d056665741e734c188
  Author: TAKANO Mitsuhiro <takano32@gmail.com>
  Date:   2020-12-25 12:06:46 +0900

    Disable DTrace in FreeBSD (#3999)

    The latest ruby cannot compile with FreeBSD Dtrace enabled.

commit 312171907c678837f7b687aff0c8b4e2652df83c
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2020-12-25 11:32:19 +0900

    Sort URLs by issue numbers and remove duplicated [ci skip]

commit 0a31310b99e5c91188af550c0492ac8ecda17cb2
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-25 11:10:29 +0900

    define RGENGC_DEBUG_ENABLED() as 0

    on RUBY_DEVEL==0 and !HAVE_VA_ARGS_MACRO.

    gc_report() is always enabled on such configuration
    (maybe it is a bug) so disable RGENGC_DEBUG_ENABLED().

commit 5c6f5b16c65506d0aadacb69b2a110f7a75cbf8b
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-25 10:22:43 +0900

    Update stdlib section for Ruby 3.0

commit a628a108fe884d87e527d6f1a46e65ce37b6103e
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-25 09:51:45 +0900

    USE_RUBY_DEBUG_LOG is not defined !devel build

commit 3fadf2665a109ca3e9b490aff2100ad190765358
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2020-12-25 08:45:09 +0900

    v3.0.0p0

commit 93a1ef67095c6654df753b2ecf8a4e36fe2a22c6
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2020-12-25 07:20:04 +0900

    Fix typos

commit c3f91f9d8823d607e73f621bbf40f4cba44dc739
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2020-12-25 07:09:51 +0900

    [DOC] Fix typos

commit db2ebbd71b746734b88832b1e70db8afed3d68ed
  Author: Marc-André Lafortune <github@marc-andre.ca>
  Date:   2020-12-25 02:08:12 +0900

    Optimize calls to `Kernel#hash` (#3987)

    This avoids recursive checks when the `hash` method of an object
    isn't specialized.

  Notes:
    Merged-By: nurse <naruse@airemix.jp>

commit 8981a63f12f9c30e9c6f893d292d01fd5df89991
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-25 01:59:07 +0900

    Update TypeProf to 0.11.0 (#3996)

  Notes:
    Merged-By: mame <mame@ruby-lang.org>

commit 9b091084a19ccfd338f7662cd9b9a2f1613e4a3b
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-25 01:44:54 +0900

    [memory_view] Add documentation [ci skip]

commit 523b520b44c403345cd9d96ee33ae27fef3c89a5
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-25 01:17:44 +0900

    [ruby/reline] 0.2.0

    https://github.com/ruby/reline/commit/064664c8f9

commit 32616229e3794ffba370fac0d385adc51a1baa94
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-25 01:17:29 +0900

    [ruby/irb] Version 1.3.0

    https://github.com/ruby/irb/commit/ec83280e66

commit d143b75f8ef6043168477f0c77668eb3a5502070
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-25 00:56:17 +0900

    Adjusted indents [ci skip]

commit 0356c3269a7c01fefdd3105d119494c81cd18d03
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-25 00:14:50 +0900

    * 2020-12-25 [ci skip]

commit c64a067d0569a0aa20ff325c800c1cd74977313c
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-25 00:06:16 +0900

    configure.ac: Make it possible to build on Android Termux

    The recent Termux's clang predefines `__ANDROID_API__` as a fixed number
    24. However, when it is lower to the current device version, some
    functions that "configure" determines available are not declared
    correctly in the header files.

    This change forces to overwrite the predefined `__ANDROID_API__` macro
    with the current device version.

    ref: https://github.com/termux/termux-packages/issues/6176

commit 81562f943e4f33fbfd00fdfd115890ba0b76916c
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-24 19:47:35 +0900

    Updated access to Process::Status attributes

    pst_pid() no longer returns Qnil even if the receiver is not
    initialized.

commit 9a7647d9eb59c8ed00b0de46fbf26f744a4158c5
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-24 22:53:24 +0900

    [ruby/reline] Doesn't contain terminate spaces by cw

    This closes ruby/reline#233.

    https://github.com/ruby/reline/commit/4c3f2e2eae

commit 78421319d0401c37497f2b5df7110e92eef9f0e4
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-24 21:44:09 +0900

    [ruby/reline] Use #bytesize for vi_replace_char

    This closes ruby/reline#228.

    https://github.com/ruby/reline/commit/8205fa0b00

commit 0db9842b2ca85709424d6c9c1e11caeae30dfae7
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-24 21:24:35 +0900

    [ruby/reline] Delete the last char of a line by dw

    This closes ruby/reline#229.

    https://github.com/ruby/reline/commit/3f0ae689c4

commit 8d5d139afaf37665d2e77eeb1197e216491d805d
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-24 20:28:26 +0900

    [ruby/reline] Suppress crashing when boken prompt_list is given

    https://github.com/ruby/reline/commit/922d087e7a

commit 634b231f33d28e4048afdc643dcf14c924b98f2e
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-24 07:15:54 +0900

    [ruby/reline] Discard prompt cache by changing mode icon

    https://github.com/ruby/reline/commit/bfeda8a79b

commit 167dc37632300e0061351ab87ddc89ebe9c5f53f
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-24 22:09:09 +0900

    [ruby/irb] Try not to register the exact same measuring method twice

    https://github.com/ruby/irb/commit/cc66b5573e

commit 2c752ff9309496d18c2158f593cab2b6fc671783
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2020-12-24 23:13:12 +0900

    Fix a typo [ci skip]

commit bdbbfd1fa53baac4d12530a6791140e35a9df46b
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-24 16:44:38 +0900

    Store errno in struct rb_process_status

    To propagate errno in the fiber thread scheduler hook.
    Returns nil when no terminated process.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3998

commit c752d29bbf784334240fca8956e39f035fb76ec1
  Author: Soutaro Matsumoto <matsumoto@soutaro.com>
  Date:   2020-12-24 21:26:46 +0900

    Bundle RBS 1.0.0 (#3994)

  Notes:
    Merged-By: soutaro <matsumoto@soutaro.com>

commit 9f9a389d95d8a4615b39b196e549e3d5f9d00794
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2020-12-24 19:35:03 +0900

    doc/syntax/pattern_matching.rdoc: fix typos, grammar, style

commit a4419a55f0117a9729be412432835b77dab0d55a
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2020-12-24 19:31:06 +0900

    doc/extension.ja.rdoc: remove trailing whitespace

commit c601a7ecfdfebcbf3534c4c22a3a7afc4dbf3333
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2020-12-24 19:30:30 +0900

    doc/keywords.rdoc: fix typo

commit 7ca2ca9e32ceea48e2e3a2d31318dff57da7f08e
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-24 16:53:26 +0900

    Remove unneeded code

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3993

commit 1a74fb011d318a5afde7b233a6b8c34e7c2b8263
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-24 18:03:39 +0900

    doc/maintainers.rdoc: typo

commit 8664c3ddef548b53c4f5c5264cccd24ae08f174f
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-24 17:41:48 +0900

    update doc/ractor.md

commit a89932799c914d1864fc91f33d6461592dbfd3fb
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2020-12-24 17:19:16 +0900

    gen-release-note.rb: Avoid to depend release metadata

    Because it doesn't have metadata when I edit draft.

commit 6a6daf3803771884f4cbf8e134802ae430568ba2
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2020-12-24 17:18:07 +0900

    Add tag key

    Release note will use tag value when I write GitHub URLs with release
    tags.

commit 709d9cf1ba47d6df20ba067fdc8e92a7a817d1d3
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2020-12-21 03:02:30 +0900

    Add release engineering related tools

commit d58537cf8f4c3a3569fb5dd647dd5f0a19a9f3be
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2020-12-21 02:26:19 +0900

    Revert "remove bz2"

    This reverts commit 7856da5fe75a76bec909778e411270c10a04ca3a.
    For other branches

commit eb3944c287a455fb1673dd74e31b56afb3c3b649
  Author: Soutaro Matsumoto <matsumoto@soutaro.com>
  Date:   2020-12-24 17:19:23 +0900

    Bundle RBS 1.0.0.pre2 (#3991)

  Notes:
    Merged-By: soutaro <matsumoto@soutaro.com>

commit 85f01794795521e29e64e06ead416cbd3d52c55c
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-24 17:14:48 +0900

    doc/keywords.rdoc: mention pattern matching in the `in` keyword section

commit 1415653c84602b3ac4ee449858783aacd8af81ed
  Author: zverok <zverok.offline@gmail.com>
  Date:   2020-12-13 01:55:17 +0900

    Redocument non-blocking Fibers and scheduler

    * Document Fiber's method related to scheduling;
    * Extend Fiber's class docs with concepts of non-blocking
      fibers;
    * Introduce "imaginary" (documentation-only) class
      Fiber::SchedulerInterface to properly document how
      scheduler's methods should look.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3891

commit 1729fd8c0acd66aec20bb6986bd82913c9dc190d
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-24 17:00:30 +0900

    doc/contributing.rdoc: remove outdated content

commit f910a27d37a3ab132126f13a20a458afa8889231
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-24 16:37:52 +0900

    README.md: Haiku is currently unsupported

commit b343d547923cf29456910b20fcd1c0a58ed68176
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-24 16:16:20 +0900

    Use RBIMPL_COMPILER_{SINCE,BEFORE} for MSVC

    Pointed out by @shyouhei.

    NOTE: Already we have dropped the support for older MSVCs,
    probably prior to 1300 or 1400.  Remove the conditional code,
    especially in win32/Makefile.sub.

commit a76082f499ef819a18a0426973ea531019df4e0a
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-24 16:10:10 +0900

    Add call-seq to Ractor doc; improve wording [doc]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3992

commit e44a8bd791ee0a2bcb5845c6152daab75e4e6b9e
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-24 16:06:40 +0900

    Let's be more accurate [ci skip]

commit 176b75747c3a079cab5cc83c47d54fa4f9dfa6be
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-24 15:59:57 +0900

    Add NEWS entries about JIT in Jul ~ Dec

    * Instance variables
      * Merge ivar guards on JIT https://github.com/ruby/ruby/commit/a69dd699ee630dd1086627dbca15a218a8538b6f https://github.com/ruby/ruby/commit/e4f7eee009ebe1f23ee3e5ea69ccd9ea1530bc6f
      * Prefer RB_OBJ_FROZEN_RAW https://github.com/ruby/ruby/commit/5611066e03fe73bdbb08cc46f79530c69975cf17
      * Skip checking ROBJECT_EMBED https://github.com/ruby/ruby/commit/81a8d1cf09d59f0d69143d7896545f849f580a4e
    * Method inlining
      * Mark some Integer methods as inline https://github.com/ruby/ruby/commit/0703e014713ae92f4c8a2b31e385718dc2452eac
      * Allow inlining Integer#-@ and #~ https://github.com/ruby/ruby/commit/dbb4f1996939d0ce977e6b37579e28dd886428ff
      * Inline builtin struct aref https://github.com/ruby/ruby/commit/167d139487d67613bd02522e24476f06ffa137b7
      * Make Kernel#then, #yield_self, #frozen? builtin https://github.com/ruby/ruby/commit/24fa37d87a24dc932c1d778bcaf91204f5c12a76
      * (For future) Rewrite Kernel#tap with Ruby https://github.com/ruby/ruby/commit/f3a0d7a2035e9f5e0c70effd55732607e3def263
    * Other optimizations
      * Inline constant references https://github.com/ruby/ruby/commit/53babf35ef5b643774636550ea23851e2607e076
      * Lazily move PC with RUBY_VM_CHECK_INTS https://github.com/ruby/ruby/commit/5d74894f2bc4a3a18aec952d946ead3d784cb4b4
      * Cache access to reg_cfp->self on JIT https://github.com/ruby/ruby/commit/d40983772966938828a28c6e89752a3e76447b9e
    * JIT compaction
      * Shrink the blocking region for compile_compact_jit_code https://github.com/ruby/ruby/commit/ed8e552d4d2c825a3f780ac8bd898eaaca7c21e7
      * Stop leaving .c files for JIT compaction in /tmp https://github.com/ruby/ruby/commit/fa1250a506e9b6a1bcbf664f6b7b9c06e045d9b9
    * GC of JIT-ed code
      * Run unload_units in the JIT worker thread https://github.com/ruby/ruby/commit/16dab6b69263ed9c816bc0283c8c1f2f95dc1027
      * Avoid unloading units which have enough total_calls https://github.com/ruby/ruby/commit/d80226e7bd801fcbccf71f19ba373b7baf71a49e
      * Throttle unload_units https://github.com/ruby/ruby/commit/122cd35939ddf8ef7bfa17ad75570c01d0cf06ab
      * Throttle JIT compaction https://github.com/ruby/ruby/commit/096f54428d8000cccce430022784cb0e7cd31cb4
    * Compilation speed
      * Eliminate IVC sync between JIT and Ruby threads https://github.com/ruby/ruby/commit/0960f56a1d773c5417e9de729e159d346aec17ca
      * Lazily move units from active_units to stale_units https://github.com/ruby/ruby/commit/5d8f227d0edd3c542fcac465eb82005a5f852d34

    Please see https://github.com/ruby/ruby/commit/200c5f4075cb1d179c2eba5b30b5b0a500870f67 for other improvements in Jan ~ Jun.

commit 8aa299de24145891848ce50e29856d2275c75fd3
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-24 15:36:08 +0900

    Tweak magic comments [doc]

commit 8c510e4095458c783420ea0da86f9eedb139731d
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-24 14:57:16 +0900

    NEWS.md: grammatical improvement

commit 24ae0e8ed73947e030b31badb9d620ddf71898b6
  Author: zverok <zverok.offline@gmail.com>
  Date:   2020-12-23 15:14:18 +0900

    Review comments

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3981

commit 5696c693540a06c01bf6172d33aff731ad61f871
  Author: zverok <zverok.offline@gmail.com>
  Date:   2020-12-23 06:23:14 +0900

    Redocument Fiber#transfer

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3981

commit 8e1c0b2f93abe23f42bd7eba0a3f0d3f3669e486
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-24 13:43:22 +0900

    dir.c: chdir conflict should raise only when called in different thread

    ... and keep it as a warning (like 2.7) when it is called in the same
    thread. [Bug #15661]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3990

commit e43b5aa52dcd1eaded1141ab85a30bc8c7c4a6e4
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-24 14:31:01 +0900

    remove redundant example.

    pointed by @marcandre.

commit 6f29716f9ffb710af7f344839ec67ef2b8a48ab2
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-24 10:59:27 +0900

    shareable_constant_value: experimental_copy

    "experimental_everything" makes the assigned value, it means
    the assignment change the state of assigned value.
    "experimental_copy" tries to make a deep copy and make copyied object
    sharable.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3989

commit 1e215a66d26d56befab4fbb72e1d953879411955
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-12-23 14:30:32 +0900

    Fix class of method in Method#inspect for singleton classes of classes

    Previously, due to a change to fix bug 15608, Method#inspect output
    changed for class methods:

    Ruby 2.7
    "#<Method: String.prepend(*)>"

    Before change:
    "#<Method: #<Class:Object>(Module)#prepend(*)>"

    This is wrong because the Method object was created from String and
    not Object. This is because the fix for bug 15608 assumed it was
    being called on the singleton class of a instance, and would skip
    the first singleton class until it got to the class itself.  For
    class methods, this results in always using the superclass. Fix
    behavior to not skip until the superclass if the singleton class
    is the singleton class of a module or class.

    After change:
    "#<Method: #<Class:Object>(Module)#prepend(*)>"

    Fixes [Bug #17428]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3984

commit 9aca51e8a597fb4689c058b4e6b215ae87434e1b
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-24 12:09:08 +0900

    add about Ractor into extension.rdoc [ci skip]

commit 66719d7dc8de7b61129d50f40c81ebd9cee323f0
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-23 16:30:16 +0900

    etc: use atomic operation instead of mutex

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3983

commit 6ed6b85ece8733518a7da0c3ec714f20d1102bf5
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-23 14:09:28 +0900

    Expose atomic operation macros with RUBY prefix [Feature #17433]

    Now we need atomic operations, which are lighter than mutex, more
    widely for extension libraries because of Ractor.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3983

commit f755926ddd3b92248f1fcdf977bd8537bff1f1dd
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-24 10:14:39 +0900

    test/ruby/test_module.rb: not depend on the order of method definitions

commit 05a756b3323d23b8f6ec899eaa83f7172ada0999
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-24 09:32:31 +0900

    [memory_view] Fix some grammar issues in a comment

commit ae26d5bd41ba3718073176a6be7b16924c5b138b
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2020-12-24 05:56:04 +0900

    doc/fiber.md: fix typos

commit 7340e7f82780f529d80490045f5ea3e2559d563c
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-24 04:29:59 +0900

    introduce rb_ractor_atfork()

    to reset main ractor at fork().

commit 7fcb6b3dbe7517fe5426fdb6871cd4940a71b7e8
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-24 04:18:17 +0900

    fix ractor-locking around rb_ractor_thread_list()

    With locking a ractor, rb_ary_push() can call RB_VM_LOCK_ENTER()
    and it violates an assertion: should not acquire ractor-lock.

commit 458d5175b9f3476c4d0c95c35458aab10c78e647
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2020-12-24 03:47:26 +0900

    Small improvements in magic comments docs

    * remove a duplicate statement
    * fix rdoc markup
    * fix typos

commit b32ed8aa41795e3b153b423ae14d2699060d73db
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-24 01:58:43 +0900

    remove method__cache__clear

    DTrace probe method__cache__clear is no longer used.
    [Bug #16658]

commit a8fc72f5a8c30ef7b5e78824e15e9868f52a3c33
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-24 01:50:45 +0900

    sample/trick2015/kinaba/entry.rb: The constant "Data" has been removed

    Instead, use "Proc" as a 4-letter constant.

commit 8feb40f49a5862ba1a42a5d8d9e228e1a8883a29
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-17 05:39:02 +0900

    Document shareable_constant_value and other magic constants [doc]

commit 4a8ff22f0c9f8a7cd9a68f49523fa2573a4326e9
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-24 01:25:22 +0900

    Reset paren_nest at tAREF and tASET [Bug #17431]

commit fb545743932a5efd5a34ed9da981248dae3cc5ff
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-24 01:24:30 +0900

    Pass keyword options in assert_syntax_error

commit 221ca0f8281d39f0dfdfe13b2448875384bbf735
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-24 00:16:59 +0900

    * 2020-12-24 [ci skip]

commit 3a81daaf8dc037057d96b8e8cdc6ab1691e7e9d9
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-24 00:15:29 +0900

    Module#public_class_method also accepts a symbol array as an argument

    I'm unsure if this is intentional, but add a document anyway.
    [Feature #17314]

commit 94015200b69820575c8b11d4181d397b033b69ac
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-23 23:40:04 +0900

    [fiddle] Update to 1.0.6

commit 28e9344fa49387ef84c71a72d1ba7e32b61cf4c7
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-23 20:29:57 +0900

    [ruby/irb] Change StdioInputMethod#eof? to non-blocking

    This fixes --inf-ruby-mode.

    https://github.com/ruby/irb/commit/0e4a818955

commit 129ecb43e54b3249734c69787f813d49ce995567
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-23 21:19:27 +0900

    [ruby/irb] Fix error_message for assert_dynamic_prompt

    https://github.com/ruby/irb/commit/b12dfb6298

commit 31bd17218515a20cf46951018d413b739935beba
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-23 21:18:48 +0900

    [ruby/irb] Suppress "shadowing outer" warning

    https://github.com/ruby/irb/commit/8b83fbef69

commit 684649ea0573c94f4d5004d9f200df65205ea246
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-23 19:47:09 +0900

    [ruby/psych] Bump version to 3.3.0

    https://github.com/ruby/psych/commit/0abce07b90

commit 8259d88938bcbd65c7994e3d8261c4de82e74174
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-23 18:45:14 +0900

    [ruby/psych] Skip test_ractor.rb with ruby/psych repo

      Because ruby/psych still uses minitest. minitest didn't support
      assert_ractor provided by test suite of ruby/ruby repo.

    https://github.com/ruby/psych/commit/7da26358f1

commit aad88cc10ba268625aaa93ddcc6ff5036052c5cd
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-23 16:51:16 +0900

    [ruby/date] Define dummy RUBY_TYPED_FROZEN_SHAREABLE for old Ruby

    https://github.com/ruby/date/commit/9f3e90ad10

commit aa856d50772aaaceb7b245b8b59f1ab1851a7fab
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-23 16:54:54 +0900

    [ruby/date] Fix envutil for old Ruby

    https://github.com/ruby/date/commit/57e25c406a

commit 313d63c2ac447abc59a878dec0d619314d75449b
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-23 18:06:27 +0900

    Use rb_init_identtable instead of direct use of rb_hashtype_ident

commit e052d0716325bcb499c57b1de0c6e3eb9effb299
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-23 16:55:36 +0900

    Revert "need to clear blocking cnt at fork (child process)"

    This reverts commit 0dd4896175f95c4c2a26d91a97b9fcb9a74cc0c6.

    It breaks the tests on RUBY_DEBUG=1.

commit 81a8d1cf09d59f0d69143d7896545f849f580a4e
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-23 16:38:01 +0900

    Skip checking ROBJECT_EMBED

    when we already check ROBJECT_NUMIV(self) is larger than
    ROBJECT_EMBED_LEN_MAX at the beginning of the method, because the number
    of instance variables for the same object doesn't decrease.

    ```
    $ benchmark-driver -v --rbenv 'before --jit;after --jit' --repeat-count=4 --alternate --output=all benchmark_3000.yml
    before --jit: ruby 3.0.0dev (2020-12-23T06:32:19Z master dbb4f19969) +JIT [x86_64-linux]
    after --jit: ruby 3.0.0dev (2020-12-23T07:45:42Z master 95e866c098) +JIT [x86_64-linux]
    last_commit=Skip checking ROBJECT_EMBED
    Calculating -------------------------------------
                                  before --jit           after --jit
    Optcarrot 3000 frames   102.34091772397872    102.77738408379015 fps
                            103.37784821624231    105.46530219076179
                            104.39567016876369    106.43712452152215
                            105.31782092252713    106.54986150067481
    ```

commit dbb4f1996939d0ce977e6b37579e28dd886428ff
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-23 15:23:45 +0900

    Allow inlining Integer#-@ and #~

    ```
    $ benchmark-driver -v --rbenv 'before --jit;after --jit' benchmark/mjit_integer.yml --filter '(comp|uminus)'
    before --jit: ruby 3.0.0dev (2020-12-23T05:41:44Z master 0dd4896175) +JIT [x86_64-linux]
    after --jit: ruby 3.0.0dev (2020-12-23T06:25:41Z master 8887d78992) +JIT [x86_64-linux]
    last_commit=Allow inlining Integer#-@ and #~
    Calculating -------------------------------------
                         before --jit  after --jit
            mjit_comp(1)      44.006M      70.417M i/s -     40.000M times in 0.908967s 0.568042s
          mjit_uminus(1)      44.333M      68.422M i/s -     40.000M times in 0.902255s 0.584603s

    Comparison:
                         mjit_comp(1)
             after --jit:  70417331.4 i/s
            before --jit:  44005980.4 i/s - 1.60x  slower

                       mjit_uminus(1)
             after --jit:  68422468.8 i/s
            before --jit:  44333371.0 i/s - 1.54x  slower
    ```

commit daec109f423e54094800e083fc8a8ca5cbceb866
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-23 11:29:00 +0900

    [ruby/psych] Optimize cache with `compare_by_identity`

    Using `compare_by_identity` gives a 4x performance boost on cache hits.
    Benchmark in https://github.com/JuanitoFatas/fast-ruby/issues/189

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3953

commit c5a445d577b786e31c420b5857ad05b954b420ec
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-21 11:42:25 +0900

    [ruby/psych] Make Ractor-ready.

    Config is Ractor-local.

    Benchmarking reveals that using `Ractor.local_storage` for storing cache
    is similar to accessing a constant (~15% slower).

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3953

commit 3ee0ad919034fbc098939979c872d041a82c4334
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-22 10:01:54 +0900

    [ruby/psych] Don't use instance variables directly for config

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3953

commit d1963adae8373cac771f3d62cd8d92ab11deff9e
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-21 11:41:02 +0900

    [ruby/psych] Avoid methods depending on bindings

    Improves Ractor-readiness.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3953

commit 0eb94dae4aec58de06051cf89d555994838452f2
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-21 11:39:56 +0900

    [ruby/psych] Freeze constants.

    Improves Ractor-readiness.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3953

commit 0dd4896175f95c4c2a26d91a97b9fcb9a74cc0c6
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-23 14:40:58 +0900

    need to clear blocking cnt at fork (child process)

commit 5cf25c55a69264138179f7c955d149a154b50458
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-23 14:03:54 +0900

    Update version for Ractor-safe extensions

commit 61bd28b836190bbc8ce110e780da4c4aad9f485b
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-23 13:15:49 +0900

    [ruby/date] Workaround for non-ruby repository like ruby/date, flori/json

    https://github.com/ruby/date/commit/1ff7fa2d80

commit 8a1e12499b83870f9f102f0f0ea512f0355aac67
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-22 22:10:11 +0900

    Ensure non-literal expressions shareable if `leteral`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3950

commit c0a2d95cf318cf9b9ffe23f0a4b8720f69775448
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-22 08:26:42 +0900

    Update rb_ractor_ensure_shareable

    * Fixed use of rb_ractor_shareable_p
    * Raise Ractor::IsolationError

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3950

commit b2aa21b868419c2d87e2812b6b3584a8a1479c23
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-21 15:15:35 +0900

    Split the test

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3950

commit d1c7db9d003fe2f989e1cd2f55698a900291b48a
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-21 15:08:22 +0900

    Added assertions

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3950

commit 0c450b86476322ea4c407d0de4d7d1c5d8523126
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-21 15:11:50 +0900

    `begin ... end` is not a literal

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3950

commit e70206f5701fca5cce38dbfac8ffaa0d9a5c61a3
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-21 15:04:06 +0900

    Added dedicated helper methods

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3950

commit 7a094146e6ef38453a7e475450d90a9c83ea2277
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-19 20:42:58 +0900

    Changed shareable literal semantics [Feature #17397]

    When `literal`, check if the literal about to be assigned to a
    constant is ractor-shareable, otherwise raise `Ractor::Error` at
    runtime instead of `SyntaxError`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3950

commit f14aaa2b1282d6dea9fad3d050e65828f1e269e1
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-22 16:09:52 +0900

    Guard < Ruby 3.0 for the repositories of default gems.

commit 7e44ade5658bc6ae16e9838c64ff9e90d4fd805e
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-23 13:34:11 +0900

    ruby_single_main_ractor should be clear before warn

    rb_warn can produce T_HASH object and it should not use
    transient heap.

commit 02233ed024095d67683330b2ee9df08d943a5cd0
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-23 12:18:41 +0900

    Adapt tool/search-cgvars.rb for MacOS

commit 3df3b47187d7a137d4eb5a7887e9c8fa22a121c6
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-23 12:16:18 +0900

    Add tool/search-cgvars.rb, thanks @ko1

commit 082114da0552484d2695f685d781418fa51c7ef8
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2020-12-23 11:13:50 +0900

    [DOC] Add doc to sharing_detection= [ci skip]

    Before:
    ```
    $ ri sharing_detection=
    = .sharing_detection=
    (from ruby core)
    === Implementation from PP
    ------------------------------------------------------------------------
      sharing_detection=(b)
    ------------------------------------------------------------------------
    Returns the sharing detection flag as a boolean value. It is false by
    default.
    ```

    After:
    ```
    $ ri sharing_detection=
    = .sharing_detection=

    (from ruby core)
    === Implementation from PP
    ------------------------------------------------------------------------
      sharing_detection=(b)

    ------------------------------------------------------------------------

    Sets the sharing detection flag to b.
    ```

commit 339227363ce0cf967fa17efa4489d823932ddabd
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-23 08:45:19 +0900

    Merge RubyGems 3.2.3 and Bundler 2.2.3

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3982

commit 733ed1e18498f97250b788f169c37b170e0cf2b6
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-22 22:41:54 +0900

    ripper: fix bad label parameter handling [Bug #17425]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3977

commit cd63f0358ffb43890d20bb5612c5d82be19fae62
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-22 13:31:11 +0900

    [ruby/etc] Make Ractor safe

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3954

commit 3286380ebcc239b3fe1044884780162f1ee079fe
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-22 14:02:45 +0900

    [ruby/etc] Refactor locks using mutex API

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3954

commit 9636d14f6f4a1dc21ca61c280b26ec8fb3935168
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-23 00:51:26 +0900

    [memory_view] Acquire VM lock while running exported_object_registry_free

    exported_object_registry is freed at exit, so this change is just in case.

commit 01ab29cc285ec92c07cd67db6f8616690bd217f8
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-23 00:43:26 +0900

    [memory_view] Make some rb_memroy_view_t members const

commit db0385d6576bb9d2486e799c935e6b1fa1e7dfcc
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-23 00:43:18 +0900

    [memory_view] Remove needless use of StringValueCStr

commit b3ea828c8ef92f2fab4646f72144f7c468339a81
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-23 00:40:54 +0900

    [memory_view] Add mdview_release_view for test

commit 74652e640a3ef50eb5442eb98438e3d634a4faf7
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-23 00:33:24 +0900

    [memory_view][fiddle] Rename len to byte_size in rb_memory_view_t

commit 05014dcb887681d986105653ab527da2c4ff7774
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-22 17:33:14 +0900

    [memory_view][fiddle] Use bool for boolean return value

commit 74a3569b597f28780958dc3001b41120b54a8a48
  Author: Marcus Stollsteimer <sto.mar@web.de>
  Date:   2020-12-23 07:20:14 +0900

    NEWS: fix typos and grammar

commit 841d22ea479f37ab03d3f6c575997a2dd1b6d0a8
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-23 02:18:32 +0900

    [ruby/reline] [ruby/irb] Handle multiple newlines in a token correctly

    Co-authored-by: manga_osyo <manga.osyo@gmail.com>
    Co-authored-by: ima1zumi <mariimaizumi5@gmail.com>

    https://github.com/ruby/irb/commit/c59a9be82f

    https://github.com/ruby/reline/commit/a7922da16b

commit be5faa2519f1ab70eafd58caccbc3a8cba2718dc
  Author: Takeru Naito <takeru.naito@gmail.com>
  Date:   2020-12-22 12:58:12 +0900

    [ruby/irb] Make it possible to use measure even if it is installed as gem

    Include the file that implements this command in the irb gem.

    Co-Authored-By: scivola <scivola@users.noreply.github.com>

    https://github.com/ruby/irb/commit/d8dfea5b57

commit 32849dc1bbc3296aa13f86a35468ce16f8c32aab
  Author: Sutou Kouhei <kou@clear-code.com>
  Date:   2020-12-22 14:56:47 +0900

    fiddle: Update to 1.0.5

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3970

commit 228fa3ac6ec25eba5139674d04a74f07a34f2874
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-22 17:27:18 +0900

    NEWS: Mention deprecation warnings not being shown by default

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3974

commit fd745cc92c5e4dfa226cbdbbeb118f6b780666e1
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-22 16:52:05 +0900

    NEWS: group keyword arguments related items together

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3974

commit 5a6d27fe220548eb4ab5232d7f7331b42a66a17f
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-22 16:50:39 +0900

    NEWS: combine $SAFE and $KCODE, move lower

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3974

commit 1bd7427f29bb0e69e6e03d6d66aac6c9a6f7a300
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-22 16:49:27 +0900

    NEWS: move error handling at end of section

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3974

commit f1591b385890fe5e650bf8d5fa75e05a7c01ecea
  Author: Delton Ding <dsh0416@gmail.com>
  Date:   2020-12-22 16:01:53 +0900

    Add verbose nil in testing

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3971

commit c6d7e02b90f96d9bcd04edd48b7374f31c510b2a
  Author: Delton Ding <dsh0416@gmail.com>
  Date:   2020-12-22 15:30:59 +0900

    Enable `Fiber.current` and `Fiber#alive?` call inside ractor

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3971

commit 487355873ad0de9ab70611d63d97f3fbbfebe79d
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-23 02:37:59 +0900

    * 2020-12-23 [ci skip]

commit b222a1a49473490ef8903b76868de86cd0a2164e
  Author: Kazuki Tsujimoto <kazuki@callcc.net>
  Date:   2020-12-23 02:32:30 +0900

    Fix a message in example code

    Thanks to @zverok for the report.

commit 31b17a14abf9686a0a9b6777c6b47285f510b66a
  Author: Kazuki Tsujimoto <kazuki@callcc.net>
  Date:   2020-12-23 02:31:02 +0900

    Make NoMatchingPatternError a subclass of StandardError

commit 53510d1e8a827596dba926c689406edafa399ada
  Author: ima1zumi <mariimaizumi5@gmail.com>
  Date:   2020-12-22 13:59:14 +0900

    [ruby/reline] [ruby/reline] Remove unused `attr_writer`

    https://github.com/ruby/reline/commit/ecdc1b7116

    https://github.com/ruby/reline/commit/a7922da16b

commit 299f5708a2274d069c624073ca3958f8625faf35
  Author: ima1zumi <mariimaizumi5@gmail.com>
  Date:   2020-12-22 00:59:48 +0900

    [ruby/reline] Fixed an exception occurred when ambiguous width character was passed to `#calculate_width` [Bug #17405]

    https://github.com/ruby/reline/commit/f79b4c857f

commit b52bc4a9c29e80e10b7e64dbebd97117916d3982
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-22 04:38:01 +0900

    [ruby/reline] Support isearch-terminators

    https://github.com/ruby/reline/commit/a7922da16b

commit 294552ca6c38b90a2be257727ce5df69b93a4de7
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-21 23:02:46 +0900

    [ruby/reline] Render refreshed prompt just after i-search finished

    https://github.com/ruby/reline/commit/0d3188fe34

commit 0b14abe8e7610e81e6bac7a4696cdcc24ca164c0
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-22 05:08:12 +0900

    [ruby/irb] Suppress "shadowing outer" warning

    https://github.com/ruby/irb/commit/27b149c599

commit fbcdcbff0de551321eee486bfbff9bd9288331d3
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-22 05:01:35 +0900

    [ruby/irb] Version 1.2.9

    https://github.com/ruby/irb/commit/9668e5fe6b

commit 4131cd05be4c00e2d6740d1619711e574cd731af
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-22 04:56:03 +0900

    [ruby/irb] Support arg for measure command

    https://github.com/ruby/irb/commit/b43f35d8f3

commit 47b26795d06ea13d646edddd51470d9a6cd377b4
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-22 04:49:02 +0900

    [ruby/irb] Change variables handling for compatibility

    https://github.com/ruby/irb/commit/26fd1a75cf

commit cae8bbfe6271a15cf212a83a9c3ac3fedcdc7718
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-22 17:07:23 +0900

    pp is ractor-ready.

    `@sharing_detection` is only one obstruction to support pp on
    non-main ractors, so make it ractor-local.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3973

commit 034c19ce288b951cfaf3bbd996ce19e14fdeb502
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-22 21:51:15 +0900

    Merge json-2.5.1

commit 9b9cbbbc17bb5840581c7da37fd0feb0a7d4c1f3
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-22 21:43:30 +0900

    Update library versions of the default gems.

      They are followed up with
      https://github.com/ruby/ruby/commit/8fb02b7a97317090e3946e6f2d4a7d034f9699f1

commit 96b881679390271eb2234060ea7eed77a997d707
  Author: Akinori MUSHA <knu@idaemons.org>
  Date:   2020-12-22 21:41:44 +0900

    Import set 1.0.1

    - Eliminate warnings
    - Convert rdoc to markdown

commit f08cbdbf7d9b31ab570a235e4503ded2bc79d005
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-22 20:55:35 +0900

    Move the library to extensions for some of default gems

commit 93a56a5e98875ed619fe5c29f401a8a43632dbed
  Author: Samuel Williams <samuel.williams@oriontransfer.co.nz>
  Date:   2020-12-22 06:55:29 +0900

    Update fiber scheduler documentation.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3965

commit edb76e8765b7f165237c8ca6155cff1cc0f18cf9
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-22 18:18:32 +0900

    Prepare to release json-2.5.0

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3975

commit f2f00e24fa14b8114d6c3bea11170b2b3e309719
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-20 12:29:16 +0900

    [ruby/date] Make Ractor-compatible

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3946

commit ee102de6d7ec2454dc5da223483737478eb7bcc7
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-20 12:28:20 +0900

    [ruby/date] Deep-freeze internal constants.

    Probably not strictly necessary, but good principle anyways.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3946

commit 7fbad9224188905a6d96dee5aad5b1e1564e4461
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2020-12-22 16:15:35 +0900

    rb_cData: no longer exists

    Commit 8918a9cf6c65409ae1ffcdea324a1b97c6e5bb70 introduced macro
    `#define rb_cData rb_cData()`.  This deleting `VALUE rb_cData;`
    declaration was then macro-expanded into `VALUE rb_cData();`.  This
    worked by accident because the expanded expression happen to be a K&R
    style function declaration.

    This is rather complicated and I guess unintended.  Just delete the line
    to keep things simple straight forward.

commit 7898bc92258aff74d7600abe5dbdedff9b543cf0
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2020-12-22 15:25:03 +0900

    rb_cCont: no longer exists

    Deleted well over a decade ago in commit 977d66ec993b0f1892fb3e4cd8ac.

commit 15b81edd86a760331cb551b39882fab6fb9f4e37
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-22 15:05:58 +0900

    MJIT is enabled whenever an MJIT header is used

    ```
    $ benchmark-driver -v --rbenv 'before --jit;after --jit' --repeat-count=4 --alternate --output=all benchmark.yml
    before --jit: ruby 3.0.0dev (2020-12-22T05:16:39Z master 692af8e8f8) +JIT [x86_64-linux]
    after --jit: ruby 3.0.0dev (2020-12-22T06:05:59Z master d2ca23fdbc) +JIT [x86_64-linux]
    last_commit=MJIT is enabled whenever an MJIT header is used
    Calculating -------------------------------------
                                 before --jit           after --jit
    Optcarrot 180 frames    86.61115328062763     91.49245232931852 fps
                            90.18653732453176     92.31139517827663
                            91.29817884736318     93.84437713805814
                            92.76118222412521     93.91929147901106
    ```

commit 95acd3c0302b571a4d77debc05bf38cf0bcce929
  Author: Yuki Nishijima <yk.nishijima@gmail.com>
  Date:   2020-12-22 14:42:32 +0900

    Sync did_you_mean

commit 692af8e8f8b5f9965450d8f2577f435feaa6f80d
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-22 14:16:19 +0900

    Prefer stdbool in vm_exec

    Make the code a bit modern and consistent with some other places.

commit 03f2b093201762031d5be64d0cce85da26c1d3b3
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-22 14:05:36 +0900

    NEWS.md: fix the format

commit fee2913d0af894492542cc0ed5e45dbf00e8f8df
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2020-07-28 11:03:00 +0900

    Struct::Tms: delete

    Has been deprecated since 44c53ee473d3b3973cb5c3ce03fbf4f280fd75ff.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3969

commit fa356a798aefc20725467d4fad02df8325d63e71
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2020-08-13 11:44:15 +0900

    Enumerator.new: raise unless block given

    Has been deprecated since c73b6bd7ebd01133538c645566944132dbde4d13.
    [Feature #17116] [ruby-dev:50945]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3968

commit 7204b81bcb13f84ca3cc34384d205565fd5ad381
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-22 12:59:47 +0900

    fix to use rb_ractor_id()

    Catch up recent changes on USE_RUBY_DEBUG_LOG=1.

commit 2e1cdf36ba950fef3f7d6fc215835ce3027699f4
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-22 12:46:15 +0900

    add a NEWS entry about ractor C API

commit be9b5553a3ae3a90c73d4c11786cb1a813e915f6
  Author: Akinori MUSHA <knu@idaemons.org>
  Date:   2020-12-22 12:26:45 +0900

    Add entries for set 1.0.0

commit 3fa4bd82928983cf5f6711c130711502397e05e2
  Author: Akinori MUSHA <knu@idaemons.org>
  Date:   2020-12-22 12:20:21 +0900

    Import set 1.0.0

    - SortedSet has been removed for dependency and performance reasons.
    - Set#join is added as a shorthand for `.to_a.join`.
    - Set#<=> is added.

    https://github.com/ruby/set/blob/v1.0.0/CHANGELOG.md

commit 63b872c409ec441718f55c60362a441cf108cfc0
  Author: Akinori MUSHA <knu@idaemons.org>
  Date:   2020-12-22 12:17:47 +0900

    Prepare for importing the set gem

commit d0050edb84e9c3ba99946e08325e168deb741e28
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-22 11:07:13 +0900

    Update Fiber#backtrace doc [See bug #17408]

commit 843fd1e8cfccdf1efcbb157315e267e4f380e030
  Author: zverok <zverok.offline@gmail.com>
  Date:   2020-12-22 06:42:01 +0900

    Document Fiber#backtrace and #backtrace_locations

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3966

commit 816bbfdc87d4a5f600f28cf4b0eaa5161af80645
  Author: zverok <zverok.offline@gmail.com>
  Date:   2020-12-22 06:15:47 +0900

    Document Proc#==

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3966

commit 861dbd950684d311e4f4bfed0e14885ed8a90b53
  Author: zverok <zverok.offline@gmail.com>
  Date:   2020-12-21 05:06:26 +0900

    Random instance methods

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3966

commit 4728c0d900f40036757d869fd5f20673c563bac7
  Author: zverok <zverok.offline@gmail.com>
  Date:   2020-12-17 07:49:52 +0900

    Add Symbol#name and freezing explanation to #to_s

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3966

commit 4a18cc7f604c259415d933acd9fd00234733cab6
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-22 09:04:54 +0900

    NEWS.md: mention the behavior change of Binding#eval

    [Bug #17419]

commit 91773ddd261abfc13f8a36d82b9c27a507c7cd81
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-22 08:56:46 +0900

    Remove debugging code

commit 831f7850689c51f8d7b17eb76c7f20b0eda16778
  Author: nagachika <nagachika@ruby-lang.org>
  Date:   2020-12-22 08:08:27 +0900

    [DOC] Fix typo in Ractor.make_shareable documentation.

commit a29b9e5efe286e8ad1b0d67c38f03cbb70951076
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-22 07:52:06 +0900

    Remvoed no longer needed version guards

commit c34c6a89cb7524050dc6f174da53a8159a7bbd64
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-22 01:05:52 +0900

    fix ractor's doc. [ci skip]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3960

commit 520dcbd6009b07458d67309ae33a602d77062975
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-22 05:27:47 +0900

    reset cache before iterating

    cee02d754d76563635c1db90d2ab6c01f8492470 resets pCMC and `me`
    will be a invalidated and continuing the invalidated `me`,
    it will break the data structure. This patch tris to clear
    all methods of specified class before manipulating the `me`s.
    [Bug #17417]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3964

commit d0e4ccbefcdd6032d0ae70bc54c9a4fb55d92576
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-22 02:22:51 +0900

    add Ractor.main

    It returns main Ractor, like Thread.main.
    [Feature #17418]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3963

commit 35471a948739ca13b85fe900871e081d553f68e6
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-22 01:55:15 +0900

    add Ractor#[]/#[]= for ractor local storage

    This API is similar to plain old Thread#[]/Fiber#[] interface
    with symbol key.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3962

commit 8f2031a06725d32f59e5ecd88ede3f96e8c5e9b1
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-22 03:30:40 +0900

    Ractor#to_s as #inspect

commit 8918a9cf6c65409ae1ffcdea324a1b97c6e5bb70
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-22 01:00:43 +0900

    Removed rb_cData entity

    * Use the wrapper of rb_cObject instead of data access
    * Replaced rest of extensions
    * Updated the version guard for Data
    * Added the version guard of rb_cData

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3961

commit c30f03d32833f38fedf41ecb08f1ade9c6657fef
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2020-07-27 16:15:28 +0900

    Data: delete

    Has been deprecated since 684bdf6171b76f5bc5e4f05926a5ab01ec2b4fd5.

    Matz says in [ruby-core:83954] that Data should be an alias of Object.
    Because rb_cData has not been deprecated, let us deprecate the constant
    to make it a C-level synonym of rb_cObject.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3961

commit 5c0abe2d94c545275079a862dc36bb163953010a
  Author: Kazuki Tsujimoto <kazuki@callcc.net>
  Date:   2020-12-22 02:08:32 +0900

    Update documentation for pattern matching

commit 208f7d7c801c83facab4c24a36ed5e5b49b75377
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-22 00:03:21 +0900

    * 2020-12-22 [ci skip]

commit 02d9524cdaca1754718bf1d591408d377e6b383a
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-20 01:44:41 +0900

    separate rb_ractor_pub from rb_ractor_t

    separate some fields from rb_ractor_t to rb_ractor_pub and put it
    at the beginning of rb_ractor_t and declare it in vm_core.h so
    vm_core.h can access rb_ractor_pub fields.

    Now rb_ec_ractor_hooks() is a complete inline function and no
    MJIT related issue.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3943

commit a2950369bd8a5866092f6badf59b0811653a6092
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-19 06:38:58 +0900

    TracePoint.new(&block) should be ractor-local

    TracePoint should be ractor-local because the Proc can violate the
    Ractor-safe.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3943

commit c7a5cc2c3098ea74343a0dbab36b3a65bc7a4144
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-21 21:46:10 +0900

    Replaced magic numbers tr table

commit 84eebb3c9e92d33055393d32a276e11f3e1afd3f
  Author: Naohisa Goto <ngotogenome@gmail.com>
  Date:   2020-12-21 23:08:35 +0900

    On Solaris, _XOPEN_SOURCE should be undefined for C++ sources.

commit 91e2f08a6a296acb7debb184ffe1229c5c25bb0c
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-21 23:28:05 +0900

    export rb_eRactorIsolationError for MJIT

    https://ci.appveyor.com/project/ruby/ruby/builds/36942168/job/7ugrpk0pndoly9wp
    ```
    _ruby_mjit_p11920u0.c
    C:\Users\appveyor\AppData\Local\Temp\1/_ruby_mjit_p11920u0.c(14) : warning C4005: 'GET_SELF' : macro redefinition
            c:\projects\ruby\vm_insnhelper.h(111) : see previous definition of 'GET_SELF'
       Creating library C:\Users\appveyor\AppData\Local\Temp\1/_ruby_mjit_p11920u0.lib and object C:\Users\appveyor\AppData\Local\Temp\1/_ruby_mjit_p11920u0.exp
    _ruby_mjit_p11920u0.obj : error LNK2001: unresolved external symbol rb_eRactorIsolationError
    C:\Users\appveyor\AppData\Local\Temp\1/_ruby_mjit_p11920u0.so : fatal error LNK1120: 1 unresolved externals
    ```

commit 0b6a80c0beec5afb3a98535c5bc851bb77b3a5e2
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-21 22:40:38 +0900

    [json] Avoid method redefinition

commit dca6752fecc6733575145185764d7b6a218cee96
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-21 18:06:28 +0900

    Introduce Ractor::IsolationError

    Ractor has several restrictions to keep each ractor being isolated
    and some operation such as `CONST="foo"` in non-main ractor raises
    an exception. This kind of operation raises an error but there is
    confusion (some code raises RuntimeError and some code raises
    NameError).

    To make clear we introduce Ractor::IsolationError which is raised
    when the isolation between ractors is violated.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3957

commit 8c0c61728fd08bd7c3c29612de8b3486d75339dc
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-21 22:16:02 +0900

    NEWS: JSON is Ractor compatible [ci skip]

commit 14d7d1df25bbefadfc385042d541b4afc31e4c1b
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-21 15:57:42 +0900

    [json] Make json Ractor safe

commit 4c2e7f26bda8df087a66e546744de0d0d467ea7c
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-21 15:50:04 +0900

    [json] JSON_parse_float: Fix how to convert number

    Stop BigDecimal-specific optimization.  Instead, it tries the conversion
    methods in the following order:

    1. `try_convert`,
    2. `new`, and
    3. class-named function, e.g. `Foo::Bar.Baz` function for `Foo::Bar::Baz` class

    If all the above candidates are unavailable, it fallbacks to Float.

commit 596da98b3ff28ff48b10aed0bbe75287862eacbb
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-21 15:45:50 +0900

    [json] Make JSON.create_id thread-safe

commit 98cc15ed1e9193e17fad6b87cccf8f8b5ade7801
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-20 12:17:32 +0900

    [json] Stop using prototype objects

commit d84dd66da065cc40da69df5e042205209411c086
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-21 18:17:45 +0900

    Fixed a typo in an error class name

commit b9d00f42e63593e8c52dbe86cd4ebb7a120f768e
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-21 18:09:45 +0900

    Enable escape sequence on Windows10 console via pager too

commit d8469507b943376b2b1b9be2692ff2fe055496a3
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-16 17:53:37 +0900

    [ruby/digest] Remove .gitignore and .travis.yml from gemspec

    https://github.com/ruby/digest/commit/7b57b73f46

commit 09f939d3a0140478f2e547f45b4becd05247d360
  Author: U.Nakamura <usa@ruby-lang.org>
  Date:   2020-12-21 17:29:09 +0900

    Enable escape sequence on Windows10 console

            * win32/win32.c (init_stdhandle): enable escape sequence on
              Windows10 console to show `ruby --help` colors correctly.

commit 95ce5c0ee9baa692d419dd45f0e00cbd5cee4d4c
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-21 13:27:52 +0900

    [ruby/rdoc] Bump version to 6.3.0

    https://github.com/ruby/rdoc/commit/3d3616cb94

commit 391343e82867919bb13be4660fd49e05ebd5983c
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-21 13:35:37 +0900

    [ruby/rdoc] Guard for WEBrick

    https://github.com/ruby/rdoc/commit/b1e7129e05

commit f26f905b28c5531c78445ac15d74ca1265eff5c5
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-21 16:17:28 +0900

    Mark an ISeq being JIT-ed

    This is to avoid SEGV on a CC reference in a normal compilation
    https://github.com/ruby/ruby/runs/1586578023

commit 1fdc97f1b76b7532d011b20d52f843a2bb0d1a2f
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-21 15:41:52 +0900

    Mark active_units

    to avoid SEGV on mjit_recompile and compact_all_jit_code.

    For some reason, ISeqs on stack are sometimes GC-ed (why?) and therefore
    it may run mjit_recompile on a GC-ed ISeq, which I expected d07183ec85d
    to fix but apparently it may refer to random things if already GC-ed.
    Marking active_units would workaround the situation.
    http://ci.rvm.jp/results/trunk-mjit-wait@phosphorus-docker/3292740

    Also, while compact_all_jit_code was executed, we saw some SEGVs where
    CCs seemed to be already GC-ed, meaning their owner ISeq was not marked
    properly. Even if units are still in active_units, it's not guaranteed
    that their ISeqs are in use. So in this case we need to mark active_units
    for a legitimate reason.
    http://ci.rvm.jp/results/trunk-mjit-wait@phosphorus-docker/3293277
    http://ci.rvm.jp/results/trunk-mjit-wait@phosphorus-docker/3293090

commit a574df14e45b8b5a1de7bfe949e08b61ae51b0bd
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-21 14:54:27 +0900

    Stop marking unit_queue

    The original motivation of this marking was https://github.com/k0kubun/yarv-mjit/issues/20.
    As wanabe said, there are multiple options to mitigate the issue, and
    Eric Wong introduced another fix at 143776f6fe by checking unit->iseq
    inside the lock.

    Therefore this particular condition has been covered in two ways, and
    the script given by wanabe no longer crashes without mjit_mark().

commit 74a78778362a7ad9aa246f2cb1a30174a6007365
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2020-12-21 13:25:03 +0900

    [DOC] Remove about FrozenError from Ractor::MovedObject [ci skip]

    Because unfreeze Ractor::MovedObject at
    https://github.com/ruby/ruby/commit/76e88480371469400346fca609efe67096813915

commit 1ecac8e4d031c244df711d573fa73ce339ffa2f5
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-21 11:51:11 +0900

    Add `require_relative` option to `assert_ractor`

commit eee93bc9330cb069abb679a0a0d48a49b10f6a4e
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-21 11:33:22 +0900

    eval_error.c: fix off-by-one error for --backtrace-limit

    https://bugs.ruby-lang.org/issues/17413

commit ac78d90d5e90d414fed2c5ea61faaaa4c57e1815
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-21 11:22:58 +0900

    Bump bundled rake version to 13.0.3

commit fe60480947969d32797c265085cceb90b771702a
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2020-12-14 16:54:12 +0900

    include/ruby/internal/xmalloc.h: document rb_eNoMemError

    It was my bad, the exception that actually raises is rb_eNoMemError.
    [ci skip]

commit 11656d15e2c5d5779a637eaf5f388a5c18bef629
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2020-12-14 15:17:59 +0900

    include/ruby/internal/xmalloc.h: doxygen tag

    `@exception` is an alias of `@throw`.  It might suite Ruby's document
    because ruby uses `raise` terminology instead of `throw`. [ci skip]

commit 63849a1cd98c7ae3a7d6af3f69814f01dfae25ea
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2020-12-21 10:54:24 +0900

    Fix misspellings [ci skip]

commit 5253b9579a129f66a768dae24bd50a95bab02841
  Author: Victor Shepelev <zverok.offline@gmail.com>
  Date:   2020-12-21 09:32:30 +0900

    Document usage of ArithmeticSequence in Array#slice, and add to NEWS (#3952)

  Notes:
    Merged-By: mrkn <mrkn@ruby-lang.org>

commit 6be61ab264c98c96e26b5d3398cf80b49197ba29
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-21 02:04:38 +0900

    should use owned_p instead of locked_p

    It should raise an error if the same thread tris to call
    receive/receive_if.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3949

commit 435b619a3d5a2d5754a3f739c50f64d1ad520ffc
  Author: Ivan Denysov <johnny.denisov@gmail.com>
  Date:   2020-12-21 02:24:30 +0900

    fix phrasing in comment

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3951

commit 7600f69a8e7955fc2ba3ef83d0c9fa019114216e
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-21 02:20:57 +0900

    rename to rb_ractor_make_shareable_copy()

    from rb_ractor_make_copy_shareable().

commit 9c73c756244fa27ffa99d81dcc73a4ad14198002
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-21 01:16:26 +0900

    Use Integer instead of Fixnum/Bignum

commit fb8f011422c645ebe29e94c3fb2079af73d1d35f
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-21 00:40:56 +0900

    Fixed indefinite articles before "Integer" [ci skip]

commit ad534a677a6df7437c934440b35affa88ce3648a
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-21 00:20:06 +0900

    Fixnum as a Symbol was an old feature until 1.6

commit a365ae841b9fe06c1ed9efad3c457cd2d1260524
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-21 01:15:45 +0900

    * 2020-12-21 [ci skip]

commit 730f314171e67d981887c061d5dabf927ff5efd5
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-21 01:13:39 +0900

    fix Ractor.make_shareable() with Class/Module

    To check shareable-ness, rb_ractor_shareable_p() is needed
    for Class/Module objects isntead of checking flags.

commit 8680ae9cbd6e7e7e08f6d21fa8d35abdc82342da
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-20 19:36:24 +0900

    irb: Removed unused variables

commit 4b6e3f7b82e03d6eb6562631365d35abaee35fb3
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-20 19:35:59 +0900

    irb: Define extension command on the given object

commit 37987d99940f10bc6fec9b4825d7ce72df391d42
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-20 02:20:27 +0900

    win32: Deprecate file CP version functions

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3948

commit 95862ae44046cfc66c474ce534c204d276ea704d
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-20 15:29:21 +0900

    win32: Added rb_w32_ureaddir only for UTF-8 [Feature #12654]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3948

commit 5b98b2ce39ed979aec614365a2dc3e1c30052bca
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-20 02:16:31 +0900

    win32: Use UTF-8 as filesystem encoding [Feature #12654]

    Co-Authored-By: Dāvis Mosāns <davispuh@gmail.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3948

commit feea436febb50eb4265bd985a550e384c606122c
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-20 18:25:39 +0900

    irb: Define extension command only on the given object

    Not to interfer in class variables.

commit 0fad9a9e30d3dd362d9567284284206e1a476920
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-20 17:10:11 +0900

    Set non-verbose mode as well as tty mode

commit 59b84fbf2ef38f1f7c93c526bdb64e382f3dd635
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-20 17:07:24 +0900

    Set :DEFAULT to PROMPT_MODE for CI

commit 216a087e9351132b83110e0f7aad81d796371bdd
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-20 16:48:47 +0900

    Suppress errors related to using variables that are not directly related to testing

commit 24fcbc92b44d44bccf28d9375201162e627bb4ec
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-20 16:16:11 +0900

    [ruby/irb] Version 1.2.8

    https://github.com/ruby/irb/commit/bcd96834c7

commit a7cacd33ccef56b6377d511e0bf3f8b7c1f760be
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-20 16:15:58 +0900

    [ruby/reline] Version 0.1.10

    https://github.com/ruby/reline/commit/723c6e191a

commit 9f08e3c703795e81d333d568e7e44743022468f1
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-08-15 06:36:24 +0900

    [ruby/irb] Add measure command

    You can use "measure" command to check performance in IRB like below:

      irb(main):001:0> 3
      => 3
      irb(main):002:0> measure
      TIME is added.
      => nil
      irb(main):003:0> 3
      processing time: 0.000058s
      => 3
      irb(main):004:0> measure :off
      => nil
      irb(main):005:0> 3
      => 3

    You can set "measure :on" by "IRB.conf[:MEASURE] = true" in .irbrc, and, also,
    set custom performance check method:

      IRB.conf[:MEASURE_PROC][:CUSTOM] = proc { |context, code, line_no, &block|
        time = Time.now
        result = block.()
        now = Time.now
        puts 'custom processing time: %fs' % (Time.now - time) if IRB.conf[:MEASURE]
        result
      }

    https://github.com/ruby/irb/commit/3899eaf2e2

commit 8b6aaeaddf2d13833c0540490a84741035a3a808
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-20 12:20:00 +0900

    [ruby/irb] Handle rest of tokens correctly if no newline at last

    https://github.com/ruby/irb/commit/f3c8edad2a

commit 67ee1cbdd5def5b8e9db987a4a9367ab1d22fcfe
  Author: Kazuki Tsujimoto <kazuki@callcc.net>
  Date:   2020-12-20 16:00:13 +0900

    Remove unnecessary files from .document

    * ruby:ext/rbconfig/exts.mk
    * ruby:ext/rbconfig/sizeof/Makefile
    * ruby:ext/rbconfig/sizeof/depend
    * ruby:ext/rbconfig/sizeof/mkmf.log
    * ruby:ext/win32/depend
    * ruby:ext/win32/exts.mk
    * ruby:ext/win32/resolv/depend
    * ruby:lib/racc/pre-setup

commit b911509a08cee6c99ab8eec01516ebe84ba9029d
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-20 15:13:07 +0900

    Adjusted indents of closing braces [ci skip]

commit 7d0144e055fdbd7110cf84275b9e145550b77fd3
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-20 14:35:59 +0900

    Check mjit_call_p only when interrupted

    for leaf_without_check_ints insns.

    $ benchmark-driver -v --rbenv 'before --jit;after --jit' --repeat-count=12 --alternate --output=all benchmark.yml
    before --jit: ruby 3.0.0dev (2020-12-20T05:02:18Z master 02b3555874) +JIT [x86_64-linux]
    after --jit: ruby 3.0.0dev (2020-12-20T05:36:00Z master 3f58de4eab) +JIT [x86_64-linux]
    last_commit=Check mjit_call_p only when interrupted
    Calculating -------------------------------------
                                     before --jit           after --jit
    Optcarrot Lan_Master.nes    84.50647332260259     85.85057800433144 fps
                                91.17796644338372     92.09930605656054
                                91.29346683444497     93.01336611323687
                                91.50322318568884     93.07234029037433
                                91.66560903214686     93.22773241529644
                                91.82315142636172     93.37032901061119
                                92.15066379608260     93.83701526141679
                                92.37897097456643     93.86032792681507
                                92.53049815524908     93.91211970920320
                                92.78414507914283     94.09109196967890
                                92.90299756525958     94.40107239595325
                                93.70279428858790     95.01326369371263

commit ae1cc3fd4e4e926dc9d84723ae2696b9799cfe9d
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-20 14:28:55 +0900

    Made an internal callback function static

commit 02b3555874cecb93bdfff7c1ea6a80ca908785c9
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-20 14:02:18 +0900

    Install gdb on Actions

commit 85ec6cc38767320bc8767298c909f75e61b0d63b
  Author: Kazuki Tsujimoto <kazuki@callcc.net>
  Date:   2020-12-20 13:28:40 +0900

    Fix markups and indentation

commit d37be18af5a789003e46015c2a2a916923e7682a
  Author: Kazuki Tsujimoto <kazuki@callcc.net>
  Date:   2020-12-20 13:25:43 +0900

    Fix typos

commit 4902f96ee56d0391165b9ba769224c0d88d105fe
  Author: Kazuki Tsujimoto <kazuki@callcc.net>
  Date:   2020-12-20 13:22:53 +0900

    Update documentation for pattern matching

commit b1b6dbfdc3abaca44e971979328fd396b424c32a
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-20 12:37:27 +0900

    `assert_ractor` tweak. Thanks Nobu

commit f70b894b8829c064e39646c9b5f6d304d13bb16d
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-20 03:23:41 +0900

    sync RCLASS_CONST_TBL()

    RCLASS_CONST_TBL() is shared resource so we need to sync with
    other ractors.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3944

commit 648bbfcc65ad28841db2206513375dd88f064c52
  Author: Soutaro Matsumoto <matsumoto@soutaro.com>
  Date:   2020-12-20 10:25:27 +0900

    Update rbs 1.0.0.pre (#3941)

  Notes:
    Merged-By: soutaro <matsumoto@soutaro.com>

commit 6343a8112950b12df942f5098edc093bca96ef2d
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-20 02:19:06 +0900

    [ruby/ostruct] Add Ractor test

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3942

commit 67e062b523e1a1bdf597a500027c916c16cd07a1
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-20 02:17:47 +0900

    [ruby/matrix] Add Ractor test

    This reverts commit cacdf2681dcc7c431973f33a18979b10566ec2f9.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3942

commit 70f20234b297a7fc9940bace30101813aa9df052
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-20 02:54:07 +0900

    Add `assert_ractor` [Feature #17367]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3942

commit 7f8108eeff8ffa66c93efb07d4bead1baf7153a8
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-20 04:51:00 +0900

    fix indent

commit bcf4b236e424ce0e6055f4a9651b5369a830866a
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-20 04:22:13 +0900

    ext/racc/cparse is ractor-safe

commit 846c4b03b8e9ff788f355f1bcd12e75715288e95
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-20 04:21:54 +0900

    ext/monitor is ractor-safe

commit c1461c927b123468ba83713676dcda48e51c8ec1
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-20 04:09:40 +0900

    cgi/escape is ractor-safe

commit 362138004624f0d8664c16da4c0d5133ac213942
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-20 04:14:05 +0900

    NEWS.md: remove nonsense caveat

    3.0 will be released in a few days (hopefully), so remove a caution: "it
    may be reverted until 3.0 release."

commit ed4381d94132990067922bc4204c8abb99cde3e8
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-20 03:14:58 +0900

    BigDecimal#precs is deprecated

commit c01ad11f908c2a57c2348e83d109b08fdd89dc4e
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-20 03:13:33 +0900

    bigdecimal: initialize conditionally assigned variable

commit b2acae32742adf86a64ba5c0af55830bb3bddc0d
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-20 02:56:18 +0900

    Reduced ID caches

    NEW_GASGN and NEW_GVAR evaluate `id` argument twice.

commit a273171ca8848e85367628343ddd64ac6c0f70c1
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-20 03:08:24 +0900

    Tweak Ractor doc [doc] [ci skip]

commit 1f565ac6d98e902f51a0ea7b8b4aa85693deea6e
  Author: Victor Shepelev <zverok.offline@gmail.com>
  Date:   2020-12-20 03:04:40 +0900

    Add documentation for Ractor (#3895)

  Notes:
    Merged-By: marcandre <github@marc-andre.ca>

commit d44671c819e104d329e604fdf9bb59bbb426afb5
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-11-28 18:39:57 +0900

    Revived the getenv macro for dln_find.c

    This partially reverts commit "Windows: Improve readablity of
    getenv() encoding" 14453a256d58b11b06d432e2a4388d95aac298d6.

    The `getenv` macro defined here is to also substitute the function
    in dln_find.c, not only in this file.

commit 50f1e7eb23382ca1f62668d9067cce2fc09ee866
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-20 00:42:04 +0900

    NEWS: Add an entry of Pathname [ci skip]

commit 48bd5a3d577d48e4feab7e843dfac037335ff575
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-20 00:41:06 +0900

    * 2020-12-20 [ci skip]

commit de80b928910b7ca785725382cec53cb27f1d65ed
  Author: Kenta Murata <mrkn@users.noreply.github.com>
  Date:   2020-12-20 00:40:47 +0900

    [pathname] Make Pathname Ractor safe (#3940)

  Notes:
    Merged-By: mrkn <mrkn@ruby-lang.org>

commit d62414b48fbb944cc9e4442ad7d04d40a27fa4e9
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-19 22:15:48 +0900

    NEWS: Update BigDecimal version [ci skip]

commit 8355a3e17b6ea05ee60400ae41a1553eee900ed8
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-19 21:13:33 +0900

    [bigdecimal] Fix deprecation warning test

commit 8986f948e0a7da0e53647d1ce7ea8d626051b7e3
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-19 19:21:56 +0900

    [bigdecimal] Version 3.0.0

    https://github.com/ruby/bigdecimal/commit/e68f1eb33a

commit df3deb3baa0eabc66a47879be115ae3ffca4daba
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-19 17:06:14 +0900

    [bigdecimal] Add BigDecimal#n_significant_digits

    https://github.com/ruby/bigdecimal/commit/981dc48f95
    https://github.com/ruby/bigdecimal/commit/9ecf880ec04

commit 654f6fbf19c0ca2e01765a909b4d952b7f0f5baa
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-19 11:55:46 +0900

    [bigdecimal] Make BigDecimal#precs deprecated

    https://github.com/ruby/bigdecimal/commit/7e80e6e145
    https://github.com/ruby/bigdecimal/commit/0ed7846e8c

commit ff9e40811c67b1090966b655f7adc0684fc58abe
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-19 04:24:15 +0900

    [bigdecimal] Add BigDecimal#precision

    https://github.com/ruby/bigdecimal/commit/458eb66c49

commit 928a06723d1ede495b7c3b42f3ca48e370ccec77
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-19 02:45:47 +0900

    [bigdecimal] Make bigdecimal Ractor safe

    https://github.com/ruby/bigdecimal/commit/93fc392640
    https://github.com/ruby/bigdecimal/commit/a90d13c4d0

commit 97d4e72e0bc4b07442f5ce674a945df91d9fce3c
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-19 01:30:37 +0900

    [bigdecimal] Use DBLE_FIG

    https://github.com/ruby/bigdecimal/commit/12296dcb90

commit e1424c35012ccf1f3822c9046081b225aef4142e
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-18 23:46:26 +0900

    [bigdecimal] Fix the default precision of Float#to_d

    Fix https://github.com/ruby/bigdecimal/issues/70
    [Bug #13331]

    https://github.com/ruby/bigdecimal/commit/aa536cd4b5

commit 4735a5b9d2cbde69c501ee8d5bb570f4fac7e51d
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-19 21:19:16 +0900

    test/ruby/test_module.rb: Avoid "warning: method redefined"

commit 1ba8d63b49318e5682a22502c5f5b70e3298da8f
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-19 18:22:44 +0900

    Recommit 34f06062174882a98ebef998c50ad8d4f7fc0f2e

commit eb8ea336d33af7e1dec4c17964c671c33cf75ce1
  Author: Radosław Bułat <radek.bulat@gmail.com>
  Date:   2020-12-19 03:17:57 +0900

    Feature 17314: allow to pass array to public, protected and private methods

commit 8148f88b92a6b8d850b991afe74fb0d0f9c11887
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-19 18:04:47 +0900

    ALWAYS_INLINE implies inline

commit 0d3dc2ec807c313d0952d15ac4f30bc8586bba2f
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-18 04:43:11 +0900

    Make `Hash#except` always return a Hash

    [Feature #15822]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3929

commit 5611066e03fe73bdbb08cc46f79530c69975cf17
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-19 17:33:21 +0900

    Prefer RB_OBJ_FROZEN_RAW

    following the original implementation's change.
    RB_TYPE_P(obj, T_OBJECT) is already checked in these places.

    ```
    $ benchmark-driver -v --rbenv 'before --jit;after --jit' --repeat-count=12 --alternate --output=all benchmark.yml
    before --jit: ruby 3.0.0dev (2020-12-19T08:27:44Z master 52b1716c78) +JIT [x86_64-linux]
    after --jit: ruby 3.0.0dev (2020-12-19T08:27:44Z master 52b1716c78) +JIT [x86_64-linux]
    Calculating -------------------------------------
                                     before --jit           after --jit
    Optcarrot Lan_Master.nes    88.04551460097873     84.38303800957766 fps
                                88.25194345156318     85.31098251408059
                                88.34143982084871     86.60491582339496
                                88.63486879856976     88.23675694701865
                                88.85392212902701     88.23696283371444
                                89.05739427483194     88.97185459567562
                                89.08141031147311     90.16373192658857
                                89.11359420883423     90.61655686444394
                                89.80323392966130     90.77044959019291
                                90.58912189625207     90.88534596330966
                                90.59847996970350     91.34314801302897
                                90.61180456415137     93.11599164249547
    ```

commit e33eb09b76e9070fd49837e8b896319636501b38
  Author: Nobuhiro IMAI <nov@yo.rim.or.jp>
  Date:   2020-12-19 01:31:12 +0900

    ripper: fix `#tok` on some error events [Bug 17345]

    sorting alias target by event arity, and setup suitable `Elem` for error.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3936

commit 52b1716c78a7ad9daa317e3eb43f744744b9f736
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-19 17:27:42 +0900

    Fix vm_search_invokeblock

    call_ needs to be vm_invokeblock_i, and flags is also not empty.

commit 8ec8f37566902c0167f736d345bb5c8cca6016d3
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-19 16:30:09 +0900

    discourage inlining for vm_sendish()

    reversing 9213771817 only for JIT, because it made JIT slower.

    $ benchmark-driver -v --rbenv 'before;after;before --jit;after --jit' --repeat-count=36 --alternate --output=all benchmark.yml
    before: ruby 3.0.0dev (2020-12-19T07:38:17Z master a139318538) [x86_64-linux]
    after: ruby 3.0.0dev (2020-12-19T07:52:01Z master ce9faaeff5) [x86_64-linux]
    last_commit=discourage inlining for vm_sendish()
    before --jit: ruby 3.0.0dev (2020-12-19T07:38:17Z master a139318538) +JIT [x86_64-linux]
    after --jit: ruby 3.0.0dev (2020-12-19T07:52:01Z master ce9faaeff5) +JIT [x86_64-linux]
    last_commit=discourage inlining for vm_sendish()
    Calculating -------------------------------------
                                           before                 after          before --jit           after --jit
    Optcarrot Lan_Master.nes    42.83365858987760     42.68912456143848     76.50136803552716     65.74704713379785 fps
                                42.87724738609940     42.89045158177300     79.72624911659534     81.26221749201044
                                43.34963955708526     42.95431841174180     80.18085951039328     82.86458983313545
                                43.56786038452823     43.57563008888242     80.45933051716041     83.09150550702445
                                43.83219269706004     43.60748924115331     80.67164125046142     83.39458202043882
                                43.99035062888973     43.62050459554573     80.93204435712701     83.56303651352751
                                44.25176047881120     44.04822899344536     81.15051082548314     83.58166141398522
                                44.41978060794512     44.06521657912991     81.35651907376140     83.80036752456826
                                44.46864790591856     44.09325484326153     81.53456531520031     83.87502933718609
                                45.54712020644544     44.70693952869038     81.97738413452767     83.95818356402224
                                45.84292299382878     44.77704345873913     82.35118338199700     83.95966387450966
                                45.89411137280815     45.41425773286726     83.01052538434648     84.12812994632024
                                45.93130099197283     46.16884439916935     83.50833510120576     84.26276094927231
                                46.13648038236674     46.66645417860622     84.88757531920830     85.41732546800056
                                46.74873798919658     46.71790568883760     84.90953097036886     85.56340808970482
                                47.11273577214855     46.74581938882115     84.93196765297411     85.57603396455576
                                47.17870777128640     46.82414166607185     84.97178445888456     86.63510466280221
                                47.19338055580042     46.83645774240446     85.43536447262163     86.74129103462393
                                47.25761413477774     46.86834469505590     85.59822430471097     86.85376073363715
                                47.53327847102834     46.90228589364909     85.76446609620548     87.26108400015282
                                47.64308771617673     47.02814519551055     85.79904863600991     87.72293541243303
                                47.80286861846863     47.44672838168050     85.88640862064263     87.86803587836525
                                47.86455937950740     47.65301489003541     85.88750199172448     88.16881051171814
                                47.90065455321760     47.73425082354376     85.94295700508701     88.71267004066843
                                47.90727961241468     47.86377917424705     85.94674546805844     88.77726627283683
                                47.93243954623904     47.88720812998766     86.51872778134982     88.78993962536994
                                47.95062952008558     47.88774830879015     86.63116771614249     88.88085054889298
                                47.95097849989396     47.89825669442417     86.77387990931732     89.72021826461126
                                48.04730571166697     47.89981045730949     86.95084011077047     89.75804193954582
                                48.08042611622322     48.03246661737583     87.87239147980547     90.05949240088842
                                48.08999523258601     48.15253490344558     88.31289344498016     90.36439442190294
                                48.25670456430854     48.26904755214532     88.33999433286937     90.54253266759406
                                48.25947200597002     48.41894159956091     88.35502296938638     90.72591894564106
                                48.30826210577268     48.43125201523194     88.58311746582939     90.77173035874087
                                48.31514124187375     48.53932287546499     88.89099681179805     91.07747476133886
                                48.44349281318267     48.58969411593706     89.34043973691581     91.08545627378257

commit 349e79bae02a8a161c06ba5f6fa203d609f6e8b9
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-19 16:53:18 +0900

    Try to test with rake-13.0.2 again.

      [ruby/fileutils] Make verbose output go to stdout instead of stderr

      This reverts commit 510df47f5f7f83918d3aa00316c8a5b959d80d7c.

commit bdd18090ad75cd5659b561890756c5e0b1227b69
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-19 16:52:56 +0900

    Bump bundled rake version to 13.0.2

commit a139318538f070cb3eb2ca1a72ae56a8c9c4acad
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-19 15:51:42 +0900

    Added macros for headers which are not included by ruby.h

commit 042c3e91fbc621e28e5edda015c43e01341fee1c
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-19 16:10:57 +0900

    Check macros for headers

commit 197550c9564d56372d4ea30dd3f17c8905072c21
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-19 16:09:54 +0900

    Renamed check_encoding.yml as check_misc.yml [ci skip]

commit 5c9d6ea6b43443c470a490858a8ad11b36ed5516
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-19 15:34:26 +0900

    Strip trailing spaces [ci skip]

commit 553d6fa0a05fc766229c094b231ac1e103906ba8
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-19 15:32:06 +0900

    [DOC] Marked dtrace arguments as description list [ci skip]

commit a5832c9a37c34756020425b60dd265ca1a45d95b
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-19 15:01:47 +0900

    [DOC] Fixed markups in dtrace_probes.rdoc [ci skip]

    * `+` can enclose just a word.
    * TIDYLINK with braces gets confused when other braces even inside
      code precede.

commit 144b11e03ee0994cacd3fa5eb9ff8b87bd627452
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2020-12-19 15:24:09 +0900

    Fix `warning: instance variable @head not initialized` and remove unused instance variable

commit e64af7d5ad8791cc8fe5ea4e75072e3857bcb270
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-19 15:08:54 +0900

    NEWS: Add an entry of Digest 3.0.0 [ci skip]

commit 0cb556b457cdb200966aa011de21b752940a9c1f
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-18 17:56:01 +0900

    [digest] Version 3.0.0

    https://github.com/ruby/digest/commit/4bbd247a32

commit b66f52b0e374d298cbd3a68029226dc1ccd77554
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-16 23:04:42 +0900

    [digest] Make digest Ractor safe

    https://github.com/ruby/digest/commit/c13a024b85
    https://github.com/ruby/digest/commit/9edca3f8be
    https://github.com/ruby/digest/commit/378b56b6ca

commit feacae193ca3856b1d326697835357791a6df12b
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-17 11:02:31 +0900

    [digest] Added rb_digest_make_metadata to wrap metadata

    https://github.com/ruby/digest/commit/7046fe6005

commit 5b2cf7eac89550fc88aea45ad2a9dfe9a261c2b1
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-19 11:48:04 +0900

    Partially reintroduce e042e8460bb9a63c05f938d51e8c7c5345a6f3a4 and ...

    34f06062174882a98ebef998c50ad8d4f7fc0f2e

    Add a test for alias_method

commit 51bcd50915941d21df806e8dcde769ae63b6eaaf
  Author: Radosław Bułat <radek.bulat@gmail.com>
  Date:   2020-12-19 03:14:23 +0900

    Feature 17314: alias_method returns symbol

commit 34f6b22df073fe86e30aca99be5aa0b0eb8653df
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-18 12:10:20 +0900

    Use rb_id_attrset without intermediate strings

commit 5616f2ee93e63e575dc5e30db75a6f475ac57fb3
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-18 12:59:01 +0900

    Added missing tests for public, private, protected and alias_method

commit d40d95296d0947edf513ad5bc7d4bf338b2e3877
  Author: Radosław Bułat <radek.bulat@gmail.com>
  Date:   2020-12-19 01:40:31 +0900

    Feature 17314: update docs and NEWS about attr* methods returning array of symbols

commit 76e88480371469400346fca609efe67096813915
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-19 05:57:12 +0900

    unfreeze Ractor::MovedObject

    Matz prefers to unfreeze the class.
    [Feature #17401]

commit 80cb9165fa34185b601970da407a295a78ec9eff
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-19 05:52:18 +0900

    add "copy: true" option for Ractor.make_shareable

    Ractor.make_shareable(obj) tries to make obj a shareable object
    by changing the attribute of obj and traversable objects from obj
    (mainly freeze them).

    "copy: true" option is more conservative approach by make deep
    copied object and make it sharable. It doesn't affect any existing
    objects.

commit cee02d754d76563635c1db90d2ab6c01f8492470
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-19 04:30:25 +0900

    fix refinements/prepend bug

    replaced method entry should be invalidated.
    [Bug #17386]

commit 04d62e6f6202684c57f2fcf71bbfcb891cd4ddd9
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-19 04:29:58 +0900

    fix method cache debug tool

commit 0e79d4cde547edd52b2d5bf576780906e45a742d
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-19 03:25:48 +0900

    Added tests for [Feature #17314]

    Partially reintroduce 34f06062174882a98ebef998c50ad8d4f7fc0f2e

commit aa7a02071072b5b0dd15357740d0ffd506bb0381
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-19 03:20:09 +0900

    Revert "Revert "Use rb_id_attrset without intermediate strings""

    This reverts commit 41c208d4a463183fddca250026e5f1cd759d2604.

    Reintroduce 66090b9d10cdaed917b525225e59d1c19e399248.

commit 346bf0f5a586ce6140e28aca145e5b6a8160ee4f
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-19 03:16:20 +0900

    spec/ruby/core/module/attr_*: Add version guards

commit 5944c4b3cfbbf8b774a4a76ca71ab9f71c71d1b0
  Author: Radosław Bułat <radek.bulat@gmail.com>
  Date:   2020-12-19 03:11:35 +0900

    attr_reader, attr_writer, attr_accessor and attr methods returns array of symbols (#3935)

    Co-authored-by: Yusuke Endoh <mame@ruby-lang.org>

  Notes:
    Merged-By: mame <mame@ruby-lang.org>

commit f6641d73764115c3f6bdf435a381711d894300b6
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-19 03:06:16 +0900

    NEWS: Add an entry of StringScanner 3.0.0 [ci skip]

commit b3b7f1e580007fbb21e37afcfcde56364825fc69
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-19 03:05:00 +0900

    NEWS: Add an entry of StringIO 3.0.0 [ci skip]

commit f213a271a1eedfe6b956826ea9a60b334452c4ee
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-19 03:02:04 +0900

    NEWS: fiddle 1.0.4 [ci skip]

commit 7e2dbbda357b8c509358a3aa10ff6d588ed819e2
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-12-17 02:02:23 +0900

    Use category: :experimental in warnings that are related to experimental features

    This adds rb_category_compile_warn in order to emit compiler warnings
    with categories.  Note that Ripper currently ignores the category
    for these warnings, but by default it ignores the warnings completely,
    so this shouldn't matter.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3917

commit 05313c914b29f7027b27a91021ae2662f0149e54
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-09-29 02:10:31 +0900

    Use category: :deprecated in warnings that are related to deprecation

    Also document that both :deprecated and :experimental are supported
    :category option values.

    The locations where warnings were marked as deprecation warnings
    was previously reviewed by shyouhei.

    Comment a couple locations where deprecation warnings should probably
    be used but are not currently used because deprecation warning
    enablement has not occurred at the time they are called
    (RUBY_FREE_MIN, RUBY_HEAP_MIN_SLOTS, -K).

    Add assert_deprecated_warn to test assertions.  Use this to simplify
    some tests, and fix failing tests after marking some warnings with
    deprecated category.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3917

commit 6ced55b07cf00e4ce8ffac5762f10e8ff1ecc59b
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-12-17 01:37:04 +0900

    Make warning_categories a map of category symbols to category numbers

    Use this to simplify rb_warning_category_from_name.

    This also adds support for using the :experimental category in
    Kernel#warn and Warning.warn.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3917

commit 52fb696ee7d01b1d55a1d5c42c60c6a5ebfc4502
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-12-17 01:15:13 +0900

    Switch rb_category_warn{,ing} to accept an rb_warning_category_t

    Since we decided to only allowing specific warning categories,
    there is no reason to have an API that accepts a general string,
    as it is more error-prone.  Switch to only allowing the specific
    warning categories.

    As rb_category_warn{,ing} are public API, this requires making
    rb_warning_category_t public API as well.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3917

commit 7b06085c7bf8cc0db157e46fb11d16a6447d4d63
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-19 02:44:20 +0900

    [bigdecimal] Fix test for d5ab8e8562

commit d5ab8e8562ec15979a32365fe4bf85be9e6334c0
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-19 02:29:18 +0900

    [bigdecimal] Use rb_undef_alloc_func to undefine allocate

commit c2a5594e271170b57f92d7461466f3c0ab8da863
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-19 00:41:00 +0900

    [ruby/reline] Use cached prompt list when just moved the cursor

    https://github.com/ruby/reline/commit/cfe619460b

commit d4257c6152ac9ad5179eb77d6e68942a5b9c011f
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-18 23:36:33 +0900

    [ruby/reline] Yank by em-kill-region correctly

    This closes ruby/reline#106.

    https://github.com/ruby/reline/commit/2549a52e15

commit af2c81e10c15c267611e59f11b7152545c617826
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-18 23:35:15 +0900

    [ruby/reline] Bind yank-pop correctly

    https://github.com/ruby/reline/commit/3c74beac65

commit 671f2762fb8a4832d2c17322ee600f53c91f76f5
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-18 22:25:09 +0900

    [ruby/reline] Add Enumerable to KillRing for debugging

    https://github.com/ruby/reline/commit/d208874152

commit dc61affd67a3e93c870bf6f79eefc0473630d6f1
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-19 01:52:14 +0900

    [ruby/reline] [ruby/irb] Call ripper only once when generating dynamic prompt

    https://github.com/ruby/irb/commit/babb122a48

    https://github.com/ruby/reline/commit/e6dbcb3b42

commit e76b56f58e44cb54497d93526d649950f5bdd1c0
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-19 02:04:34 +0900

    support Ruby 2.x for openssl

commit ad76c8fb6bc9df26601b0b454f3f0b61c2c772c9
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-18 23:16:54 +0900

    Update TypeProf to 0.10.0

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3933

commit 19a98a8791f99085aca11413a331811659c8b78c
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-19 00:34:14 +0900

    Fixed not to make non-literal expression shareable [Feature #17273]

    Non-literal expression which is not a part of a literal expression
    is not a subject of `shareable_literal_value: literal`.

commit 6945597f6ff491a3f745b66017190715d1642563
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-19 00:04:41 +0900

    * 2020-12-19 [ci skip]

commit ed5c09f38459fe4a0f94c9e24358b21ff5f151c6
  Author: Radosław Bułat <radek.bulat@gmail.com>
  Date:   2020-11-09 19:25:11 +0900

    Remove unused variable

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3934

commit c71934f8a50746c9cd01a86375b178d5c7823259
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-18 09:24:37 +0900

    [stringio] Version 3.0.0

    https://github.com/ruby/stringio/commit/831be01071

commit e1b5289a2bf297d80ea35b32a32a0c5c34ab2ad8
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-17 10:38:42 +0900

    [stringio] Add test-unit in the development dependencies

    https://github.com/ruby/stringio/commit/de010fc0e9

commit 3d3194412918012ddab185751b84ebb64fe6e5d5
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-17 10:05:07 +0900

    [stringio] Make stringio Ractor safe

    https://github.com/ruby/stringio/commit/ee3fec7512
    https://github.com/ruby/stringio/commit/18dcd045ef
    https://github.com/ruby/stringio/commit/18dcd045ef

commit 14ca7f633cae9938b7d8bc722fe1c5c96f6bcd95
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-18 21:58:41 +0900

    [openssl] Fix dependencies

commit b5588edc0a538de840c79e0bbc9d271ba0c5a711
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-18 18:19:33 +0900

    openssl is ractor-safe

    ossl_bn_ctx is C's global variable and it should be ractor-local
    to make it ractor-safe.

commit 74ab2c3b463da4d98803fe694acad831938a97e5
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-18 17:59:26 +0900

    finalizing should be checked before VM lock

commit 7d32bf78537eaeb046166b45a79b47316ccf6f02
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-18 17:56:08 +0900

    Removed a moved local variable

commit 61236770e6cc41f1364dc04249d845def03d9f37
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-18 17:49:22 +0900

    need to sync gc_finalize_deferred

    gc_finalize_deferred() runs finalizers and it accesses objspace,
    so it need to sync.

commit 75416b86287c8266cef3a8b372625c1738661a24
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-17 13:50:08 +0900

    Removed old GC.stat keys deprecated since 2.2

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3921

commit 763d5f9c6baf57108396ee5452fa73c834fe9ce0
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-17 13:49:10 +0900

    Removed old GC tuning environment variables deprecated since 2.1

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3921

commit 982443e6e373f5a3ac22ee495909cb9adffcd08d
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-18 14:12:42 +0900

    Revert "Better cooperation between public/protected/private with attr* and alias_method"

    This reverts commit 81739ad4fdfcc86a769056fec352f27c686fba1b.

commit 41c208d4a463183fddca250026e5f1cd759d2604
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-18 14:12:38 +0900

    Revert "Use rb_id_attrset without intermediate strings"

    This reverts commit 66090b9d10cdaed917b525225e59d1c19e399248.

commit c4e50b58d1e6f030b24faffbc208d3d454d1f433
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-18 14:12:15 +0900

    Revert "Added missing tests for public, private, protected and alias_method"

    This reverts commit e042e8460bb9a63c05f938d51e8c7c5345a6f3a4.

commit 0a60ba923e044ec2e84ac63406ca85b7bb8fc73f
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-18 14:12:09 +0900

    Revert "Added tests for [Feature #17314]"

    This reverts commit 34f06062174882a98ebef998c50ad8d4f7fc0f2e.

commit 8e03e3b0baf12b0e470ef7188559097fea95cb37
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-18 15:09:55 +0900

    Drop token info also for endless singleton method definition

commit ffc8a72f39f15d2977908a71d0c3bd8047c1fd41
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2020-12-18 14:59:20 +0900

    Sort URLs by issue numbers [ci skip]

commit f0ec923c5852b9ae9c82824137641e4e1dfad35a
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-18 14:36:06 +0900

    Remove --jit-save-temps from MJIT

    It's probably not helping the backtrace.

commit b5de66e13278ec588cbc8b76b7212e22898e6a89
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-17 22:40:26 +0900

    [strscan] Fix license comment and files

    https://github.com/ruby/strscan/commit/a999f2c6d1

commit 5370963992a0c79925c812e70beb94d09dbc5e47
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-17 18:32:08 +0900

    [strscan] Version 3.0.0

    https://github.com/ruby/strscan/commit/08645e4e77

commit 985f0af2576c4b4f9f4e75dce7299ba9d55d9419
  Author: Kenta Murata <mrkn@users.noreply.github.com>
  Date:   2020-12-17 18:29:21 +0900

    [strscan] Make strscan Ractor safe (#17)

    * Make strscan Ractor safe

    * Add test-unit in the development dependencies

    https://github.com/ruby/strscan/commit/3c93c2bebe

commit cfa124ef05e1b899c1953888c0fb3076388a0d8e
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-18 14:14:40 +0900

    acquire VM lock on gc_verify_internal_consistency()

    There is a case to call this function without VM lock acquiring.

commit 8cba3b35e095bf17308ed00bf19f6d6f7a682ae2
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-18 14:11:50 +0900

    Bump version RubyGems and Bundler in NEWS

commit b44f7151c71011460877bdba549453aaeada88fe
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-18 11:37:13 +0900

    zlib is ractor-safe

commit 0e40cc9b194a5e46024d32b85a61e651372a65cb
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-18 12:13:33 +0900

    Merge RubyGems 3.2.2 and Bundler 2.2.2

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3930

commit 34f06062174882a98ebef998c50ad8d4f7fc0f2e
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-18 13:03:22 +0900

    Added tests for [Feature #17314]

commit e042e8460bb9a63c05f938d51e8c7c5345a6f3a4
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-18 12:59:01 +0900

    Added missing tests for public, private, protected and alias_method

commit 66090b9d10cdaed917b525225e59d1c19e399248
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-18 12:10:20 +0900

    Use rb_id_attrset without intermediate strings

commit a07f2498031d5f4c53ddc03d61a8a41a6b77baca
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-18 11:23:16 +0900

    socket is ractor-safe.

commit aa82b067cbf24e781fedfe951be153b6b1d21ddf
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2020-12-18 11:18:09 +0900

    ruby_set_stack_size: no longer exists

    Deleted since fc3c60f6081d85f6274986a7a08b59db1515fcb5

commit 51c2725dc646030283d01ce23a32c06f0f1c8bf6
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-18 09:12:26 +0900

    use eval to create different Regexp objects

    Only one warning is shown for the same Regexp object, so create
    different objects to support repeating tests.

    http://ci.rvm.jp/results/trunk-repeat20@phosphorus-docker/3290658

commit 29e42b8bfdfc7a2d879a4ddb1db3d4453d66143a
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-18 08:25:24 +0900

    add explicit check

    To debug this issue:
    https://rubyci.org/logs/rubyci.s3.amazonaws.com/solaris10-gcc/ruby-master/log/20201217T220004Z.fail.html.gz

commit 895b10ad020a788566c6e35431d07e6121e38c87
  Author: Aaron Patterson <tenderlove@ruby-lang.org>
  Date:   2020-12-18 06:25:35 +0900

    Add documentation about GC.compact

    [Misc #16443][ruby-core:96395]

commit 81739ad4fdfcc86a769056fec352f27c686fba1b
  Author: Radosław Bułat <radek.bulat@gmail.com>
  Date:   2020-11-09 19:25:11 +0900

    Better cooperation between public/protected/private with attr* and alias_method

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3757

commit f7a6b460d5cf3665d3cc682fec34f989b639e7a6
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-18 01:20:56 +0900

    * 2020-12-18 [ci skip]

commit 6538c89f1c9d1af95c0fb3e58ac0e807a5fe47f4
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-18 01:19:03 +0900

    gc_verify_internal_consistency() needs barrier

    gc_verify_internal_consistency() accesses all slots (objects) so
    all ractors should stop before starting this function.

commit caef364cc5e9816b398f46a7da50057707f87af3
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-17 22:39:37 +0900

    test/ruby: suppress some warnings

    follow up to 9908177857a28633d6279c43a1ad4dfedcb98596

commit 980f994b3b349486c5e64b51241330d4c9fc63f1
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-11-21 06:58:02 +0900

    [ruby/irb] Change context-mode's default to new mode 4.

    This new mode uses a copy of the TOPLEVEL_BINDING. This is compatible with refinements (contrary to mode 3), while keeping nested IRB sessions separate

    https://github.com/ruby/irb/commit/25c731cb2f

commit 753222d72c8787f2d57781c2e55194da2d3d0d8f
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-12-09 01:56:01 +0900

    [ruby/irb] Enable deprecation warnings when using -W or -w

    Requested in Ruby Bug 17377

    https://github.com/ruby/irb/commit/698f6eb34a

commit 336fe648b08e7bd062dc8d4cc11781dd8d617f11
  Author: Benoit Daloze <eregontp@gmail.com>
  Date:   2020-11-06 02:13:56 +0900

    [ruby/irb] Skip the few failing tests on TruffleRuby

    https://github.com/ruby/irb/commit/22717844c0

commit b5effe07bd7965a3d90c36509025c4231f306741
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-11-22 22:03:09 +0900

    [ruby/irb] Fixed a typo in a comment [ci skip]

    https://github.com/ruby/irb/commit/ce373417f3

commit cbf6a7f906d17968c8f54f4efb1899e9b204ccfe
  Author: Nobuhiro IMAI <nov@yo.rim.or.jp>
  Date:   2020-11-21 08:40:31 +0900

    [ruby/irb] workaround for lack of tokens from `Ripper.lex`

    * Fixes #38

    https://github.com/ruby/irb/commit/905fb8e52e

commit 422e2c7274d9dbf1ff93dccc0c3c388f4775e636
  Author: Robert Schulze <robert@dotless.de>
  Date:   2020-05-05 16:24:52 +0900

    [ruby/reline] Use plus operator to create unfrozen string

    https://github.com/ruby/reline/commit/ca274b0d37

commit cdf2790aa089c5ff608dd97407b5ce684cc9f415
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-17 19:57:44 +0900

    [ruby/reline] Support longer than screen height on Windows

    https://github.com/ruby/reline/commit/2a97ca9362

commit 0158ba7e51cb3fc5a204cb65d1be1618802e08d2
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-16 16:28:51 +0900

    [ruby/reline] Make a log file on windows if debug env is set

    https://github.com/ruby/reline/commit/dff30a2d44

commit 2b8fa7817643a9ac7632b66ffed7cb5fd3753966
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-13 11:30:05 +0900

    [ruby/reline] Support longer than screen height

    https://github.com/ruby/reline/commit/e83a3de9ed

commit 9908177857a28633d6279c43a1ad4dfedcb98596
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-17 20:06:18 +0900

    test/ruby: Check warning messages at a finer granularity

    Instead of suppressing all warnings wholly in each test scripts by
    setting `$VERBOSE` to `nil` in `setup` methods.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3925

    Merged-By: nobu <nobu@ruby-lang.org>

commit d597d7a8b6e753cfe40b8470c770f744adde5d4f
  Author: Yale Kozinski <ytk@kozinski.com>
  Date:   2020-11-23 18:17:06 +0900

    Fixing glitchy kill ring behavior in irb
    See https://github.com/ruby/irb/issues/85 for details

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3806

commit da3438a50454706cce2e5b06bdad498b42977f8f
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-17 17:29:05 +0900

    sync obj_to_id_tbl

    objspace->obj_to_id_tbl is a shared table so we need to synchronize
    it to access.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3924

commit 7f11c8086a4b5924737223322e24be23e9ff34c5
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-17 17:20:29 +0900

    reduce barrier counts for GC events

    mark needs barrier (stop other ractors), but other GC events don't need
    barriers (maybe...).

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3923

commit 99b91453809be68c604f94416030addfff3d6142
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-17 04:06:04 +0900

    relax synchronization on WB

    Current synchronization is too much on write barriers.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3918

commit 44fba194a5561a5ca20f6bd91fb96b7d8edd1dbb
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-17 17:24:51 +0900

    ruby/pathname separated .rb file to top-level directory.

commit c42948d78463d7e38f04070236985dcda895efd5
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-17 17:03:05 +0900

    add debug counters for gc start events

commit 92137718170118030a1f56303764d08201bf5c33
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-17 15:46:36 +0900

    encourage inlining for vm_sendish()

    Some tunings.
    * add `inline` for vm_sendish()
    * pass enum instead of func ptr to vm_sendish()
    * reorder initial order of `calling` struct.
    * add ALWAYS_INLINE for vm_search_method_fastpath()
    * call vm_search_method_fastpath() from vm_sendish()

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3922

commit 5d74894f2bc4a3a18aec952d946ead3d784cb4b4
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-17 15:08:04 +0900

    Lazily move PC with RUBY_VM_CHECK_INTS

    ```
    $ benchmark-driver -v --rbenv 'before --jit;after --jit' --repeat-count=12 --alternate --output=all benchmark.yml
    before --jit: ruby 3.0.0dev (2020-12-17T06:17:46Z master 3b4d698e0b) +JIT [x86_64-linux]
    after --jit: ruby 3.0.0dev (2020-12-17T07:01:48Z master 843abb96f0) +JIT [x86_64-linux]
    last_commit=Lazily move PC with RUBY_VM_CHECK_INTS
    Calculating -------------------------------------
                                     before --jit           after --jit
    Optcarrot Lan_Master.nes    80.29343646660429     83.15779723251525 fps
                                82.26755637885149     85.50197941326810
                                83.50682959728820     88.14657804306270
                                85.01236533133049     88.78201988978667
                                87.81799334561326     88.94841008936447
                                87.88228562393064     89.37925215601926
                                88.06695585889995     89.86143277214475
                                88.84730834922165     90.00773346420887
                                90.46317871213088     90.82603371104014
                                90.96308347148916     91.29797694822179
                                90.97945938504556     91.31086331868738
                                91.57127890154500     91.49949184318844
    ```

commit 3b4d698e0b5a79b63b05ae0c79d282a9049225e4
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-17 15:12:50 +0900

    Ignore catch_except_p for PC motion

    We probably don't need to move it when an insn is leaf...

commit a09c3c6fe1f24e5956b43157e6e40dfe4f986bed
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-17 14:37:45 +0900

    expand VERSION path for ruby repository.

commit 46ea74297eb3e46e19fb692a8d8eef817b93a49b
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-17 14:20:42 +0900

    Bump version to json-2.4.1 and use VERSION file for json version same as upstream

commit ccf9da079f0a9987f80d74b971a11bcd236d3576
  Author: d-m-u <16326669+d-m-u@users.noreply.github.com>
  Date:   2020-12-17 13:20:49 +0900

    fix doc typo

    s/it's/its

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3920

commit d07183ec85dc20c7c034170bd8964c79c34a47d7
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-17 12:43:17 +0900

    Do not access jit_unit if NULL

commit 93ba3ac03681a2a65ca28b4c5aaba72da9e16f97
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-17 03:46:44 +0900

    RGENGC_PROFILE=0

    Enabled this flag, maybe accidentally.

commit 2a3324fcd2f9681e167b2619563a5c26e1a362fe
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-17 01:56:30 +0900

    No sync on ASCII/US_ASCCII/UTF-8

    rb_enc_from_index(index) doesn't need locking if index specify
    ASCII/US_ASCCII/UTF-8.
    rb_enc_from_index() is called frequently so it has impact.

                                   user     system      total        real
    r_parallel/miniruby       174  0.000209   0.000000   5.559872 (  1.811501)
    r_parallel/master_mini    175  0.000238   0.000000  12.664707 (  3.523641)

    (repeat x1000 `s.split(/,/)` where s = '0,,' * 1000)

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3916

commit c58142134cccdd31811f12aabf4f9dd3ce6a17f7
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-17 01:29:15 +0900

    make RB_DEBUG_COUNTER_INC()_thread-safe

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3915

commit d5929b39a9c7944de14c133fa3948b7b3a92e423
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-16 23:57:35 +0900

    Make Ractor#receive_if private

commit 24f018972b958d6287c71a4682ea1dcc8d1fa16e
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-17 00:31:14 +0900

    fix timing bug

    ractor_sleep() can remain wait.status by interrupt, so that this
    patch handles more correctly.

    This patch fixed this kind of assertion failures:

       Assertion Failed: ../src/ractor.c:1332:ractor_yield_atexit:cr->sync.wait.status == wait_none

commit 84c9ebd65f8a6fcd2e22225c563fb671dc690a9a
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-17 00:31:09 +0900

    * 2020-12-17 [ci skip]

commit b29c0fadeca7bd7d00d9fe17345fe88bf968312f
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-17 00:28:48 +0900

    add HAVE_RB_EXT_RACTOR_SAFE macro

    define HAVE_RB_EXT_RACTOR_SAFE to check rb_ext_ractor_safe() is
    available or not.

commit 53babf35ef5b643774636550ea23851e2607e076
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-16 23:24:07 +0900

    Inline getconstant on JIT (#3906)

    * Inline getconstant on JIT

    * Support USE_MJIT=0

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit bfb374be2342d7822cd37a1b100cb1715f85ca74
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2020-12-16 22:59:05 +0900

    Fix a typo [ci skip]

commit 9c859f4b3c2098af590d3e0eadc2d1011fb32bb8
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-16 22:53:43 +0900

    Ripper: Pass callback result to alias_error as well as other errors

    [Bug #17345]

commit 47328ad217ecaf240f0faedac89723dcd6a917ac
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-16 21:01:45 +0900

    Ripper: Fixed erred token on wrong alias [Bug #17345]

commit 359ad4423ed0f314822a3b97831fe9e4272ea347
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-16 20:33:31 +0900

    strip trailing spaces [ci skip]

commit a9a7f4d8b8ec30abc7a47ce700edc7209ae12279
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-08 14:04:18 +0900

    Ractor#receive_if to receive only matched messages

    Instead of Ractor.receive, Ractor.receive_if can provide a pattern
    by a block and you can choose the receiving message.

    [Feature #17378]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3862

commit ddb93c3d64b8997c85f23c96a73ad0a9a7f82ad1
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-16 17:05:39 +0900

    Made LARGEFILE_SUPPORT mandatory

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3914

commit 5193fbb6d0dedfbc2b3c017456fb58a13136de01
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-16 17:00:04 +0900

    Removed stale declaration

    rb_w32_pipe_exec was removed in 1.9.3, at
    commit:7ac32d7a16734ea66de15319bcff2fd429abae7f.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3914

commit 8b32191a3101cb6441fc64c87cfd011fdadc6867
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-15 23:17:23 +0900

    Ignore failure on unsupported fcntl to drop non-blocking mode

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3913

commit 4fe7f270ce924b6339e9ccf56c3fff2de3f4fa8b
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-16 17:39:23 +0900

    Different names instead of `ulimit`

commit 5d8f227d0edd3c542fcac465eb82005a5f852d34
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-16 16:14:02 +0900

    Lazily move units from active_units to stale_units

    to avoid SEGV like
    http://ci.rvm.jp/results/trunk-mjit@phosphorus-docker/3289588
    by a race condition between mjit_recompile and compation around active_units

commit 0a521618723e5e602c1288b4185b869e94332172
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-16 17:18:07 +0900

    fix Ractor#receive by other ractors

    Ractor#receive can be called by the another Ractors using send,
    so making this method completely same as `Ractor.receive` even if
    the ractor is specified by the receiver (OO term :p).

commit c668772b145b7fd889000480778e011a808442ab
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-16 16:17:54 +0900

    test/ruby/test_enum.rb: Avoid "warning: assigned but unused variable"

commit 19157a3c001d68acdc8e5190a806189840d23375
  Author: David CARLIER <devnexen@gmail.com>
  Date:   2020-12-16 15:32:11 +0900

    vm debug: dump registers on ARM too. (#3900)

    * vm debug: dump registers on ARM too.

  Notes:
    Merged-By: nurse <naruse@airemix.jp>

commit 98dca855736c9fb8d4edef8b33a5df1cfe67ebb7
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-16 14:13:32 +0900

    tuning vm_setivar_slowpath() more.

    specify inline/noinline code for is_attr condition.

commit 1bafb3cb47649037cc93fec97503c18a864e3983
  Author: Kenta Murata <mrkn@users.noreply.github.com>
  Date:   2020-12-16 13:43:56 +0900

    [memory_view] Make MemoryView API Ractor-safe (#3911)

    * memory_view.c: make Ractor-safe

    * test/ruby/test_memory_view.rb: Add test_ractor

    * memory_view: fix typo

    * memory_view.c: Use st_update in unregster_exported_object

    * memory_view: update dependency

  Notes:
    Merged-By: mrkn <mrkn@ruby-lang.org>

commit 1e11c12a066036e85177104a9f8f5469063858a7
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-16 13:30:34 +0900

    remove unused function

commit 5499651ee75538a4d8a3bb4a7442f5f59f36acd8
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-16 12:03:36 +0900

    tuning ivar set

    * make rb_init_iv_list() simple
    * introduce vm_setivar_slowpath() for cache miss cases

    ../clean/miniruby is 647ee6f091.

    Calculating -------------------------------------
                          ./miniruby  ../clean/miniruby  ../ruby_2_7/miniruby
             vm_ivar_init     7.388M             6.814M                5.771M i/s -     30.000M times in 4.060420s 4.402534s 5.198781s
    vm_ivar_init_subclass     2.158M             2.147M                1.974M i/s -      3.000M times in 1.390328s 1.397587s 1.519951s
              vm_ivar_set   128.607M            97.931M              140.668M i/s -     30.000M times in 0.233269s 0.306338s 0.213268s
                  vm_ivar   144.315M           151.722M              117.734M i/s -     30.000M times in 0.207879s 0.197730s 0.254811s

    Comparison:
                          vm_ivar_init
               ./miniruby:   7388398.8 i/s
        ../clean/miniruby:   6814257.1 i/s - 1.08x  slower
     ../ruby_2_7/miniruby:   5770583.9 i/s - 1.28x  slower

                 vm_ivar_init_subclass
               ./miniruby:   2157763.6 i/s
        ../clean/miniruby:   2146557.0 i/s - 1.01x  slower
     ../ruby_2_7/miniruby:   1973747.9 i/s - 1.09x  slower

                           vm_ivar_set
     ../ruby_2_7/miniruby: 140668063.8 i/s
               ./miniruby: 128606912.1 i/s - 1.09x  slower
        ../clean/miniruby:  97931027.8 i/s - 1.44x  slower

                               vm_ivar
        ../clean/miniruby: 151722121.9 i/s
               ./miniruby: 144314526.5 i/s - 1.05x  slower
     ../ruby_2_7/miniruby: 117734305.5 i/s - 1.29x  slower

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3912

commit ad8e82f70828bf6a0a36648f8b4bdc3142b09968
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-16 12:31:40 +0900

    Fixed marshal compatibility of Process::Status

commit b30d7fea569cf64325d55b901af784ee13a477f8
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-16 12:14:30 +0900

    Removed leading spaces [ci skip]

commit cfefd1e524fdd8c832c5a762d5ec969b71190827
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-16 11:26:26 +0900

    Added entry for webrick changes at Ruby 3.0 to NEWS

commit 0b678cc9e5a5149e40765562142ed1dc05d09b53
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-16 10:10:05 +0900

    add vm_sync debug counters

    * vm_sync_lock
    * vm_sync_lock_enter
    * vm_sync_lock_enter_nb
    * vm_sync_lock_enter_cr
    * vm_sync_barrier

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3910

commit 171f0431e766ba5b1a326386fff34a30f6cbc4c5
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-16 10:36:23 +0900

    fix typo

commit dff67c809f786c94933583a450dbd9398fa07039
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-16 10:29:48 +0900

    fix duplicated name

commit ccc828f49956424b2548e32cb3bc3a78e16e207b
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2020-12-15 16:57:28 +0900

    configure.ac: avoid squashing CXX=g++

    We are discussing this issue at [Bug #17337] but in the meantime, leave
    this questionable autoconf glitch as-is to save sassc and eventmachine.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3907

commit 8558d5e4801b74b058dc2a534be2be85037cadb5
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-16 07:05:35 +0900

    Document Hash#transform_keys with hash. Amend NEWS [DOC] [ci skip]

commit d5f0d338c7b5d3d64929b51d29061d369550e8c4
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-09 11:20:37 +0900

    Optimize `Enumerable#grep{_v}`

    [Bug #17030]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3868

commit a039dc018ccf34e217f767eac500b9400c58f069
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-16 00:07:37 +0900

    [DOC] Described "numeric representation" more precisely [ci skip]

    [Bug #17395]

commit efc6a4e580b863ee032d61a7f3927be86de64a03
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-16 00:04:59 +0900

    * 2020-12-16 [ci skip]

commit 289d42c932b744260359ee2c02d6723ecb8fc714
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-15 23:43:08 +0900

    Removed unneeded cast and use the real name

commit 8f6cb5b70b5ca107260960a107e257ef202c9dc0
  Author: Zoltán Mizsei <zmizsei@extrowerk.com>
  Date:   2020-10-30 06:47:24 +0900

    TEST: multiarch support for Haiku

commit 95423215849ad26e1b928b3d36af021472bb185b
  Author: Zoltán Mizsei <zmizsei@extrowerk.com>
  Date:   2020-10-30 06:49:45 +0900

    Haiku: disable stack-protector

commit 4d43ac2fb94de27ed6f87f92f2ef71808c9cc44b
  Author: Zoltán Mizsei <zmizsei@extrowerk.com>
  Date:   2020-10-30 06:49:17 +0900

    Add Haiku to the context support list

commit e0bdd54348514ff06df88a9bac88fa56058235a4
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-15 14:14:13 +0900

    Ripper: Refined error callbacks [Bug #17345]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3909

commit 2e436982ee64301aceb97e0c8d5b06b94fc7b580
  Author: Junichi Ito <jit@sonicgarden.jp>
  Date:   2020-12-15 20:11:02 +0900

    Fix typo in NEWS.md

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3908

commit 151ff609e595e78b7937ecb4b011879dc5a0cbd1
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-15 20:05:32 +0900

    Added updated versions of the default gems on NEWS

commit ad3e3bd65a69c05035289b0dbf04394a8238fbfb
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-15 19:54:58 +0900

    Bump version to json-2.4.0

commit 5463eff5f6236f89c137c562ee271e1c1ff92a89
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-15 16:33:49 +0900

    Lock only active_units references

    556a7285080c1344c75bb93a333c9bfc5d631c61 was not good maybe because it
    wasn't using list_for_each_safe. If list_for_each_safe is safe for
    list_del for any nodes (is that true?), this should be fine.

commit ce6fafb8cc59658245a70ff24c75a3108a39ba93
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-15 15:15:23 +0900

    Cache warning category IDs

commit a86c147579745859ea064ec22b2901a7ac7e4abf
  Author: Kenta Murata <mrkn@users.noreply.github.com>
  Date:   2020-12-15 15:17:15 +0900

    Import bigdecimal 2.0.2 (#3905)

    * remove duplicated include

    * Make BigDecimal#round with argument < 1 return Integer

    Fixes [Bug #12780]

    * Use a higher default precision for BigDecimal#power and #**

    When a fractional power is given, increase the precision if the
    precision isn't specified via power's second argument:

    Float: increase by 15 (rough number of decimal precision in float)
    BigDecimal: increase by adding similar precision modifier as done to
                calculate the base precision.
    Rational: double the precision, since a BigDecimal is created, but
              the created BigDecimal uses the same precision.

    Increasing the precision for these power calculations has the obvious
    tradeoff of making the calculations slower.

    Fixes Ruby Bug #17264

    * Use DBLE_FIG for a Float value

    * Version 2.0.1

    Co-authored-by: pavel <pavel.rosicky@easy.cz>
    Co-authored-by: Jeremy Evans <code@jeremyevans.net>

  Notes:
    Merged-By: mrkn <mrkn@ruby-lang.org>

commit 9d85ed6cbb50960d08bdb24c303a8f5e06b7e922
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-15 14:06:53 +0900

    Simplify positioning of '{' and '}'

    and fix inconsistent indentation in mjit_compile.inc.erb

commit 72a73691bd069c20f07a42bbd2740ada319ee001
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-15 12:10:35 +0900

    add several debug counters

    add cc_found_in_ccs (renamed from cc_found_ccs), cc_not_found_in_ccs,
    call0_public, call0_other debug counters to measure more details.

    also it contains several modification.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3903

commit aa6287cd26582e64c19e37dea3fd90b380b85d5b
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-15 05:40:38 +0900

    fix inline method cache sync bug

    `cd` is passed to method call functions to method invocation
    functions, but `cd` can be manipulated by other ractors simultaneously
    so it contains thread-safety issue.

    To solve this issue, this patch stores `ci` and found `cc` to `calling`
    and stops to pass `cd`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3903

commit 40b7358e934e3b1f2cc7a664f97e5cc1393cbc77
  Author: John Hawthorn <john@hawthorn.email>
  Date:   2020-12-15 10:34:31 +0900

    Skip defined check in NODE_OP_ASGN_OR with ivar

    Previously we would add code to check if an ivar was defined when using
    `@foo ||= 123`, which was slower than `@foo || (@foo = 123)` when `@foo`
    was already defined.

    Recently 01b7d5acc702df22d306ae95f1a9c3096e63e624 made it so that
    accessing an undefined variable no longer generates a warning, making
    the defined check unnecessary and both statements exactly equal.

    This commit avoids emitting the defined instruction when compiling
    NODE_OP_ASGN_OR with a NODE_IVAR.

    Before:

        $ ruby --dump=insn -e '@foo ||= 123'
        == disasm: #<ISeq:<main>@-e:1 (1,0)-(1,12)> (catch: FALSE)
        0000 putnil                                                           (   1)[Li]
        0001 defined                      instance-variable, :@foo, false
        0005 branchunless                 14
        0007 getinstancevariable          :@foo, <is:0>
        0010 dup
        0011 branchif                     20
        0013 pop
        0014 putobject                    123
        0016 dup
        0017 setinstancevariable          :@foo, <is:0>
        0020 leave

    After:

        $ ./ruby --dump=insn -e '@foo ||= 123'
        == disasm: #<ISeq:<main>@-e:1 (1,0)-(1,12)> (catch: FALSE)
        0000 getinstancevariable                    :@foo, <is:0>             (   1)[Li]
        0003 dup
        0004 branchif                               13
        0006 pop
        0007 putobject                              123
        0009 dup
        0010 setinstancevariable                    :@foo, <is:0>
        0013 leave

    This seems to be about 50% faster in this benchmark:

        require "benchmark/ips"

        class Foo
          def initialize
            @foo = nil
          end

          def test1
            @foo ||= 123
          end

          def test2
            @foo || (@foo = 123)
          end
        end

        FOO = Foo.new

        Benchmark.ips do |x|
          x.report("test1", "FOO.test1")
          x.report("test2", "FOO.test2")
        end

    Before:

        $ ruby benchmark_ivar.rb
        Warming up --------------------------------------
                       test1     1.957M i/100ms
                       test2     3.125M i/100ms
        Calculating -------------------------------------
                       test1     20.030M (± 1.7%) i/s -    101.780M in   5.083040s
                       test2     31.227M (± 4.5%) i/s -    156.262M in   5.015936s

    After:

        $ ./ruby benchmark_ivar.rb
        Warming up --------------------------------------
                       test1     3.205M i/100ms
                       test2     3.197M i/100ms
        Calculating -------------------------------------
                       test1     32.066M (± 1.1%) i/s -    163.440M in   5.097581s
                       test2     31.438M (± 4.9%) i/s -    159.860M in   5.098961s

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3904

commit 2fa9f3c0322570dfb1672b49bc1f3306ef595131
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-15 08:32:54 +0900

    Prepare to release rubygems-3.2.1 and bundler-2.2.1

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3901

commit 7898f4243f5df9ead0bf91cc8c40907c559d18c0
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-15 09:37:11 +0900

    ripper: return pushed new token instead of the token list

commit c59b9a8c0c50a6df13909c71e43de09a152b122d
  Author: Alan Wu <alanwu@ruby-lang.org>
  Date:   2020-12-15 10:01:55 +0900

    Move docs for Integer#bit_length [ci skip]

commit befa24488c2757b55be12ae3ca866156f5a4073f
  Author: Alan Wu <alanwu@ruby-lang.org>
  Date:   2020-12-15 10:01:01 +0900

    Help RDoc find Exception [ci skip]

    This was on top of `Init_Exception()`.

commit 928cb6eeb6497f9e59ccde394cde60319c63b371
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-15 08:38:36 +0900

    NEWS: make links to label [ci skip]

commit 78fad67ce67048b99c9b4e91b87444b1db2b82e8
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-14 21:30:16 +0900

    NEWS: make links to other document files [ci skip]

commit a5fd65157500a65debeb88f5ac6a62821f96972e
  Author: Alan Wu <alanwu@ruby-lang.org>
  Date:   2020-12-15 08:26:32 +0900

    Reword docs for Fiddle::Function#call [ci skip]

    I'm using `<code>` instead of `+` since `+` only works when it encloses
    a single word.

commit 25a48b703ec738d4667a7b8edcfe8e100ed6ca84
  Author: Alan Wu <alanwu@ruby-lang.org>
  Date:   2020-12-15 07:56:42 +0900

    Update dependencies

commit f5c89c1660afd3a89514125aad579c0a96990c4b
  Author: Benoit Daloze <eregontp@gmail.com>
  Date:   2020-12-15 04:24:18 +0900

    Deprecate Random::DEFAULT

    * Closes [Feature #17351].

commit c183288754fdad17e627c4182de599d965e99405
  Author: Benoit Daloze <eregontp@gmail.com>
  Date:   2020-12-15 04:11:15 +0900

    Remove references to Random::DEFAULT in the documentation

    * Random::DEFAULT is no longer a Random instance, and referencing it is
      more confusing than helpful. Related to [Feature #17351]

commit f7850bbea8842da3e709cf5759f05b38c20e9dac
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-14 23:55:44 +0900

    NEWS: get rid of unintended link [ci skip]

commit 7ca82ff888ac1fafbe928ed296599f30f25f507b
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-15 00:05:38 +0900

    * 2020-12-15 [ci skip]

commit 6b3a808b8476b61d6327f0c7a134736c1369779d
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-14 23:57:13 +0900

    Fix code block indents [ci skip]

    RDoc::Markdown requires all block elements nested under bullet
    list to be indended deeper than the first column of the list.

commit b3e99b36765f99add04e8106b85bb32f3d3022f7
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-14 23:53:50 +0900

    Fix indent for rdoc's markdown

    It seems that nested points need four spaces

commit c2a60fec2f79c05bdb865c143b6ad8eddfc6cc36
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-14 20:13:12 +0900

    Merge Psych-3.2.1 from ruby/psych

commit 27520a1e1e8ac1ef0607a75d654e2cff6d36e15a
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-14 19:39:32 +0900

    Fixed dst name for digest gem

commit 332317472779554f991ffa5bad74c1255828cc21
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-11-26 18:10:42 +0900

    Support shareable_constant_value: literal

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3681

commit 89e489d51d164cf22bce3a7580e5695da22fb347
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-11-13 14:03:25 +0900

    Make shareable_constant_value tri-state

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3681

commit 7060aeedbd69c0888379cbf91f0bb2208bc59308
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-11-02 19:48:17 +0900

    shareable_constant_value: is effective only in comment-only line

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3681

commit 25cf1aca927946595b1325e4fde7f642bba2a706
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-10-22 16:25:28 +0900

    Added continued line case

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3681

commit 78cb9b627b19069abad5b27f1710abacf1eed064
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-10-22 16:24:38 +0900

    Added false case

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3681

commit d19601fb569a2b3adea1bfb1938820314833a475
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-10-21 14:35:42 +0900

    Test by Ractor.shareable?

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3681

commit 11d9983bc340f3cc05da3a87d5d0c63f4f6bd899
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-10-21 14:11:18 +0900

    Make the value shareable deeply

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3681

commit 070a990bcb81ed371fc60e3922f5329b1020aa44
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-10-10 16:24:54 +0900

    Save and pass lex_context wholly

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3681

commit dc1cc33d691faacccd2c12ce3ca75b24cc89dbf9
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-10-10 00:44:14 +0900

    Determine shareable-ness after assignment operator

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3681

commit 60f0c376f762aafadaba38e761d2dc9b0c1c0c82
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-10-09 23:55:22 +0900

    Implemented shareable_constant_value op_asgn

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3681

commit 65450e8f7daf59ca64a12ff1da0efdc0f4280dc1
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-10-20 17:28:12 +0900

    Call FrozenCore.make_shareable

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3681

commit f43c71abe07b4b2b0f8f9a69c567fcd0f38faef6
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-10-09 23:06:13 +0900

    Implemented shareable_constant_value

    It does shallow freeze only for now.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3681

commit b1bd223085d7b97d8de8679894a81b7993c26b28
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-10-09 20:06:30 +0900

    Support shareable_constant_value pragma

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3681

commit 7060d6b721092d56f1cbc084940db960e01671fd
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-14 18:37:22 +0900

    fix condition and add another debug counter

    mc_inline_miss_same_def is added to check same method or not.
    Also the mc_inline_miss_same_cc calculation was fixed.

commit e889c025501850de9a91012552d38924cc5fb947
  Author: Junichi Ito <jit@sonicgarden.jp>
  Date:   2020-12-14 06:01:51 +0900

    Add information to Caveats section in NEWS.md

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3896

commit c37ba2c5478c8fa81f3cb26d7ddb9b79d681147d
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-14 18:17:35 +0900

    add ccs_not_found debug counter

    ccs_not_found to count not found in ccs table.

commit da3be76cb017c188d1a99d8aa14d13c15d93f9d1
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-14 17:56:34 +0900

    add debug counters to survey the IMC miss

commit aacd2295d0f2c982641229e159ff179462d83a36
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-14 16:35:27 +0900

    Debug the command used for gdb dump

    It's not working
    http://ci.rvm.jp/results/trunk-mjit@phosphorus-docker/3288206. I'm
    debugging why.

commit 8d83334a695b7454e9b942289eaede843c4c3660
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-14 16:33:54 +0900

    @ruby is the target Ruby in bootstraptest

commit ab869d6b9ba07fa9453d39902d8641c3db485b76
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-14 15:56:13 +0900

    test/ruby/test_method_cache.rb: suppress "assigned but unused variable"

commit 53edb27baccaffe919c2885a9c86312cc51ea9fb
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-14 14:51:39 +0900

    use method cache on Object#respond_to?

    rb_method_boundp (method_boundp) searches method_entry, but this
    search did not use pCMC, so change to use it.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3899

commit 0362b4c689e319e233691ee052cd703bf8d2baa1
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-14 10:50:22 +0900

    add tests for method cache.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3892

commit a8aa169b8f1f89660037c874e8fc2feaf596a43a
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-14 10:49:07 +0900

    add cc_invalidate_negative debug counter

    counts for invalidating negative cache.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3892

commit 967040ba59799e6b7891168ffbf37cc646988d84
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-13 05:55:18 +0900

    Introduce negative method cache

    pCMC doesn't have negative method cache so this patch  implements it.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3892

commit fa63052be19b26d39b22689ad9969aa83909809e
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-13 01:32:17 +0900

    create ccs with 0 capa

    ccs is created with default 4 capa, but it is too much, so start
    with 0 and extend to 1, 2, 4, 8, ...

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3892

commit 85a7f723c300c45c8fff40c2595422e13a8d9237
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2020-12-14 10:26:04 +0900

    Fix a typo [ci skip]

commit 66756c6d4234c5908213ada7934f8773fa7bebc6
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-14 08:17:34 +0900

    * 2020-12-14 [ci skip]

commit ea6856dcdf9e5909d12e6c4960d4a39fabaac85b
  Author: Junichi Ito <jit@sonicgarden.jp>
  Date:   2020-12-14 07:34:10 +0900

    Remove "2.8" from NEWS.md

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3897

commit 6e84af2fa9c5986d9717bfdfe70c88f402742f5c
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2020-12-13 20:26:22 +0900

    `ulimit` does not affect another shell

commit 12eb5734b3ca1dabfd8286de1d0841d80286fe02
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-13 19:26:47 +0900

    Sorted links by URLs and issue numbers [ci skip]

    ```
    ruby -e 'puts readlines.sort_by {[_1[%r[(https?://.*?)(?:/\d+)?$],1], _1[/\d+$/].to_i]}'
    ```

commit a3adb10aacb48efe0ecb059f012969dc08145360
  Author: Junichi Ito <jit@sonicgarden.jp>
  Date:   2020-12-13 17:15:34 +0900

    Add NEWS about open-uri and Kernel#open

    There might be a lot of codes using redefined Kernel#open via open-uri, so it's worth mentioning that.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3894

commit c7530f0d568e9772bef22a93907f92d8cd872995
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-13 13:39:57 +0900

    Wait testing/helper threads to terminate

commit 416e402cf3d756dcf9c5b10dc7042adf686efacf
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-13 13:12:18 +0900

    Fixed a suspicious comparison

commit 97e6c28db4cfb2b383870769940ade08cbe1a6bf
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-13 11:34:57 +0900

    Narrowed down unaligned member access region in RB_OBJ_WRITE

    Since UNALIGNED_MEMBER_ACCESS assigns to an intermediate variable,
    it can cause unused-value warnings.

commit 88f3ce12d32ffbef983b0950743c20253ea2d0c6
  Author: Kazuki Tsujimoto <kazuki@callcc.net>
  Date:   2020-12-13 11:50:14 +0900

    Reintroduce `expr in pat` [Feature #17371]

commit a8cf526ae99c9e0823cd8c7c5ac96e43061fafa6
  Author: Kazuki Tsujimoto <kazuki@callcc.net>
  Date:   2020-12-13 11:47:02 +0900

    Don't emit warning when the pattern of one-line pattern matching is just a variable pattern

    https://github.com/ruby/dev-meeting-log/blob/master/DevelopersMeeting20201210Japan.md#feature-17371-reintroduce-expr-in-pat-ktsj

commit 1b45174aeaad4ab0e14b37f70d60a1d43ae21adc
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-13 11:47:48 +0900

    Allow dumping a core file on Actions

    to see a C backtrace.

commit 246d7e4f1d92851356d459f424cbc3491135d1ac
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-13 11:46:13 +0900

    Dump a backtrace with gdb

    Because Ruby often fails to dump a C backtrace.

commit 92dfe9aefb62e526bf30b42168ecd4fc9a9db1cf
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-13 01:30:32 +0900

    * 2020-12-13 [ci skip]

commit 3b7c05ef8dc15371316e5254d33af12928183971
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-13 01:10:49 +0900

    Fixed RUBY_RM_RECURSIVE when autoconf met the required version

    Before 9189cf5793cd527a86b711d15d5fd0633ec082e1 the result of
    `m4_version_compare` was compared to -1, however the `$2` of
    `m4_version_prereq` has different meaning and is expanded when
    the required version met.

commit 7ef5226520cbd13bdbc65a7f3c60188e002b133c
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-12 23:25:15 +0900

    spec: suppress deprecations of "lambda(&proc_block)" pattern

commit efbef729b2aee13241e6f7606f90d407f4530df8
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-12 23:11:47 +0900

    test/ruby/test_lambda.rb: prevent lambda(&proc_block) warnings

commit 248f1ef2821325987b7525fc6c839145d66c65e4
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-12 23:09:11 +0900

    tool/mk_builtin_loader.rb: prevent "assigned but unused variable"

commit 4d2ad8d737c55c3efd4c75131687dd1c8db7441b
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-12 17:20:58 +0900

    Removed obsolete autoconf checks

    Use regular `AC_CHECK_MEMBERS` instead of:
    * `AC_STRUCT_ST_BLKSIZE`
    * `AC_STRUCT_ST_BLOCKS`
    * `AC_STRUCT_ST_RDEV`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3890

commit 0df67a469561fab80b78478b99703ed893c4db07
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-12 16:06:19 +0900

    Signal handler type should be void

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3889

commit 21c5726418136d6efa98cbf205860a8bee328907
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-12 16:01:10 +0900

    Omit checks for C89 standard or later

    Now we require C99, these features available of course.

    * prototypes
    * stdarg prototypes
    * token pasting
    * stringization
    * string literal concatenation

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3889

commit e53c0bc906c514ca6f0d40e2140dee1e23b4591e
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-12 15:52:15 +0900

    Add some JIT options to MJIT Actions

    hoping to improve C backtrace outputs

commit 68af5235292f82145c599038b4bff7d9225e62d7
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-12 14:22:59 +0900

    Added parentheses to silence sizeof-array-div warnings [Bug #17385]

    As well as 2366c681166a1dab95de6b9ca8ffcaae18aadd39.

commit 52bca75cde2d888e636301fc43f6371808118154
  Author: S-H-GAMELINKS <gamelinks007@gmail.com>
  Date:   2020-12-11 14:20:43 +0900

    Remove unused function declarations

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3886

commit 3e2399134509930f3fe4d98787264f3a2c96af4c
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-12 12:58:45 +0900

    Lock GC while searching the best iseq

    To fix
    http://ci.rvm.jp/results/trunk-mjit-wait@phosphorus-docker/3286265

commit 4e5156621e3557af98d3d91aff243278e1d8dbef
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-12 11:44:25 +0900

    [DOC] Process::Status.wait return nil if no child processes [ci skip]

commit 70a311fdeb66ce80b562ccc4459c409cea64b74c
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-12 06:54:46 +0900

    trap on non-main ractor

    trap can accept blopck/Proc and it can violate Rator isolation,
    so the Proc should be isolatable when trap is used on non-main ractor.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3888

commit 124321e0c7ab8dac1ffce78c653cc677f878d5b0
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-12 06:29:11 +0900

    fix lambda's warning and tests

    There are warning condition bugs and test bugs.
    b53ccb9c69abd24e3bdad66cbe4c7e7480eaef16

commit d741c77b5fd976300815c1ea987e76e92b71122f
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-11 16:37:20 +0900

    fix ivar with shareable objects issue

    Instance variables of sharable objects are accessible only from
    main ractor, so we need to check it correctly.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3887

commit 31e8de2920935d500105949bda931f3ca22cdbff
  Author: nicholas a. evans <nicholas.evans@gmail.com>
  Date:   2020-11-18 09:23:51 +0900

    Let Fiber#raise work with transferring fibers

    This automatically choosess whether to use transfer on a transferring
    fiber or resume on a yielding fiber.  If the fiber is resuming, it
    raises a FiberError.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3795

commit e795b632467317cdea07d0599bf2c5d08b403f00
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-12 00:29:02 +0900

    * 2020-12-12 [ci skip]

commit abbc43413c5cc2a2c26520d22856e316041ea3d1
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2020-12-12 00:28:08 +0900

    Remove unused link [ci skip]

commit eea756ac861dc7d4a1de67741c8730cb3ca868ca
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-11 23:14:36 +0900

    Strip trailing spaces [ci skip]

commit 68d3952c52de3b7cf4aba10d61085244f1bf449b
  Author: ima1zumi <mariimaizumi5@gmail.com>
  Date:   2020-12-11 22:18:36 +0900

    [ruby/reline] Fix breaking to input Emoji with ZWJ.

    https://github.com/ruby/reline/commit/f21dfdbb11

commit ed343c76fbd94dfcd429668b72844e0db87a0b46
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-11 19:54:14 +0900

    RDoc states that Process::Status.wait returns nil if cannot wait

commit 1728eba48a163c09c0e2a918c13d5c08961bf9a9
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-11 19:40:25 +0900

    [DOC] Fixed the RDoc location of Process::Status.wait [ci skip]

commit 885135f84cd609fb1c7be3fa0a20ae77969eae9d
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-11 14:56:48 +0900

    Allow an MJIT worker to show a backtrace on SEGV

    An MJIT worker thread doesn't have ec, and it's required for SDR() and
    rb_backtrace_print_as_bugreport(). Therefore it must be checked.

commit 4439b783366aa8d7dddbb39673f4074bb062f3d6
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-11 14:36:42 +0900

    Save a core file from bootstraptest

commit a6a68bae3ced278bb41a42d363a0eaee86fa31bd
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-11 14:16:35 +0900

    Removed needless gemspec of webrick

commit 947a5505e50de1321fd26bf9a5b016be33ae189c
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-11 14:15:52 +0900

    Bump webrick-1.7.0 for version management with ruby/webrick.

commit bca57b911a185ab3d0fe19f6f739f6b27bfd48c5
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-11 14:09:34 +0900

    [DOC] Moved RDoc of abort [ci skip]

commit c718c300079573392d4de6f51fbb28b3a34c5341
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-10-04 00:07:37 +0900

    addr2line.c: support debuglink by build_id

    Currently, addr2line.c supports only one path format of debuglink:
    "/usr/lib/debug/usr/bin/ruby.debug".

    However, recent debian packages seem to use another format by build_id:
    "/usr/lib/debug/.build-id/ab/cdef1234.debug".

    https://github.com/Debian/debhelper/blob/5d1bb29841043d8e47ebbdd043e6cd086cad508e/dh_strip#L292
    https://github.com/Debian/debhelper/blob/5d1bb29841043d8e47ebbdd043e6cd086cad508e/dh_strip#L353

    This changeset makes ruby backtrace support the second format.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3627

commit 8c5ec10038a9bbc328eeb3756da207ba5976072d
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-11 10:54:06 +0900

    Link zlib always if available

    Major Linux distribution packages including Debian, Ubuntu, and Fedora
    use `--compress-debug-sections=no` to build ruby, and then extract and
    compress debug symbols as separate files. However, the configure option
    makes ruby not link zlib, thus the generated binary cannot uncompress
    the compressed separate debug symbol files, and fails to show C level
    backtrace when a critical error like segfault occurs.

    This change makes ruby always link zlib if it is available so that it
    can show C level backtrace correctly.

    Related: Debian packages require https://github.com/ruby/ruby/pull/3627
    to load debug symbol files.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3884

commit 288e93bea872e99ccf706294dc63b8a2b139ea2c
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-11 13:40:03 +0900

    Exclude parenthesized function declarations such as NORETURN

    Fixes https://github.com/ruby/ruby/pull/3883

commit b53ccb9c69abd24e3bdad66cbe4c7e7480eaef16
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-11 11:54:50 +0900

    show deprecation warning correctly for lambda(&b)

    lambda(&b) where b is given block of method (like: def foo(&b))
    should warn correctly.
    [Feature #17361]

    Also labmda(&labmda_block) or lambda(&:to_s) (Symbol#to_proc)
    should not warn (but I'm not sure who cares about it).

commit ad6573163f4a7b7eedb904f2f6f730c3cd2669e3
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-11 11:52:19 +0900

    add RUNOPT and RUNOPT0 for dev rules.

    run, runruby, ... accept RUNOPT and RUNOPT0 configuration to pass
    some commandline argument like that:

      $(BTESTRUBY) $(RUNOPT0) $(TESTRUN_SCRIPT) $(RUNOPT)

    RUNOPT0 is options for ruby interpreter (-w, -v, ...)
    RUNOPT is options for the script (ARGV/ARGF)

commit 56918578ea48ef3bc6a5f27f884fb2cccbe02c06
  Author: Masaki Matsushita <glass.saga@gmail.com>
  Date:   2020-12-11 11:13:13 +0900

    Remove unimplemented parameter from comment

    :resolv_timeout of TCPSocket.new is not implemented for now.

commit 974e89ae0743e591f0034de6c8dfc41a81d6429d
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-11 09:54:34 +0900

    revert da3bca513f437b05b3953c3712ff48621fc5e008

    It seems introduce critical problems. Now I could not find
    out the issue.

    http://ci.rvm.jp/results/trunk-test@ruby-sky1/3286048

commit 9b0c36b39032cffff3c62a2b0e1fc38fa429f5ea
  Author: Kenta Murata <mrkn@users.noreply.github.com>
  Date:   2020-12-11 09:41:12 +0900

    Import fiddle-1.0.4 (#3860)

    I don't use tool/sync_default_gem.rb because the last sync was incomplete.

    Co-authored-by: Hiroshi SHIBATA <hsbt@ruby-lang.org>
    Co-authored-by: Alan Wu <XrXr@users.noreply.github.com>
    Co-authored-by: sinisterchipmunk <sinisterchipmunk@gmail.com>
    Co-authored-by: Sutou Kouhei <kou@clear-code.com>

  Notes:
    Merged-By: mrkn <mrkn@ruby-lang.org>

commit 6b1d2de6cc2e85fda7885fe77dbd7c99c4eb1ef2
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-11 07:40:22 +0900

    Unfortunately getinstancevariable was still not leaf

    https://github.com/ruby/ruby/runs/1533401436

commit 97868f16ff764e60176e817db101e65c9d58eff3
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-11 06:00:02 +0900

    Reintroduce the fix again

commit 4474aadae8d6610cc5b1c62156739d4245a1a38c
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-11 04:48:54 +0900

    Fix the path properly

    :disappointed:

commit f56ab7a4764131e5c01e279623e2a141442426a8
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-11 04:18:23 +0900

    Try fixing the -I position

    https://github.com/ruby/ruby/runs/1532260149
    :thinking:

commit dca13e2bf7b7efeb2841a039e3cfd7b5cd650a7b
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-12-09 02:00:04 +0900

    Make ruby -We the same as ruby -W -e

    This changes the behavior, which I'm not sure is acceptable.
    However, it's odd to allow an option to be combined, but change
    the behavior of the option when combined.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3867

commit 699608487d2ff09bb5c610a9d1e6e13f5bd2a25e
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-12-11 00:36:55 +0900

    Make getinstancevariable a leaf instruction

    It can no longer issue a warning.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3879

commit 01b7d5acc702df22d306ae95f1a9c3096e63e624
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-12-10 13:53:02 +0900

    Remove the uninitialized instance variable verbose mode warning

    This speeds up all instance variable access, even when not in
    verbose mode.  Uninitialized instance variable warnings were
    rarely helpful, and resulted in slower code if you wanted to
    avoid warnings when run in verbose mode.

    Implements [Feature #17055]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3879

commit 4a559aa22537bbd2f17c7babb1aca48d1a3a4647
  Author: MSP-Greg <MSP-Greg@users.noreply.github.com>
  Date:   2020-12-11 02:27:02 +0900

    Actions mingw - add tool/test for WEBrick in spec tests (#3882)

    Some spec tests require WEBrick, and the spec tests are run from install with the MinGW CI.

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit f3c19ddfbcfde63505a34b7a5b3a640f23b22dc0
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-11 00:09:09 +0900

    Show C backtrace appropriately at core dump for GCC 8 or later

    When ruby is compiled by GCC 8 or later, some frames of C level
    backtrace information lacks.

    ```
    $ ./miniruby -e '1.times { Process.kill(:SEGV, $$) }'

    ...

    -- C level backtrace information
    -------------------------------------------
    /home/mame/work/ruby-gcc-9/miniruby(rb_vm_bugreport+0x611) [0x558a5fdcbc21] ../ruby/vm_dump.c:758
    [0x558a5fbc789a]
    /home/mame/work/ruby-gcc-9/miniruby(sigsegv+0x4d) [0x558a5fd1eaed] ../ruby/signal.c:959
    /lib/x86_64-linux-gnu/libpthread.so.0(__restore_rt+0x0) [0x7f687e6713c0]
    /lib/x86_64-linux-gnu/libc.so.6(kill+0xb) [0x7f687e31355b] ../sysdeps/unix/syscall-template.S:78
    /home/mame/work/ruby-gcc-9/miniruby(rb_f_kill+0x350) [0x558a5fd1fe60] ../ruby/signal.c:480
    [0x558a5fda50d3]
    [0x558a5fdb085c]
    [0x558a5fdb0fe7]
    [0x558a5fdbae1a]
    [0x558a5fdaf484]
    /home/mame/work/ruby-gcc-9/miniruby(rb_yield_1+0x29f) [0x558a5fdb2fbf] ../ruby/vm.c:1265
    /home/mame/work/ruby-gcc-9/miniruby(int_dotimes+0x5c) [0x558a5fc72f2c] ../ruby/numeric.c:5198
    [0x558a5fda50d3]
    [0x558a5fdb085c]
    [0x558a5fdb0fe7]
    [0x558a5fdbaf21]
    [0x558a5fdaf484]
    /home/mame/work/ruby-gcc-9/miniruby(rb_ec_exec_node+0xed) [0x558a5fbcc4fd] ../ruby/eval.c:317
    /home/mame/work/ruby-gcc-9/miniruby(ruby_run_node+0x4f) [0x558a5fbd110f] ../ruby/eval.c:375
    /home/mame/work/ruby-gcc-9/miniruby(main+0x73) [0x558a5fb2c083] ../ruby/main.c:50
    ```

    By this one-line change, it shows all locations.

    ```
    $ ./miniruby -e '1.times { Process.kill(:SEGV, $$) }'

    ...

    -- C level backtrace information -------------------------------------------
    /home/mame/work/ruby-gcc-9/miniruby(rb_print_backtrace+0x11) [0x558247adec21] ../ruby/vm_dump.c:758
    /home/mame/work/ruby-gcc-9/miniruby(rb_vm_bugreport) ../ruby/vm_dump.c:956
    /home/mame/work/ruby-gcc-9/miniruby(rb_bug_for_fatal_signal+0x15a) [0x5582478da89a] ../ruby/error.c:773
    /home/mame/work/ruby-gcc-9/miniruby(sigsegv+0x4d) [0x558247a31aed] ../ruby/signal.c:959
    /lib/x86_64-linux-gnu/libpthread.so.0(__restore_rt+0x0) [0x7f82202f73c0]
    /lib/x86_64-linux-gnu/libc.so.6(kill+0xb) [0x7f821ff9955b] ../sysdeps/unix/syscall-template.S:78
    /home/mame/work/ruby-gcc-9/miniruby(rb_f_kill+0x350) [0x558247a32e60] ../ruby/signal.c:480
    /home/mame/work/ruby-gcc-9/miniruby(vm_call_cfunc_with_frame+0x123) [0x558247ab80d3] ../ruby/vm_insnhelper.c:2821
    /home/mame/work/ruby-gcc-9/miniruby(vm_call_method_each_type+0x7c) [0x558247ac385c] ../ruby/vm_insnhelper.c:3324
    /home/mame/work/ruby-gcc-9/miniruby(vm_call_method+0xc7) [0x558247ac3fe7] ../ruby/vm_insnhelper.c:3428
    /home/mame/work/ruby-gcc-9/miniruby(vm_sendish+0x14) [0x558247acde1a] ../ruby/vm_insnhelper.c:4412
    /home/mame/work/ruby-gcc-9/miniruby(vm_exec_core) ../ruby/insns.def:789
    /home/mame/work/ruby-gcc-9/miniruby(rb_vm_exec+0x1a4) [0x558247ac2484] ../ruby/vm.c:2165
    /home/mame/work/ruby-gcc-9/miniruby(rb_yield_1+0x29f) [0x558247ac5fbf] ../ruby/vm.c:1265
    /home/mame/work/ruby-gcc-9/miniruby(int_dotimes+0x5c) [0x558247985f2c] ../ruby/numeric.c:5198
    /home/mame/work/ruby-gcc-9/miniruby(vm_call_cfunc_with_frame+0x123) [0x558247ab80d3] ../ruby/vm_insnhelper.c:2821
    /home/mame/work/ruby-gcc-9/miniruby(vm_call_method_each_type+0x7c) [0x558247ac385c] ../ruby/vm_insnhelper.c:3324
    /home/mame/work/ruby-gcc-9/miniruby(vm_call_method+0xc7) [0x558247ac3fe7] ../ruby/vm_insnhelper.c:3428
    /home/mame/work/ruby-gcc-9/miniruby(vm_sendish+0x14) [0x558247acdf21] ../ruby/vm_insnhelper.c:4412
    /home/mame/work/ruby-gcc-9/miniruby(vm_exec_core) ../ruby/insns.def:770
    /home/mame/work/ruby-gcc-9/miniruby(rb_vm_exec+0x1a4) [0x558247ac2484] ../ruby/vm.c:2165
    /home/mame/work/ruby-gcc-9/miniruby(rb_ec_exec_node+0xed) [0x5582478df4fd] ../ruby/eval.c:317
    /home/mame/work/ruby-gcc-9/miniruby(ruby_run_node+0x4f) [0x5582478e410f] ../ruby/eval.c:375
    /home/mame/work/ruby-gcc-9/miniruby(main+0x73) [0x55824783f083] ../ruby/main.c:50
    ```

    Details:

    In short, it is an uninitialized variable bug.

    Until GCC 7, all function locations are represented by a pair of
    DW_AT_low_pc and DW_AT_high_pc in DWARF information.
    But since GCC 8, some functions are split to multiple chunks, which are
    represented by DW_AT_ranges.
    DW_AT_ranges are represented as offsets from a base address.
    According to DWARF specification, it is the base address of the
    compilation unit, but GCC seems to use zero as default.
    The function "di_read_cu" in addr2line.c had a comment about the fact.
    However, the base address wasn't initialized as zero.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3881

commit 7f4c31d6a38f11046bb9e5a9aa1139d91c0eb289
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-11 01:19:47 +0900

    * 2020-12-11 [ci skip]

commit b72f613210de7b80ce76edb9beef2101d4311d68
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-11 00:56:06 +0900

    Suppress a "clobbered" warning by gcc on macOS

commit 673fcb7e9a31b0021783dfe73b41eeb5210b6b28
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2020-12-10 21:48:04 +0900

    Fix a link [ci skip]

commit 73db60bdda64fab43f6ba4d1902337a39715fd91
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-10 21:41:47 +0900

    include/ruby/memory_view.h: fix the return type of rb_memory_view_prepare_item_desc

commit 0fcd478a4e50af309ad8a1a7afc3e121609ebbf3
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-10 21:35:53 +0900

    include/ruby/memory_view.h: fix typo

commit d5dfc3f2c833d62e4e0fb3145ed729f48b8e2a66
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2020-12-10 21:04:57 +0900

    Use `abort(message)` instead of `puts` and `exit`

commit 78f188524f551c97b1a7a44ae13514729f1a21c7
  Author: Masaki Matsushita <glass.saga@gmail.com>
  Date:   2020-09-25 16:20:18 +0900

    Add connect_timeout to TCPSocket

    Add connect_timeout to TCPSocket.new in the same way as Socket.tcp.

    Closes [Feature #17187]

commit 658b4ff60934b9fb6845e214fda83229e631e366
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-10 18:55:03 +0900

    Fixed the test failures called WEBrick.new directly

commit 72f1c43584df714a011864ca9fafc6e15ace392c
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-10 13:27:08 +0900

    ObjectSpace._id2ref should not support unshareable

    ObjectSpace._id2ref(id) can return any objects even if they are
    unshareable, so this patch raises RangeError if it runs on multi-ractor
    mode and the found object is unshareable.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3878

commit 7856da5fe75a76bec909778e411270c10a04ca3a
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2020-12-09 17:41:21 +0900

    remove bz2

commit 142f154a0a0863dc48cf767b2d1b5acec0371999
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-10 18:16:15 +0900

    Unpoison freelist to chain

commit 9a17437558e42aa1da372b515ba8bc18067d578c
  Author: Lourens Naudé <lourens@bearmetal.eu>
  Date:   2019-11-26 22:07:49 +0900

    Right size literal regular expression buffers on compile

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2696

commit e7433a3288b48f90447bc8ebb1531f57be17392c
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-10 16:20:21 +0900

    Added help message for gem i webrick in rdoc

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3729

commit 4ccc66265cdef0480eb6ff46f6be9f8de1a01891
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-11-03 07:14:36 +0900

    Added help message for gem i webrick in gem server command

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3729

commit b084f8abcf5b7310ce8f08d48a1a3f3e56876123
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-11-03 07:11:40 +0900

    Completely removed webrick

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3729

commit 880727f037ee7dfeeb3dbc9027622798d46fdbac
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-11-02 20:02:12 +0900

    Added help message for gem i webrick in un.rb

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3729

commit 05cc58c2ebc467ebc18897b1aef2c2089b26adf3
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-11-02 19:58:57 +0900

    webrick was removed from ruby repo

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3729

commit 0e73b49b4c35a3ae8fd5530a730556b4e4ef4377
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-11-02 19:57:27 +0900

    Promote webrick to bundled gems

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3729

commit 087ac34fb2f6fa74bd84a290d511f4d47a286119
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-11-02 16:48:20 +0900

    Added tool/lib into test-spec loadpath

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3729

commit 5dc786bf86bb6e0da2639f88659598ec8b9db30d
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-11-02 13:44:28 +0900

    Move webrick library into internal test toolchain

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3729

commit 46d3ea2c2569e2e5a9ee3e7e206f07f0f8b693f5
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2020-12-10 17:41:39 +0900

    .github: reduce (#3876)

    Comment out some 50-ish tests.
    fix https://bugs.ruby-lang.org/issues/17376

commit 9e8f732f397ec73ebcab2d121f02c909c8f06755
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-10 17:21:59 +0900

    Revert "Revert some recent JIT changes"

    This reverts commit b7dc04e51823f9fe8b5355c30a304ecdb11fe5ed.

    This should be fine, rather necessary, too.

commit 12a1a2518161bda1d893920f70e936c82925e758
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-10 17:21:33 +0900

    Revert "Revert "Have list_node at the top of rb_mjit_unit""

    This reverts commit 73b07c437e24711c23dd2dd01d3ffc5f1012e046.

    This was, of course, innocent.

commit 16c765990ceaf5fb1efaeba2850083cfec7c137e
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-10 17:17:59 +0900

    Use list_for_each_safe when list_del is used inside

    list_for_each seems to cause all the SEGVs we've seen.

commit da3bca513f437b05b3953c3712ff48621fc5e008
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-10 10:58:25 +0900

    cache free pages per ractor

    Per ractor method cache (GH-#3842) only cached 1 page and this patch
    caches several pages to keep at least 512 free slots if available.
    If you increase the number of cached free slots, all cached slots
    will be collected when the GC is invoked.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3875

commit 554c0949777cd495e5a1296bd6719fcf508a70d0
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-10 10:38:30 +0900

    set min/maximum free slots relative to ractor cnt

    A program with multiple ractors can consume more objects per
    unit time, so this patch set minimum/maximum free_slots to
    relative to ractors count (upto 8).

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3875

commit eafe000af3d363f6cb65be99edcfccedf35d801c
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-10 10:28:53 +0900

    lazy sweep tries to collect 2048 slots

    Lazy sweep tries to collect free (unused) slots incrementally, and
    it only collect a few pages. This patch makes lazy sweep collects
    more objects (at least 2048 objects) and GC overhead of multi-ractor
    execution will be reduced.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3875

commit 2544f7196ee7d157000244ca9cac55514e3b193d
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-10 00:58:44 +0900

    test/ruby/test_arithmetic_sequence.rb: restore test_last_bug17218

    And rename the existing `test_last_bug17218` to `test_to_a_bug17218`.

commit bb489aca5815acf3afd43ec9e3cdae008d882e3a
  Author: Kenta Murata <mrkn@users.noreply.github.com>
  Date:   2020-12-10 00:24:36 +0900

    memory_view.c: Add rb_memory_view_get_item and rb_memory_view_prepare_item_desc (#3871)

  Notes:
    Merged-By: mrkn <mrkn@ruby-lang.org>

commit 549118b3e29713835226d4088ba65f58eee7c054
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-10 00:17:44 +0900

    * 2020-12-10 [ci skip]

commit 3156fb0f2c3ebf8229f392c8502c08fe165ab181
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-10 00:16:49 +0900

    test/ruby/test_arithmetic_sequence.rb: remove a duplicated test

    There is another "test_last_bug17218"

commit fad3023e94c45e7f03478732f7641b6f39ba9d12
  Author: Kenta Murata <mrkn@users.noreply.github.com>
  Date:   2020-12-09 18:48:59 +0900

    Fix ArithmeticSequence#last and ArithmeticSequence#each for non-integer sequences (#3870)

    [Bug #17218]
    [ruby-core:100312]

  Notes:
    Merged-By: mrkn <mrkn@ruby-lang.org>

commit cacdf2681dcc7c431973f33a18979b10566ec2f9
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-09 18:21:00 +0900

    [ruby/matrix] Disable Ractor test

commit 150dbb656dd8c479f32db3bc83ae9fc57fe48608
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-09 14:30:05 +0900

    [ruby/matrix] v0.3.1

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3869

commit a7dccd08e7c9cf0e5d0c0fdbe659ccc921624e6f
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-09-27 04:49:43 +0900

    [ruby/matrix] Make frozen matrices Ractor shareable

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3869

commit 6b264e833f9b9c86819feff88048ffcdf8d67af8
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-09 15:24:16 +0900

    [ruby/prime] Fix gemspec

commit 45b29754cfba8435bc4980a87cd0d32c648f8a2e
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-09 14:49:06 +0900

    need the lock for debug checking.

    Checking code (RGENGC_CHECK_MODE > 0) need a VM lock because it
    refers objspace.

commit 47ff8de645b6791f961f2c971436f035534209a5
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-09 15:03:29 +0900

    Update maintainers list [doc] [ci skip]

commit b603085d2f4b997541247f8eab864f92f9b5f006
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-09 14:45:56 +0900

    [ruby/prime] v0.1.2

commit 1866d483dce614a02c5186bd0588b48a5041e55e
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-05 14:20:39 +0900

    [ruby/prime] Optimize `Integer#prime?`

    Miller Rabin algorithm can be used to test primality for integers smaller than a max value "MaxMR" (~3e24)

    It can be much faster than previous implementation: ~100x faster for numbers with 13 digits, at least 5 orders of magnitude for even larger numbers (previous implementation is so slow that it requires more patience than I have for more precise estimate).

    Miller Rabin test becomes faster than previous implementation at somewhere in the range 1e5-1e6. It seems that the range 62000..66000 is where Miller Rabin starts being always faster, so I picked 0xffff arbitrarily; before that, or above "MaxMR", the previous implementation remains.

    I compared the `faster_prime` gem too. It is slower than previous implementation up to ~1e4. After that it becomes faster and faster compared to previous implementation, but is still slower than Miller Rabin starting at ~1e5 and up to MaxMR. Thus, after this commit, builtin `Integer#prime?` will be similar or faster than `faster_prime` up to "MaxMR".

    Adapted from patch of Stephen Blackstone [Feature #16468]

    Benchmark results and code: https://gist.github.com/marcandre/b263bdae488e76dabdda84daf73733b9

    Co-authored-by: Stephen Blackstone <sblackstone@gmail.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3847

commit dea600046aa5895e745a8d655ff90616705e11a6
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-09 13:10:28 +0900

    Ad-hoc fix of test-bundler

commit b419f90a8bc3e472635a813e56cc2153b3125b41
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-09 11:49:20 +0900

    Tweaked `Process::Status.wait`

    * revert `rb_last_status_set`
    * renamed the new function as `rb_process_status_new`
    * `rb_process_status_new` always freezes the return value
    * marked `Process::Status.wait` as EXPERIMENTAL, as it has not
      been discussed totally yet.

commit 4f907a80f04292e472d2eea660c4f5c0cb62e00f
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-09 11:32:18 +0900

    Removed declaration of non-existent symbol

commit 27b6df9653e88e83c6a524149ef44070802770c5
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-10-24 06:42:48 +0900

    Add test that `Ractor.make_shareable` calls user defined `#freeze`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3694

commit 2553c5f94a5d51c2c5876b31e4c1521ad9be12f6
  Author: Samuel Williams <samuel.williams@oriontransfer.co.nz>
  Date:   2020-12-08 05:29:09 +0900

    Add support for non-blocking `Process.wait`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3853

commit a4a92ae6d99a75e11165ca09c44ccf47cf342047
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-09 01:41:06 +0900

    * 2020-12-09 [ci skip]

commit ee194af2aa170c0cb1bfd5fed4e84259a8150ece
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-08 00:42:20 +0900

    re-layout rb_ractor_t

    separate synchronization data and ractor local data.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3858

commit 2749123e213007e20d2f5e65ce941ff53feb4c76
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-08 19:33:43 +0900

    Supported category option in Warning#warn

commit d5ffa4e9a43ebdd451fb2c46529d301dec03f666
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-08 19:32:33 +0900

    [DOC] mentioned category option

commit 2427393b4d1ea0557362b106044e3aba3da32370
  Author: Kenta Murata <mrkn@users.noreply.github.com>
  Date:   2020-12-08 21:58:08 +0900

    Revert "test/fiddle/helper.rb: remove duplication (#3863)" (#3865)

    This reverts commit bd47a8d660ab33a20c5e28d0effcc29105c434e4.

    `libc_so` and `libm_so` are `nil` at line 124 because Big Sur doesn't have `/usr/lib/libSystem.B.dylib`.
    The reassignment at line 127 is necessary in this case.

  Notes:
    Merged-By: mrkn <mrkn@ruby-lang.org>

commit 30d4a7ad9a1f629d84b9b0e22db4ba146e63fd61
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-08 21:42:03 +0900

    Update rubygems.org links for published default gems.

commit 09229c71bcdc82b2e7c3138baa4cb2696b97ec5d
  Author: Samuel Williams <samuel.williams@oriontransfer.co.nz>
  Date:   2020-12-08 17:21:28 +0900

    Fix "Ruby is not properly fortified on armv7hl".


    See <https://bugs.ruby-lang.org/issues/16762> for more details.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3866

commit aeeaf90b7ee8230425e8c68cb9cfc962b0a186f4
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-08 18:38:25 +0900

    Added missing dependency of fileutils

commit d7a16670c30160cf7f0d57d2a970faefb331a024
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-08 17:49:51 +0900

    [DOC] Fixed RDoc directives [ci skip]

commit 86332cdce900ab5777962696c5dea676f731c8dc
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-08 16:43:48 +0900

    Bump version numbers of RubyGems and Bundler on NEWS

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3864

commit 473f9d2df0ddd7fdb5cc73fa3ad49b2f19f22b06
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-08 16:36:29 +0900

    Merge prepare version of Bundler 2.2.0

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3864

commit 4aca77edde91f826aa243e268bf1ef5214530583
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-08 16:33:39 +0900

    Merge prepare version of RubyGems 3.2.0

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3864

commit 6a6a24df9b72750d12f9b15192bdb7517e668efb
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2020-12-08 16:53:25 +0900

    Fix links [ci skip]

commit 4b583d4928d1797b35d99b7fc9666e0b4cbed136
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2020-12-08 16:46:14 +0900

    Add NEWS about UTF-8 on Windows

    * 94b6933d1c6f4c8698319fbcac9dcecc9033b4b9
    * ca76337a00244635faa331afd04f4b75161ce6fb

commit 509241b39f2569b2c3ee9bb9f6d217a1e9d419db
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2020-12-08 16:37:41 +0900

    Add NEWS about Net::SMTP [ci skip]

commit bd47a8d660ab33a20c5e28d0effcc29105c434e4
  Author: Kenta Murata <mrkn@users.noreply.github.com>
  Date:   2020-12-08 15:42:31 +0900

    test/fiddle/helper.rb: remove duplication (#3863)

  Notes:
    Merged-By: mrkn <mrkn@ruby-lang.org>

commit b7dc04e51823f9fe8b5355c30a304ecdb11fe5ed
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-08 14:06:00 +0900

    Revert some recent JIT changes

    Revert "Lock the entire active_units loop"

    This reverts commit 5c2ff88be2e515613dfe54823e8429656f688e9f.

    Revert "Lock active_units references on compaction"

    This reverts commit 556a7285080c1344c75bb93a333c9bfc5d631c61.

    Revert "Wait for GC before unload_units"

    This reverts commit a8f16df615daa55901bb351efe038e86b61fbb92.

    Well, the previous revert actually didn't fix it, but this series of
    reverts seems to rollback the situation a little.

commit 73b07c437e24711c23dd2dd01d3ffc5f1012e046
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-08 14:02:21 +0900

    Revert "Have list_node at the top of rb_mjit_unit"

    This reverts commit 3319ce37651aa7e50c31b5fba14871938318b37a.

    I still haven't figured out why, but this seems to have increased the
    failure rate.

commit a8f16df615daa55901bb351efe038e86b61fbb92
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-08 12:57:15 +0900

    Wait for GC before unload_units

commit ea18c8bb96c019a609b37671ceec5f51d61476cd
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-08 11:43:42 +0900

    Made method-local instance variables local variables

commit 5c2ff88be2e515613dfe54823e8429656f688e9f
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-08 08:33:29 +0900

    Lock the entire active_units loop

    The previous fix seems not working. Let me test if this works.

commit 41fafd9dd29717cfa9fcf6331d9da88f49da4916
  Author: MSP-Greg <MSP-Greg@users.noreply.github.com>
  Date:   2020-12-08 07:47:42 +0900

    Remove BUNLDER_VERSION in Windows (#3859)

    [Bug #17372]

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 2580093d5deb9940700aa5faa5bed3af405d989f
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-08 07:21:21 +0900

    Pass the flag as $TESTOPTS

    Fixing the failure of a4f292426b40f9d6c8f3d646e4b7c667313074f2 like
    https://github.com/ruby/ruby/runs/1513663542

commit 3319ce37651aa7e50c31b5fba14871938318b37a
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-08 06:54:04 +0900

    Have list_node at the top of rb_mjit_unit

    to convert list_node to rb_mjit_unit easily in gdb.

commit a4f292426b40f9d6c8f3d646e4b7c667313074f2
  Author: NARUSE, Yui <naruse@airemix.jp>
  Date:   2020-12-08 05:45:22 +0900

    skip failing tests in test-all on mingw

    https://bugs.ruby-lang.org/issues/17372

commit 146b3695c0e1ea0d6cf00442d5524f97d8a75296
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-08 02:09:53 +0900

    ruby.c: remove needless substitution of uenc

    uenc has already been initialized the top of the function.

commit 7e69296a2be8db8814aa0cd0ce6471b80d55b464
  Author: Kenta Murata <mrkn@users.noreply.github.com>
  Date:   2020-12-08 02:01:31 +0900

    memory_view.c: Add rb_memory_view_extract_item_members (#3855)

  Notes:
    Merged-By: mrkn <mrkn@ruby-lang.org>

commit ca76337a00244635faa331afd04f4b75161ce6fb
  Author: Lars Kanis <kanis@comcard.de>
  Date:   2020-12-08 02:00:39 +0900

    Windows: Read ENV names and values as UTF-8 encoded Strings (#3818)

    * Windows: Read ENV names and values as UTF-8 encoded Strings

    Implements issue #12650: fix https://bugs.ruby-lang.org/issues/12650

    This also removes the special encoding for ENV['PATH'] and some
    complexity in the code that is unnecessary now.

    * Windows: Improve readablity of getenv() encoding

    getenv() did use the expected codepage as an implicit parameter of the macro.
    This is mis-leading since include/ruby/win32.h has a different definition.
    Using the "cp" variable explicit (like the other function calls) makes it
    more readable and consistent.

    * Windows: Change external C-API macros getenv() and execv() to use UTF-8

    They used to process and return strings with locale encoding,
    but since all ruby-internal spawn and environment functions use UTF-8,
    it makes sense to change the C-API equally.

  Notes:
    Merged-By: nurse <naruse@airemix.jp>

commit 94b6933d1c6f4c8698319fbcac9dcecc9033b4b9
  Author: Lars Kanis <kanis@comcard.de>
  Date:   2020-12-08 01:48:37 +0900

    Set default for Encoding.default_external to UTF-8 on Windows (#2877)

    * Use UTF-8 as default for Encoding.default_external on Windows
    * Document UTF-8 change on Windows to Encoding.default_external

    fix https://bugs.ruby-lang.org/issues/16604

  Notes:
    Merged-By: nurse <naruse@airemix.jp>

commit 3bf7b999e503199e2e9fe68ade25ee6830b3e57e
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-12-06 17:45:05 +0900

    [ruby/reline] Editing to initial content is not just cursor moving

    https://github.com/ruby/reline/commit/0a4f175b0a

commit b5ef4ad3120eabd0a6107524ca9503c19afdc8a5
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-08 00:01:43 +0900

    * 2020-12-08 [ci skip]

commit 05e1d87e625d9903d53e13049d69848924aecd28
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-07 23:57:31 +0900

    rbinstall.rb: do not install useless files after installed

commit 91f831ac17c8ff58d536ce1fa320294bb477d2ae
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-07 23:47:37 +0900

    Extract gemspec to versioned file

    Not to be overwritten by test-bundler-prepare.  gem files often
    contain useless gemspec files which have not been processed.

commit e025113d71ca208255203f78cc85e9efa25bb23f
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-07 22:40:46 +0900

    rbinstall.rb: relaxed split argument

    did_you_mean splits the output by `$/`.

commit 5894ea5954db119fc818bb7030ed56cf46830c6d
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-07 22:27:29 +0900

    rbinstall.rb: fix the position to expand files

    As `spec.files` is used for `executables` and so on, the expanded
    list needs to be located at the same place.

commit c6b37cb169f190bac46c76a643350ee4ffc3dfca
  Author: Masaki Matsushita <glass.saga@gmail.com>
  Date:   2020-12-07 21:32:25 +0900

    Remove resolv_timeout of TCPSocket.new from NEWS

    We couldn't support it for now, because getaddrinfo_a(3)
    was reverted in 5d8bcc4870. `resolv_timeout` will be just ignored.

commit 29dee10af28e5766916ad3aa93401508508d53e2
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-07 19:09:23 +0900

    rbinstall.rb: install files expanded from bundled gems

    Although gemspec file (e.g., power_assert and rake) often uses
    `git ls-files`, as it does not make sense in other than its own
    repository, it has been ignored now.  Gather all files expanded
    from the bundled gem to install, instead.

commit 7817a438eb1803e7b3358f43bd1f38479badfbdc
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-02 15:50:01 +0900

    Removed deprecated Time#succ

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3841

commit 20d53dad47064b28721d81ad0a98a25dcb0731c6
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-06 23:37:21 +0900

    Update the version guard to 3.0

commit 547c71dec47561571b4862dda0395fb0b08d6c1c
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2020-07-27 10:19:58 +0900

    Hash#index: delete

    Has been deprecated since 0c97c8e33584e6203bb09c08f92b63bd2cca8ae7.

commit 53ce71b5af09843e1f6dfac7d2f39fa4cf682b12
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-05 14:04:48 +0900

    Ractor.select requires an argument or yield_value

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3848

commit c2fa024e0220aca6e2437e56df2abf1a2368cbdf
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-07 16:01:35 +0900

    fix Thread's interrupt and Ractor#take issue

    Thread's interrupt set Ractor's wakeup_status as interrupted, but
    the status remains next Ractor communication API. This patch makes
    to ignore the previous interrupt state.
    [Bug #17366]

    Also this patch solves the Thread#kill and Ractor#take issues.

commit cc36e499f9403c2e3dd0514fc8f13ff485c10b82
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2020-12-07 12:37:18 +0900

    Doxygen terminology update [ci skip]

    Follow N2328 http://www.open-std.org/jtc1/sc22/wg14/www/docs/n2328.pdf

commit 5d8bcc4870601ab1ee05346346f241d4a805aac9
  Author: Masaki Matsushita <glass.saga@gmail.com>
  Date:   2020-12-07 12:49:44 +0900

    Revert getaddrinfo_a()

    getaddrinfo_a() gets stuck after fork().
    To avoid this, we need 1 second sleep to wait for internal
    worker threads of getaddrinfo_a() to be finished, but that is unacceptable.

    [Bug #17220] [Feature #17134] [Feature #17187]

commit 1ba05f5b2d7b1701242023b5ac156b169f1ded90
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-07 13:32:20 +0900

    need more lock in finalize_list()

    Some data should be accessed in parallel so they should be protected
    by the lock.

commit 556a7285080c1344c75bb93a333c9bfc5d631c61
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-07 13:23:19 +0900

    Lock active_units references on compaction

    This might race with mjit_recompile.

commit 4b4af40f5577263ae48813fed1593ba81c89c7e7
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-07 11:57:27 +0900

    Update TypeProf to 0.9.0 (#3856)

    * Update TypeProf to 0.9.0

  Notes:
    Merged-By: mame <mame@ruby-lang.org>

commit 0ebf6bd0a26b637f019d480ecd7f00a73c416b58
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-07 11:27:25 +0900

    RB_VM_LOCK_ENTER_NO_BARRIER

    Write barrier requires VM lock because it accesses VM global bitmap
    but RB_VM_LOCK_ENTER() can invoke GC because another ractor can wait
    to invoke GC and RB_VM_LOCK_ENTER() is barrier point. This means that
    before protecting by a write barrier, GC can invoke.
    To prevent such situation, RB_VM_LOCK_ENTER_NO_BARRIER() is introduced.
    This lock primitive does not become GC barrier points.

commit 8dd03e5cf0d583ffb836cf27be5645a7d88ac736
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-07 11:10:18 +0900

    skip assertion on multi-ractor

    This assertion is not considerred on multi-ractor mdoe.

commit bef3eb544025cc4bd4c9c7b87a8ffe4966db6faa
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-07 00:07:30 +0900

    fix decl of ruby_single_main_ractor

    On windows, MJIT doesn't work without this patch because of
    the declaration of ruby_single_main_ractor. This patch fix this
    issue and move the definition of it from ractor.c to vm.c to locate
    near place of ruby_current_vm_ptr.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3842

commit 344ec26a99e09c2d2f756fa6384e75ffa48f415f
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-06 15:41:21 +0900

    tuning trial: newobj with current ec

    Passing current ec can improve performance of newobj. This patch
    tries it for Array and String literals ([] and '').

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3842

commit 59ddb88da6bf483eeec7b85b8a85cf3719edf440
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-06 15:40:16 +0900

    RB_EC_NEWOBJ_OF

    NEWOBJ with current ec.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3842

commit 91d99025e4776885ceea809123a129cb31cd1db6
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-03 15:57:39 +0900

    per-ractor object allocation

    Now object allocation requires VM global lock to synchronize objspace.
    However, of course, it introduces huge overhead.
    This patch caches some slots (in a page) by each ractor and use cached
    slots for object allocation. If there is no cached slots, acquire the global lock
    and get new cached slots, or start GC (marking or lazy sweeping).

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3842

commit 1d0bf3d8dd8de40d498a7c2784a84aa566d290b9
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-05 05:42:44 +0900

    log for the beginning of vm_lock_enter

    Before this patch, there is no information to start locking.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3842

commit 554a7180a0aad85bee5cb8ed41d99d16dab304e7
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-02 04:10:05 +0900

    RB_VM_LOCK_ENTER_CR_LEV

    This is variant of RB_VM_LOCK_ENTER_LEV, but accept current racotr's
    pointer.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3842

commit 23f9447429a1bbb262aa19afd9a2a1ad0eba8ca6
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-05 05:38:50 +0900

    show ractor info on non-single ractor mode

    Without this patch, Ruby doesn't show ractor's information when
    there is only 1 ractor. However it is hard to read the log when
    some ractors are created and terminated. This patch makes to keep
    showing ractor's information on multi-ractor mode.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3842

commit 307732ccee7f9f28f8422bab2f839da021d8cdec
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-05 06:15:17 +0900

    cancel theap on multi-ractors

    accessing theap needs complicating synchronization but it reduce
    performance on multi-ractor mode. So simply stop using theap
    on multi-ractor mode. In future, theap should be replaced with
    more cleaver memory strategy.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3842

commit b67b24d0f5e78481e6a306881b6858f0dec996ba
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-02 03:37:56 +0900

    ruby_single_main_ractor for single ractor mode

    ruby_multi_ractor was a flag that indicates the interpreter doesn't
    make any additional ractors (single ractor mode).
    Instead of boolean flag, ruby_single_main_ractor pointer is introduced
    which keeps main ractor's pointer if single ractor mode. If additional
    ractors are created, ruby_single_main_ractor becomes NULL.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3842

commit 60eabb1aa7d1d8ab83c49916bd8c3536daf5d03b
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-07 00:32:29 +0900

    Revert "memory_view.c: Add rb_memory_view_extract_item_members"

    This reverts the following three commits.

    - ce707079c153f389d861c91a8dccc510fab0e245
    - 1a76bb56b0ba99a19d1373c4c8ebac42e7b6f27c
    - 51500eedefa492699668ced3e07e330a9a4d53ee

commit f9fd99e601377b114e924fc1697f18098b520fdf
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-07 00:19:45 +0900

    * 2020-12-07 [ci skip]

commit ce707079c153f389d861c91a8dccc510fab0e245
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-07 00:18:55 +0900

    memory_view.c: suppress uninitialized warning

commit e427c5cc2a8cc1163bfef7fb84f06a3e709a93b5
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-06 23:47:49 +0900

    Update rbs

commit 1a76bb56b0ba99a19d1373c4c8ebac42e7b6f27c
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-06 23:24:45 +0900

    memory_view.c: Fix the argument type of rb_memory_view_extract_item_members

commit 51500eedefa492699668ced3e07e330a9a4d53ee
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-04 15:50:13 +0900

    memory_view.c: Add rb_memory_view_extract_item_members

commit 14580ebef9ab72fe542e8b1276604c69751c9057
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-06 22:19:36 +0900

    Update rbs

commit 3184cd85c7a539200665e47ef4dfbbac84224748
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-06 16:10:52 +0900

    Updated bundled gems

commit e4e2a33560ca1ec4543fd593b344a29d452f251f
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-06 15:59:46 +0900

    update-bundled_gems: support recent format, keep the tag to test

commit ea9f16a27fab68388532cf681e5f1dd79ef973c3
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-06 16:00:51 +0900

    update-bundled_gems: chomp ".git" suffix from the source code URI

commit 967ed35bbb2c42646b764ce9f72d69e609e2eafd
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-06 15:56:44 +0900

    Moved update-bundled_gems code to a tool

commit 18b2ce11b5b0736723aa321e77c67be4395c3297
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-12-06 15:31:52 +0900

    Mentioned numbered parameter assignment is a SyntaxError in NEWS [ci skip]

    Requested by Junichi Ito.

commit 5d07a21ccd50f4e966749bf5de70e343eed232ac
  Author: MSP-Greg <Greg.mpls@gmail.com>
  Date:   2020-12-06 04:59:07 +0900

    RubyGems certs - remove AddTrust, add GlobalSign Root R3

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3854

commit 76439eee68d2f1e56ac7a6ab38aceacf0b4b40c8
  Author: Masaki Matsushita <glass.saga@gmail.com>
  Date:   2020-12-06 01:16:33 +0900

    Call cleanup function for getaddrinfo_a(3) only before fork()

    Previously, rb_getaddrinfo_a_before_exec() is called from before_exec().
    However, the function needs to be called only before fork().
    The change moves it to before_fork().

commit a38d4473564c5620d272305e91c4133f08034138
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-06 01:05:14 +0900

    * 2020-12-06 [ci skip]

commit c56a1c1953bf25581a6a0cd4ade22d2691a920e0
  Author: Masaki Matsushita <glass.saga@gmail.com>
  Date:   2020-12-05 18:05:09 +0900

    Extend sleep time to 1.5 second in rb_getaddrinfo_a_before_exec()

    After 94d49ed31c, TestSocket#test_getaddrinfo_after_fork fails in some
    platforms. To avoid this, the change extends sleep time to 1.5 second.

commit 9dbb2bfd73e66106ec75fb9fff3ac38d85e40395
  Author: Benoit Daloze <eregontp@gmail.com>
  Date:   2020-12-05 19:40:00 +0900

    Wrap SortedSet with `ruby_version_is ""..."3.0"`

    * Using $ spec/mspec/tool/wrap_with_guard.rb 'ruby_version_is ""..."3.0"' spec/ruby/library/set/sortedset/**/*_spec.rb

commit bb3d70581972969a01c8ba7f2f3477ec92224f97
  Author: Benoit Daloze <eregontp@gmail.com>
  Date:   2020-12-05 19:36:22 +0900

    Add MSpec tool to automatically wrap spec files with a guard

commit d0bd43c332f95e5f227ffcd4eb0e6f7bfa942b2a
  Author: Benoit Daloze <eregontp@gmail.com>
  Date:   2020-12-05 19:16:32 +0900

    Revert "SortedSet was removed at a3db08d7b6ff119223f77e3df00b4f6deac971e2"

    * This reverts commit b06ffce4aef002dc47c3c5968181230e7ab8d7cc.
    * Do not revert specs, wrap them with `ruby_version_is` (tool for that in next commit).

commit 5e58a9033fa795b73c76a5bb6a2fb7782335acbd
  Author: Masaki Matsushita <glass.saga@gmail.com>
  Date:   2020-12-05 17:43:03 +0900

    Reduce timeout of test_getaddrinfo_after_fork

commit d2b7e1e4b24633608aba8ef1e00189b00ea2a1d8
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-05 14:46:34 +0900

    Protoized old pre-ANSI K&R style definitions

commit a83a51932dbc31b549e11b9da8967f2f52a8b07c
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-04 15:57:40 +0900

    [ruby/matrix] Optimize **

    Avoiding recursive call would imply iterating bits starting from
    most significant, which is not easy to do efficiently.
    Any saving would be dwarfed by the multiplications anyways.
    [Feature #15233]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3844

commit 3b5b309b7b3724849c27dc1c836b5348a8a82e23
  Author: Samuel Williams <samuel.williams@oriontransfer.co.nz>
  Date:   2020-11-10 06:21:14 +0900

    Proposed method for dealing with stack locals which have non-local lifetime.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3624

commit 15e23312f6abcbf1afc6fbbf7917a57a0637f680
  Author: Samuel Williams <samuel.williams@oriontransfer.co.nz>
  Date:   2020-10-03 14:42:04 +0900

    Rework the order of operations to avoid stack smashing.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3624

commit f4386413f16f9e492a74f6b65e981e20e22c4849
  Author: Robert Schulze <robert@dotless.de>
  Date:   2020-02-05 18:59:13 +0900

    Cope with frozen-string-literal

    When running irb 1.2.1 (2019-12-24) with frozen-string-literal enabled, it crashes in reline with `can't modify frozen String (FrozenError)`

    Steps to reproduce:

    `RUBYOPT="--enable-frozen-string-literal" irb`

commit 0cf073088ef1a0a3c7d49038ba2d67547b5ed16b
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-27 23:11:46 +0900

    [ruby/reline] Process insertion buffer forcibly

    https://github.com/ruby/reline/commit/89d49ec9e0

commit c2bd5b84d06f5e74afce72e4e4af06d7176453b2
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-26 19:13:34 +0900

    [ruby/reline] Support bracketed paste mode

    https://github.com/ruby/reline/commit/d1a6869322

commit 7624f5275713c3dd2d551058355d9a4544c2ef53
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-21 13:08:53 +0900

    [ruby/reline] Forced newline insertion is not just cursor moving

    https://github.com/ruby/reline/commit/0e30a49d03

commit 37a574b527f2c612be46ec8038ff52bf861bf82f
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-21 02:59:38 +0900

    [ruby/reline] Drop prompt list cache when num of lines is changed

    https://github.com/ruby/reline/commit/1959e22043

commit 2910684c45399eed4dcebda72637a37858b74a62
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-21 00:30:11 +0900

    [ruby/reline] Cache dynamic prompt for 0.5sec

    https://github.com/ruby/reline/commit/06b89d0e61

commit b763c5cdf09fab247a7ca9526bb27a63cf03a81d
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-20 17:13:15 +0900

    [ruby/reline] Stop rerendering if the cursor is only moved

    https://github.com/ruby/reline/commit/30e8eaf855

commit a297565a4e873b9de079510bca011dc3bb2fdf78
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-20 06:00:25 +0900

    [ruby/reline] Split #rerender method that is too huge

    https://github.com/ruby/reline/commit/d0fbc89253

commit 493f381c327d129cfc8329c20cdb13413710ac2f
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-20 04:14:44 +0900

    [ruby/reline] Version 0.1.9

    https://github.com/ruby/reline/commit/0b1b5e77ce

commit b545ab219b40323373596eb45b43f2599a7a3c61
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-19 22:59:16 +0900

    [ruby/reline] Stop rerendering whole screen when adding newline at end of buffer

    The rendering time in IRB has been reduced as follows:

      start = Time.now

      def each_top_level_statement
        initialize_input
        catch(:TERM_INPUT) do
          loop do
            begin
              prompt
              unless l = lex
                throw :TERM_INPUT if @line == ''
              else
                @line_no += l.count("\n")
                next if l == "\n"
                @line.concat l
                if @code_block_open or @ltype or @continue or @indent > 0
                  next
                end
              end
              if @line != "\n"
                @line.force_encoding(@io.encoding)
                yield @line, @exp_line_no
              end
              break if @io.eof?
              @line = ''
              @exp_line_no = @line_no

              @indent = 0
            rescue TerminateLineInput
              initialize_input
              prompt
            end
          end
        end
      end

      puts "Duration: #{Time.now - start} seconds"

    0.33sec -> 0.22sec

    https://github.com/ruby/reline/commit/496c6a1892

commit fb2fda9a27ed96d5100897e93cc31e155b9c41a8
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-18 15:21:57 +0900

    [ruby/reline] Optimize regexp handling for width

    The rendering time in IRB has been reduced as follows:

      start = Time.now

      [{"_id"=>"5f9072a4589a06d2d74b6028",
        "index"=>0,
        "guid"=>"6b3051e2-dbc7-4537-bdb9-6cd7bb5358a7",
        "isActive"=>true,
        "balance"=>"$1,442.84",
        "picture"=>"http://placehold.it/32x32",
        "age"=>34,
        "eyeColor"=>"blue",
        "name"=>{"first"=>"Ward", "last"=>"Levy"},
        "company"=>"HYPLEX",
        "email"=>"ward.levy@hyplex.us",
        "phone"=>"+1 (867) 568-3319",
        "address"=>"867 Cobek Court, Clara, Maryland, 3254",
        "about"=>
         "Exercitation eu ex aliqua sit. Pariatur aliquip incididunt sint id non consectetur ullamco Lorem ea mollit duis amet sint labore. Commodo laborum labore commodo officia in cillum adipisicing esse excepteur cupidatat adipisicing ut. Non esse incididunt voluptate aliquip cillum eu aute duis laboris sit et. Amet enim quis tempor occaecat excepteur exercitation excepteur deserunt amet cillum adipisicing.",
        "registered"=>"Monday, May 25, 2015 6:51 AM",
        "latitude"=>"16.001127",
        "longitude"=>"-72.377848",
        "tags"=>["dolore", "nostrud", "occaecat", "cillum", "nisi"],
        "range"=>[0, 1, 2, 3, 4, 5, 6, 7, 8, 9],
        "friends"=>
         [{"id"=>0, "name"=>"Alison Bryant"},
          {"id"=>1, "name"=>"Ester Espinoza"},
          {"id"=>2, "name"=>"Sullivan Kane"}],
        "greeting"=>"Hello, Ward! You have 7 unread messages.",
        "favoriteFruit"=>"apple"}]

      puts "Duration: #{Time.now - start} seconds"

    0.47sec -> 0.34sec

      start = Time.now

      "Exercitation eu ex aliqua sit. Pariatur aliquip incididunt sint id non consectetur ullamco Lorem ea mollit duis amet sint labore. Commodo laborum labore commodo officia in cillum adipisicing esse excepteur cupidatat adipisicing ut. Non esse incididunt voluptate aliquip cillum eu aute duis laboris sit et. Amet enim quis tempor occaecat excepteur exercitation excepteur deserunt amet cillum adipisicing."

      puts "Duration: #{Time.now - start} seconds"

    0.11sec -> 0.08sec

      start = Time.now

      def each_top_level_statement
        initialize_input
        catch(:TERM_INPUT) do
          loop do
            begin
              prompt
              unless l = lex
                throw :TERM_INPUT if @line == ''
              else
                @line_no += l.count("\n")
                next if l == "\n"
                @line.concat l
                if @code_block_open or @ltype or @continue or @indent > 0
                  next
                end
              end
              if @line != "\n"
                @line.force_encoding(@io.encoding)
                yield @line, @exp_line_no
              end
              break if @io.eof?
              @line = ''
              @exp_line_no = @line_no

              @indent = 0
            rescue TerminateLineInput
              initialize_input
              prompt
            end
          end
        end
      end

      puts "Duration: #{Time.now - start} seconds"

    0.40sec -> 0.33sec

    Co-authored-by: NARUSE, Yui <naruse@airemix.jp>

    https://github.com/ruby/reline/commit/a9e39ddcc4

commit 3d0bcf1cc28041454de90de76ac755f20ccd7658
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-17 11:55:52 +0900

    [ruby/reline] Optimize ASCII character width calculation

    The rendering time in IRB has been reduced as follows:

      start = Time.now

      [{"_id"=>"5f9072a4589a06d2d74b6028",
        "index"=>0,
        "guid"=>"6b3051e2-dbc7-4537-bdb9-6cd7bb5358a7",
        "isActive"=>true,
        "balance"=>"$1,442.84",
        "picture"=>"http://placehold.it/32x32",
        "age"=>34,
        "eyeColor"=>"blue",
        "name"=>{"first"=>"Ward", "last"=>"Levy"},
        "company"=>"HYPLEX",
        "email"=>"ward.levy@hyplex.us",
        "phone"=>"+1 (867) 568-3319",
        "address"=>"867 Cobek Court, Clara, Maryland, 3254",
        "about"=>
         "Exercitation eu ex aliqua sit. Pariatur aliquip incididunt sint id non consectetur ullamco Lorem ea mollit duis amet sint labore. Commodo laborum labore commodo officia in cillum adipisicing esse excepteur cupidatat adipisicing ut. Non esse incididunt voluptate aliquip cillum eu aute duis laboris sit et. Amet enim quis tempor occaecat excepteur exercitation excepteur deserunt amet cillum adipisicing.",
        "registered"=>"Monday, May 25, 2015 6:51 AM",
        "latitude"=>"16.001127",
        "longitude"=>"-72.377848",
        "tags"=>["dolore", "nostrud", "occaecat", "cillum", "nisi"],
        "range"=>[0, 1, 2, 3, 4, 5, 6, 7, 8, 9],
        "friends"=>
         [{"id"=>0, "name"=>"Alison Bryant"},
          {"id"=>1, "name"=>"Ester Espinoza"},
          {"id"=>2, "name"=>"Sullivan Kane"}],
        "greeting"=>"Hello, Ward! You have 7 unread messages.",
        "favoriteFruit"=>"apple"}]

      puts "Duration: #{Time.now - start} seconds"

    0.73sec -> 0.43sec

      start = Time.now

      "Exercitation eu ex aliqua sit. Pariatur aliquip incididunt sint id non consectetur ullamco Lorem ea mollit duis amet sint labore. Commodo laborum labore commodo officia in cillum adipisicing esse excepteur cupidatat adipisicing ut. Non esse incididunt voluptate aliquip cillum eu aute duis laboris sit et. Amet enim quis tempor occaecat excepteur exercitation excepteur deserunt amet cillum adipisicing."

      puts "Duration: #{Time.now - start} seconds"

    0.15sec -> 0.10sec

      start = Time.now

      def each_top_level_statement
        initialize_input
        catch(:TERM_INPUT) do
          loop do
            begin
              prompt
              unless l = lex
                throw :TERM_INPUT if @line == ''
              else
                @line_no += l.count("\n")
                next if l == "\n"
                @line.concat l
                if @code_block_open or @ltype or @continue or @indent > 0
                  next
                end
              end
              if @line != "\n"
                @line.force_encoding(@io.encoding)
                yield @line, @exp_line_no
              end
              break if @io.eof?
              @line = ''
              @exp_line_no = @line_no

              @indent = 0
            rescue TerminateLineInput
              initialize_input
              prompt
            end
          end
        end
      end

      puts "Duration: #{Time.now - start} seconds"

    0.59sec -> 0.38sec

    Co-authored-by: NARUSE, Yui <naruse@airemix.jp>

    https://github.com/ruby/reline/commit/36bc9e3abb

commit c85035363feb79d283a753db1fe795fff0067213
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-14 22:52:38 +0900

    [ruby/reline] Key strokes like 2dl should behave d2l

    Key strokes, vi arg, operator, and motion should be treated as operator, vi
    arg, and motion.

    https://github.com/ruby/reline/commit/d1a7e74aa4

commit 21f26018d253bf1320432a956a9ce7dfa8ab7adb
  Author: manga_osyo <manga.osyo@gmail.com>
  Date:   2020-11-12 13:42:29 +0900

    [ruby/reline] Add test `Reline::Unicode.test_get_mbchar_width`.

    https://github.com/ruby/reline/commit/301e9048fc

commit e47e5db88943b7421f802f1fdfd34ba2224ec057
  Author: manga_osyo <manga.osyo@gmail.com>
  Date:   2020-11-12 12:36:48 +0900

    [ruby/reline] Fix crash to input `é`. refs #174

    https://github.com/ruby/reline/commit/ba5e267e5f

commit ff4656ee64f0dc7ea7eb0f87d90dd718948f4de3
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-09 16:09:42 +0900

    [ruby/reline] Version 0.1.8

    https://github.com/ruby/reline/commit/e79e402c01

commit dbfc1f30d59e595793aaf19fe2b774c103def087
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-09 15:59:52 +0900

    [ruby/reline] Add alias vi-movement-mode to vi-command-mode for compatibility

    https://github.com/ruby/reline/commit/a79c297567

commit 48742614df2f68a682226613dcaefe3dea2b1cab
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-09 15:55:53 +0900

    [ruby/reline] Move alias_method to right after original definition

    https://github.com/ruby/reline/commit/b7c8b93fa9

commit 9750c27afc99034960b74e8951718ca07cc353a8
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-08 21:56:27 +0900

    [ruby/reline] Call process_insert when the end of pasting plural fullwidth chars

    https://github.com/ruby/reline/commit/594484d9f9

commit ba8e5f77eb2562cc0605f1414426a34c7e844964
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-07 12:05:43 +0900

    [ruby/reline] Motions e, E, t, f should include a char on cursor if follows operator

    https://github.com/ruby/reline/commit/86e9a76499

commit 6be3b2da19a45e21c63ed0a9c51fa4e1a0d1bd08
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-02 21:57:54 +0900

    [ruby/reline] Implement vi_yank

    https://github.com/ruby/reline/commit/164aaf9a5f

commit 2dc4aca8d18ae8b5159da22c5d02b3052a7ac4ec
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-02 14:55:15 +0900

    [ruby/reline] Operator with arg need to make sure that they take arg to avoid crashing

    https://github.com/ruby/reline/commit/1c0c06de1f

commit 92b22db6a7d943328ef2776fb3b6a6924fc8b496
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-02 15:22:11 +0900

    [ruby/reline] Unimplemented vi command should be no-op

    https://github.com/ruby/reline/commit/abc90e6867

commit faf8f216be034a575350c7f3387992930b224bfc
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-02 14:48:44 +0900

    [ruby/reline] Keep operator proc as a local variable in the scope

    The proc variable will be used later so the instance variable will be changes.

    https://github.com/ruby/reline/commit/496c4361f6

commit 564aadce626ff8dc94784d909d2a9c7bcd27b427
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-01 22:59:03 +0900

    [ruby/reline] Skip em_exchange_mark without mark

    https://github.com/ruby/reline/commit/abb56e5ec3

commit e6429ad047a46e19739fceb8fa1a64380cb6ae12
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-01 20:39:26 +0900

    [ruby/reline] Backspace and C-h should be unassigned on vi command mode

    https://github.com/ruby/reline/commit/28f4dae020

commit 853c176ea7b36c498045b60359431afe06bd9e3f
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-11-01 20:04:20 +0900

    [ruby/reline] Version 0.1.7

    https://github.com/ruby/reline/commit/710ca23427

commit 266ffdde8eeb9b6626030653a927f033d7464cdf
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-10-31 16:45:15 +0900

    [ruby/reline] Continuous insertion buffering

    The rendering time in IRB has been reduced as follows:

      start = Time.now

      [{"_id"=>"5f9072a4589a06d2d74b6028",
        "index"=>0,
        "guid"=>"6b3051e2-dbc7-4537-bdb9-6cd7bb5358a7",
        "isActive"=>true,
        "balance"=>"$1,442.84",
        "picture"=>"http://placehold.it/32x32",
        "age"=>34,
        "eyeColor"=>"blue",
        "name"=>{"first"=>"Ward", "last"=>"Levy"},
        "company"=>"HYPLEX",
        "email"=>"ward.levy@hyplex.us",
        "phone"=>"+1 (867) 568-3319",
        "address"=>"867 Cobek Court, Clara, Maryland, 3254",
        "about"=>
         "Exercitation eu ex aliqua sit. Pariatur aliquip incididunt sint id non consectetur ullamco Lorem ea mollit duis amet sint labore. Commodo laborum labore commodo officia in cillum adipisicing esse excepteur cupidatat adipisicing ut. Non esse incididunt voluptate aliquip cillum eu aute duis laboris sit et. Amet enim quis tempor occaecat excepteur exercitation excepteur deserunt amet cillum adipisicing.",
        "registered"=>"Monday, May 25, 2015 6:51 AM",
        "latitude"=>"16.001127",
        "longitude"=>"-72.377848",
        "tags"=>["dolore", "nostrud", "occaecat", "cillum", "nisi"],
        "range"=>[0, 1, 2, 3, 4, 5, 6, 7, 8, 9],
        "friends"=>
         [{"id"=>0, "name"=>"Alison Bryant"},
          {"id"=>1, "name"=>"Ester Espinoza"},
          {"id"=>2, "name"=>"Sullivan Kane"}],
        "greeting"=>"Hello, Ward! You have 7 unread messages.",
        "favoriteFruit"=>"apple"}]

      puts "Duration: #{Time.now - start} seconds"

    2.17sec -> 0.92sec

      start = Time.now

      "Exercitation eu ex aliqua sit. Pariatur aliquip incididunt sint id non consectetur ullamco Lorem ea mollit duis amet sint labore. Commodo laborum labore commodo officia in cillum adipisicing esse excepteur cupidatat adipisicing ut. Non esse incididunt voluptate aliquip cillum eu aute duis laboris sit et. Amet enim quis tempor occaecat excepteur exercitation excepteur deserunt amet cillum adipisicing."

      puts "Duration: #{Time.now - start} seconds"

    1.57sec -> 0.22sec

      start = Time.now

      def each_top_level_statement
        initialize_input
        catch(:TERM_INPUT) do
          loop do
            begin
              prompt
              unless l = lex
                throw :TERM_INPUT if @line == ''
              else
                @line_no += l.count("\n")
                next if l == "\n"
                @line.concat l
                if @code_block_open or @ltype or @continue or @indent > 0
                  next
                end
              end
              if @line != "\n"
                @line.force_encoding(@io.encoding)
                yield @line, @exp_line_no
              end
              break if @io.eof?
              @line = ''
              @exp_line_no = @line_no

              @indent = 0
            rescue TerminateLineInput
              initialize_input
              prompt
            end
          end
        end
      end

      puts "Duration: #{Time.now - start} seconds"

    0.88sec -> 0.77sec

    https://github.com/ruby/reline/commit/7d87ac5a12

commit 76cac4c05a7be61a94a709b8b850118ad0bfa684
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-10-21 13:29:19 +0900

    [ruby/reline] Improve the performance of `get_mbchar_width`

    It is about three times faster to use one big regexp instead of
    sequential matching.

    https://github.com/ruby/reline/commit/e36f6c0707

commit b3e0db80606614f11412604f1657a135002326e9
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-10-21 07:14:45 +0900

    [ruby/reline] Version 0.1.6

    https://github.com/ruby/reline/commit/20a7806815

commit 9461cceb8aa111bf17c70ffb2e85e1c32315647f
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-10-20 10:49:18 +0900

    [ruby/reline] Update the generator script too

    https://github.com/ruby/reline/commit/8b0926820a

commit 55cc397a87dbfaa5d95168ce05f9a0d20339c657
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-10-20 08:39:12 +0900

    [ruby/reline] Suppress callbacks in pasting

    IRB uses Reline's 3 dynamic real-time callbacks with calling Ripper;
    output_modifier_proc, prompt_proc, and auto_indent_proc. These processing
    times make the paste time too long.

    https://github.com/ruby/reline/commit/beec3399a8

commit 4291ff370f88c9cbb83913b1d18e3f6206758b14
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-10-20 08:32:42 +0900

    [ruby/reline] Bypass newline insertion at eol on command prompt

    A newline is automatically inserted if a character is rendered at eol on
    command prompt.

    https://github.com/ruby/reline/commit/2dfd5d0df8

commit 6a51d393ca834984737a2fa60e9a37bc9dec2a03
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-10-19 23:22:47 +0900

    [ruby/reline] Improve the regexps for EastAsianWidth

    A character class is about three times faster than Regexp alternatives

    https://github.com/ruby/reline/commit/57c7955c55

commit 4af2e4111b0e351464a62c73e4ea0ef8b27c43f5
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-10-14 23:29:17 +0900

    [ruby/reline] Deduplicate completed items

    https://github.com/ruby/reline/commit/2dabf0c786

commit e16e481385743666443e162141116b46416cb10d
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-10-14 23:16:23 +0900

    [ruby/reline] Use yamatanooroti 0.0.6 for supporting startup_message on Windows

    https://github.com/ruby/reline/commit/167423b664

commit da59f6517865189281986edf9ffbf4f356c1b021
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-10-10 03:00:04 +0900

    [ruby/reline] Add tests about complicated rendering

    https://github.com/ruby/reline/commit/f4683b72eb

commit dd87d639e9ce71be474a9a5eb014875c88e2ae6b
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-10-09 21:46:22 +0900

    [ruby/reline] Test prompt with escape sequence

    https://github.com/ruby/reline/commit/c7c1d5f5d1

commit 87f51c7e66f9e92242621dda526c668071c315be
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-10-09 21:30:57 +0900

    [ruby/reline] Use startup_option instead of startup wait

    https://github.com/ruby/reline/commit/a63ce6371c

commit 092c253bff2e81ddae6e8c85b3a94af45129bdab
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-09-12 07:37:46 +0900

    [ruby/reline] Wait for the process to be started in start_terminal

    https://github.com/ruby/reline/commit/d29d33dcf5

commit 62666a6bbdab7a066c761283e448132215ca2e7d
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-10-06 23:55:33 +0900

    [ruby/reline] Add write_inputrc

    https://github.com/ruby/reline/commit/70536d8c9a

commit d5cf3fcd68348ac047094dc24a54e0ea055de844
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-10-05 01:07:24 +0900

    [ruby/reline] Update to Unicode 13.0.0

    https://github.com/ruby/reline/commit/d49bb0aa34

commit d7cda3b0024d82d9c921382b7095a31c866fa857
  Author: Peter Zhu <peter@peterzhu.ca>
  Date:   2020-12-05 00:49:33 +0900

    Add T_MOVED to rp command of GDB

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3846

commit b4ec4a41c24105efbb43f9b70ca7f36d22f98294
  Author: Benoit Daloze <eregontp@gmail.com>
  Date:   2020-12-05 00:40:02 +0900

    Guard all accesses to RubyVM::MJIT with defined?(RubyVM::MJIT) &&

    * Otherwise those tests, etc cannot run on alternative Ruby implementations.

commit 83e983ab61b532d17a1177c66e3e43a5042edc1f
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-05 00:32:51 +0900

    * 2020-12-05 [ci skip]

commit 9ea1055eabcb0e498f387953a28747dea9bf2308
  Author: Benoit Daloze <eregontp@gmail.com>
  Date:   2020-12-05 00:32:14 +0900

    2.8 -> 3.0 in specs

commit 94d49ed31c39002335eeee65d42463139f561954
  Author: Masaki Matsushita <glass.saga@gmail.com>
  Date:   2020-11-26 16:07:28 +0900

    Add a hook before fork() for getaddrinfo_a()

    We need stop worker threads in getaddrinfo_a() before fork().
    This change adds a hook before fork() that cancel all outstanding requests
    and wait for all ongoing requests. Then, it waits for all worker
    threads to be finished.

    Fixes [Bug #17220]

commit 1cfc6e7b7a92c1a624182392ba702d3dcb2eba98
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-04 20:21:41 +0900

    Added dependencies for rinda

commit 6f14a30022e284398017b47d37f3f717f384f985
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-09-23 03:22:04 +0900

    [ruby/logger] Consider cygwin a Windows platform

    This should fix Ruby Bug 12468.

    https://github.com/ruby/logger/commit/49de53d1fc

commit 60b57866ac64ef8a21951c7d5ff7b7f98e1ce15f
  Author: Masataka Pocke Kuwabara <p.ck.t22@gmail.com>
  Date:   2020-11-24 00:37:13 +0900

    [ruby/mutex_m] Fix `Mutex_m#initialize` when the super's initialize has kwargs

    Co-authored-by: Ryuta Kamizono <kamipo@gmail.com>

    https://github.com/ruby/mutex_m/commit/84ca1fc108

commit da126250ba31cd341b434b86047cf4ebde4e2539
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-10-28 03:05:54 +0900

    [ruby/fileutils] Make mkdir_p only attempt to create necessary directories

    Previously, if creating the directory directly didn't work
    and the directory didn't exist, mkdir_p would create all
    directories from the root.  This modifies the approach to
    check whether the directory exists when walking up the
    directory tree from the argument, and once you have found an
    intermediate directory that exists, you only need to create
    directories under it.

    This approach has a couple advantages:

    1) It performs better when most directories in path already exist,
    and that will be true for most usage of mkdir_p, as mkdir_p is
    usually called with paths where the first few directories exist
    and only the last directory or last few directories do not.

    2) It works in file-system access limited environments such as
    when unveil(2) is used on OpenBSD.  In these environments, if
    /foo/bar/baz exists and is unveiled, you can do
    `mkdir /foo/bar/baz/xyz` but `mkdir /foo` and `mkdir /foo/bar` raise
    Errno::ENOENT.

    https://github.com/ruby/fileutils/commit/ec0c229e78

commit e666bd1c5a595ab64faee00b3744b3bfa591acb1
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-04 19:36:30 +0900

    Skip subclass spec with SortedSet

commit b06ffce4aef002dc47c3c5968181230e7ab8d7cc
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-04 19:34:06 +0900

    SortedSet was removed at a3db08d7b6ff119223f77e3df00b4f6deac971e2

commit 1804c3368cf4a94791fafa9701f79a2e6f76d5d8
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-10-02 12:55:46 +0900

    [ruby/set] Add `Set#<=>`

    https://github.com/ruby/set/commit/447974a374

commit a3db08d7b6ff119223f77e3df00b4f6deac971e2
  Author: Akinori MUSHA <knu@idaemons.org>
  Date:   2020-09-20 22:03:33 +0900

    [ruby/set] Remove SortedSet implementations

    It required RBTree to perform decently and the external dependency was
    not suitable for a standard library.  The pure ruby fallback
    implementation was originally meant to be an example of how to write a
    subclass of Set, and its poor performance was not suitable for use in
    production.

    I decided it should be distributed as an external library instead of
    bundling it with Set.

    https://github.com/ruby/set/commit/dfcc8e568b

commit 46fc8d78a5d23d3c9a24e1bcc3c5cde4bce888de
  Author: Akinori MUSHA <knu@idaemons.org>
  Date:   2020-09-20 23:23:13 +0900

    [ruby/set] Resurrect support for Ruby 2.x

    In Ruby 2.x, initialize_copy does not take a freeze option.

    https://github.com/ruby/set/commit/3da6c309df

commit 0adc426ca5cf83e57f5e8433a2f7b55fb7a1fad6
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-10-30 04:28:09 +0900

    [ruby/zlib] Add Zlib::Inflate#inflate :buffer keyword argument

    If a buffer keyword argument is given, it is used as the buffer,
    instead of creating new strings.  This can result in significantly
    lower memory usage during inflation.

    Implements #19

    https://github.com/ruby/zlib/commit/dac9a9b57d

commit bc63ec57e7f965796479f68f6f687187c089bd40
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-10-29 02:58:28 +0900

    [ruby/zlib] Allow Zlib.crc32 and .adler32 to accept IO instance

    This reads from the IO in 8192 byte chunks, so you don't need to
    have the entire string in memory.

    Fixes #16

    https://github.com/ruby/zlib/commit/ba9793c550

commit a60dfff43470583bbb4474594efde8607f889e8b
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-09-12 05:15:08 +0900

    [ruby/zlib] Document that gets can return nil when eof? returns false

    This behavior differs from File#gets.

    Fixes [Bug #13904]

    https://github.com/ruby/zlib/commit/448e41efdd

commit cf582aa6ee9d8326f930799a4045979a924ffa5e
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-04 12:59:19 +0900

    Fixed a code block in NEWS [ci skip]

    A code block needs to be separated from the previous paragraph by
    an empty line.

commit c0de997eddfccd0a9d398a91ef122b16af1686d4
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-04 14:23:24 +0900

    memory_view.c: Fix endianness of n, N, v, V

commit e8cee4915b280dab57ca4f916f36bea4eb7ebdf1
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-04 14:59:12 +0900

    fix initialize order

    `captured->code.val` should be initialize before because it can be
    a GC point by another ractor because `RB_OBJ_WRITE` can issue
    VM locking.

commit 82bbce826f7f170270856bec8ef852667028d143
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-04 14:39:03 +0900

    fix index

    `i` should not be used here because `i` will be `alen` when
    jumped here by "goto restart".

commit f1757a88a4c8e2a50481de020787b37d926463df
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-04 14:33:31 +0900

    Avoid leaving too many core files in /tmp

    for CIs like ci.rvm.jp.

commit 30fba5f37d9058cc7e4d852ff211313f13ded3a1
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-04 14:24:35 +0900

    Do not require time and fileutils by default

    I have no idea what I'm doing, but the previous commit caused lots of CI
    failures like https://github.com/ruby/ruby/runs/1496949568 and this
    place is the most suspicious.

commit 067f45ecd379ea44f294084c8f342c69f735c018
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-04 14:01:24 +0900

    Save a core file on a worker crash

    CI failures like
    http://ci.rvm.jp/results/trunk-mjit@phosphorus-docker/3280458 doesn't
    provide any useful information, and it doesn't leave a core file in a CI
    environment because a test like `Process.kill(:TRAP, $$)` overwrites in
    a next run very quickly.

    Thus I'd like to keep core files in /tmp.

commit 0734a6cd59e6fb1d59180ee73113709ec238b045
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-04 13:55:29 +0900

    Revert "Report a full_message on a worker crash"

    This reverts commit 00f046ef57f9da7f5248f9ef9d55702ddc407bf1.
    It was not helpful for an issue I was debugging.

commit 95118e0250e2255811cc18694b97af1a920cffaf
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-04 12:02:20 +0900

    Fixed links in NEWS [ci skip]

    * added a missing link
    * removed a duplicated link

commit ee4373c81d12efce167b22f521925748728ae92d
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-12-04 11:32:32 +0900

    Remove backticks from method names in NEWS [ci skip]

    nobu pointed out this prevents automatic linking to the methods.

commit 94b2323a68eaac272374b42399f24ea62445f35b
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2020-12-04 10:37:17 +0900

    Fix typos [ci skip]

commit a9d773a2888d37993db172023769822574f1c8e8
  Author: Aaron Patterson <tenderlove@ruby-lang.org>
  Date:   2020-12-04 10:19:15 +0900

    Revert "Skip repeated scan of object during compaction"

    This seems to be breaking the build for some reason.

    This command can reproduce it:

    `make yes-test-all TESTS=--repeat-count=20`

    This reverts commit 88bb1a672c49746972f4b15410fa92e9d237c43d.

commit 9195310168fa43186b1918fb0432a54b000fcbba
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-12-04 05:47:34 +0900

    Update documentation for String#encode{,!} [ci skip]

    These methods take keywords, not a hash.

    From tjschuck (T.J. Schuck)

    Fixes [Bug #17364]

commit 88bb1a672c49746972f4b15410fa92e9d237c43d
  Author: Peter Zhu <peter@peterzhu.ca>
  Date:   2020-12-04 04:09:18 +0900

    Skip repeated scan of object during compaction

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3843

commit 04b96fc322fe6547d2587f5ccbe0a835af93e48d
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-04 02:08:21 +0900

    * 2020-12-04 [ci skip]

commit b60eaea8e54fb003a79a5a165c6ee55d653322f6
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-12-04 02:02:42 +0900

    Update NEWS [ci skip]

    Make core class updates section use a consistent format. Alphabetize
    core class updates section by class name, and stdlib updates section
    by library name.  Minor formatting changes while here.

commit bc4ca06f90c0da09fe3a6d2ab29e260b9b9cfe1b
  Author: Yusuke Endoh <mame@ruby-lang.org>
  Date:   2020-12-03 23:34:46 +0900

    test/ruby/test_io.rb: some test methods had been overwritten

    http://rubyci.s3.amazonaws.com/ubuntu/ruby-master/log/20201203T123002Z.log.html.gz
    ```
    /home/chkbuild/chkbuild/tmp/build/20201203T123002Z/ruby/test/ruby/test_io.rb:1830:
    warning: method redefined; discarding old test_each_byte
    /home/chkbuild/chkbuild/tmp/build/20201203T123002Z/ruby/test/ruby/test_io.rb:376:
    warning: previous definition of test_each_byte was here
    test/unit warning: method TestIO#test_each_byte is redefined
    /home/chkbuild/chkbuild/tmp/build/20201203T123002Z/ruby/test/ruby/test_io.rb:1849:
    warning: method redefined; discarding old test_each_char
    /home/chkbuild/chkbuild/tmp/build/20201203T123002Z/ruby/test/ruby/test_io.rb:1799:
    warning: previous definition of test_each_char was here
    test/unit warning: method TestIO#test_each_char is redefined
    ```

commit 2a99fea89e6a9510f2f2b378cfa661264bcffd5e
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-03 21:31:44 +0900

    test-bundled-gems.rb: show failed gems at last

commit d3c685f0b5b1aedfdeb7660b374ab033bcd27147
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-03 19:17:29 +0900

    digest gem is available now

commit 1af8a0a95ecc606cb57f8bce82288b6c263d9631
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-03 17:39:15 +0900

    [ruby/ipaddr] fixup 90b46678a5b09ed32612b0629b7c51c6d39a0444

    https://github.com/ruby/ipaddr/commit/d2ec7cc3ee

commit e62eb9a3fa627b42eb4445688afc46bd28c0def4
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-03 17:33:34 +0900

    [ruby/ipaddr] Relaxed Ruby version for 3.0

    https://github.com/ruby/ipaddr/commit/90b46678a5

commit d65621b636e1eb89696f13f4076e53d54710cb3f
  Author: Samuel Williams <samuel.williams@oriontransfer.co.nz>
  Date:   2019-07-09 20:16:23 +0900

    Specify minimum version.

commit ca024beeba93340aefff6dde6ee3ac35d9b03352
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-07-16 18:03:28 +0900

    Use Gemfile instead of Gem::Specification#add_development_dependency.

commit 7b126a82a921c991f8121f62e094a62a5f0edb30
  Author: Samuel Williams <samuel.williams@oriontransfer.co.nz>
  Date:   2019-07-09 20:16:13 +0900

    Simplify `ipaddr.gemspec`.

commit ab524dfdd90078b48cc41354a8e9a472ef466a2f
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-08-24 23:07:15 +0900

    [ruby/forwardable] Specify minimum Ruby version.

    Remove jruby-9.1.17.0 from CI

    https://github.com/ruby/forwardable/commit/08d92a9c39

commit 5b1ebb8ead87e7b3b35c6e43959b6b8687ac3be3
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-09-26 11:02:58 +0900

    [ruby/readline-ext] Rename depend.gem with depend-gem

    https://github.com/ruby/readline-ext/commit/897ffe26a6

commit b526db85fe96f906beea6500f7029013a16f9349
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-09-26 01:47:28 +0900

    [ruby/readline-ext] Version 0.1.1

    https://github.com/ruby/readline-ext/commit/6d55854434

commit b619197dfad4767ee779822047ca0b03ffe1fb05
  Author: aycabta <aycabta@gmail.com>
  Date:   2020-09-26 01:43:25 +0900

    Use gemified depend

commit eab4aa4178e9fb55f7c9abfeb631bbe44a665d6e
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-10-11 15:41:08 +0900

    [ruby/io-wait] Added extensions

    https://github.com/ruby/io-wait/commit/664c93b2ff

commit 09266eccf46540e1cd8170800e3b52a6565254d3
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-10-11 15:27:45 +0900

    [ruby/io-wait] Fixed regexp to reject .travis* at the toplevel only

    https://github.com/ruby/io-wait/commit/4434b10e46

commit 7fcbe07d612a967d1904a52617903007c28ffb86
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-10-11 15:25:15 +0900

    [ruby/io-wait] Exclude dot-files for CIs

    https://github.com/ruby/io-wait/commit/12cce69ddf

commit 09bcb935ec5467e44bab7426446c6e7ce2bbf983
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-10-11 15:19:23 +0900

    [ruby/io-wait] Fix ls-files matching regexp

    See rubygems/rubygems@8a81183236c4475152798db99734e89779287331.

    https://github.com/ruby/io-wait/commit/04857e0cf5

commit 2800e9f347dc9110d2be33d5abab94a1957c71a6
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-10-12 14:56:27 +0900

    [ruby/io-nonblock] Added extensions

    https://github.com/ruby/io-nonblock/commit/8b7abbd1b5

commit 7820162018869f8931e7abd5d153d5d26c6ae411
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-10-12 14:55:48 +0900

    [ruby/io-nonblock] Exclude dot-files for CIs

    https://github.com/ruby/io-nonblock/commit/9fa3ad9c7a

commit 7d0a6e28f2260ec2ba487c174e35a9dc614e2e60
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-10-12 14:53:29 +0900

    [ruby/io-nonblock] Fix ls-files matching regexp

    See rubygems/rubygems@8a81183236c4475152798db99734e89779287331.

    https://github.com/ruby/io-nonblock/commit/e14f7952c1

commit 412a0f52406b2e215eaa77dd601c456dd5c23fce
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-03 16:31:14 +0900

    [ruby/digest] LICENSE

    https://github.com/ruby/digest/commit/aa048ce345

commit 7324d76da40de79cd1a25d023b1a0629002929a7
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-03 16:30:57 +0900

    [ruby/digest] Fixup d981714348f71177132426e3ac19598e1b2e8f5d

    https://github.com/ruby/digest/commit/502a12587c

commit 541e4340dd70de75d44c8ac3b5a4a69943042737
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-03 17:01:10 +0900

    Assert unit->iseq null out happens under the JIT/GC guard

commit 58c3c75fee775abb9a145e7b106320a55f2c8be1
  Author: Takashi Kokubun <takashikkbn@gmail.com>
  Date:   2020-12-03 16:38:40 +0900

    Skip checking Ractor recursive locking

    for an MJIT worker thread. We can't do it because its GET_EC() returns
    NULL.

commit 29c9588e7ec4fcc36c91b3783dfbfe86a4d104bf
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-12-03 15:27:54 +0900

    Add Proc#{==,eql?} addition to NEWS [ci skip]

commit 43b95bafd57d04c8fb401d3a9b52aca3f5b4b0be
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2020-07-27 11:15:50 +0900

    delete deprecated IO-like methods

    This commit deletes
    {IO,ARGF,StringIO,Zib::GZipReader}#{bytes,chars,lines,codepoints}, which
    have been deprecated since c47c095b9740e7c19d6fdca29ab661c1089221d4.

    Note that String also has those methods.  They are neither depreacted
    nor deleted because they are not aliases of counterpart each_something.

commit 84eb2bfab940fc9c6962c10ede7f72cee3fb9899
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2020-12-03 11:53:56 +0900

    include/ruby/internal/xmalloc.h: add doxygen

    Thought it was not a bad idea to document these CAPI. [ci skip]

commit 1f71c7dc81628bfd141bb91ee10bd8ca44ccaf07
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-03 06:49:52 +0900

    add GC guard

    new_prev_env is stored in the env_body memory block but this is not
    a GC root, so new_prev_env could be freed.

commit 51268be7feace6a6547f8be72d6baf9023b08f2b
  Author: Aaron Patterson <tenderlove@ruby-lang.org>
  Date:   2020-10-24 08:13:11 +0900

    When allocating new pages, add them to the end of the linked list

    When we allocate new pages, allocate them on the end of the linked list.
    Then when we compact we can move things to the head of the list

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3814

commit 9e73177d5362c1986814f411961b712967dc5f97
  Author: Jeremy Evans <code@jeremyevans.net>
  Date:   2020-11-24 07:40:59 +0900

    Do not reduce quantifiers if it affects which text will be matched

    Quantifier reduction when using +?)* and +?)+ should not be done
    as it affects which text will be matched.

    This removes the need for the RQ_PQ_Q ReduceType, so remove the
    enum entry and related switch case.

    Test that these are the only two patterns affected by testing all
    quantifier reduction tuples for both the captured and uncaptured
    cases and making sure the matched text is the same for both.

    Fixes [Bug #17341]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3808

commit 7546be2ca0de45bcc2a72d9b4ae0cd44a1322031
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-03 01:23:57 +0900

    * 2020-12-03 [ci skip]

commit 0bebea985dd1b759973e285e87ed9dfa8610d253
  Author: Aaron Patterson <tenderlove@ruby-lang.org>
  Date:   2020-12-02 08:15:14 +0900

    Incremental sweeping should not require page allocation

    Incremental sweeping should sweep until we find a slot for objects to
    use.  `heap_increment` was adding a page to the heap even though we
    would sweep immediately after.

    Co-authored-by: John Hawthorn <john@hawthorn.email>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3837

commit 12a121cc0f7f5b438388288383a7b8b9baf3e2fe
  Author: 卜部昌平 <shyouhei@ruby-lang.org>
  Date:   2020-07-27 10:25:27 +0900

    ENV.index: delete

    Has been deprecated since 373282f6656d3d3d989d261e7a95f8e81b5c9712.

commit 28001e55b3eb65e210484bc2b6f42e89c2903d49
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-02 15:58:37 +0900

    Added dependencies for net-pop

commit 1fa3f9a1b5d237d4d9d6ad87e1d56ea5c1e98717
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-02 15:57:28 +0900

    Added dependencies for net-imap

commit 4e01ab342a4b1478255eee09ddbb5e9fe46a88b9
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-02 19:11:01 +0900

    Revert "Removed deprecated Dir.exists? and File.exists?"

    This reverts commit 1a5205536f0c0d6021450b11722919211847df86.

commit 1a5205536f0c0d6021450b11722919211847df86
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-11-30 23:33:20 +0900

    Removed deprecated Dir.exists? and File.exists?

commit 9e94cd18fcf193a9f87b908b7130123602a7d800
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-02 17:06:09 +0900

    test-bundled-gems: select bundled gems to test by BUNDLED_GEMS

commit 44f038bd7f8371011722ef3531a13d054e541fa2
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-02 17:04:33 +0900

    gmake.mk: renamed BUNDLED_GEMS as bundled-gems

    Hyphenated names are safe in GNU make.

commit 30ded41fc3237f83470d0f6b64103f18bc92a78d
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-02 16:16:27 +0900

    Loaded script is unset yet when crashed in the initialization phase

commit 98c9120cc00ba691b4abcc13a49a30fa54638535
  Author: Soutaro Matsumoto <matsumoto@soutaro.com>
  Date:   2020-12-02 13:45:00 +0900

    Bundle rbs 0.19.0 (#3838)

  Notes:
    Merged-By: soutaro <matsumoto@soutaro.com>

commit c461b2405ca2b86b6d1328a51374bda8a2fdf332
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-02 13:32:43 +0900

    Removed needless .rb

commit 4bbb61001187a285ba8e504ef2fdce9a4835966f
  Author: Vít Ondruch <vondruch@redhat.com>
  Date:   2019-12-18 23:03:38 +0900

    Emit warning when 'RubyGems' were not properly loaded.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2764

commit fbe37ff37a291f138d9a1119df257174005e7086
  Author: Vít Ondruch <vondruch@redhat.com>
  Date:   2019-12-18 23:02:31 +0900

    Emit warning when 'did_you_mean' was not properly loaded.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2764

commit 0ad7f2dd19c84e44b8fd8d314de33c3e2255feb6
  Author: Vít Ondruch <vondruch@redhat.com>
  Date:   2019-12-18 22:55:25 +0900

    Don't fail when 'RubyGems' are not available.

    Although 'RubyGems' are always available in upstream Ruby, it might not
    be available optionally when Ruby is delivered via packaging systems.
    E.g. Linux distributions.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2764

commit 55c9a95ac8ed1a44645cc8d7d80f2e5ebee6ec8f
  Author: Vít Ondruch <vondruch@redhat.com>
  Date:   2019-12-18 22:29:17 +0900

    Don't fail when 'did_you_mean' is not available.

    Although 'did_you_mean' is always available in upstream Ruby, it might
    not be available when speed, memory, disk or network bandwidth is a
    concern. This is typically the case for production environment, where
    'did_you_mean' is of limited usage.

    Also it might not be available optionally when Ruby is delivered via
    packaging systems. E.g. Linux distributions.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/2764

commit 2e601c284c9b61c286aa031d91e5198c17b44f00
  Author: Kazuki Yamaguchi <k@rhe.jp>
  Date:   2020-05-28 00:53:41 +0900

    digest: remove OpenSSL engine

    The OpenSSL engine of Digest uses the low-level API of OpenSSL, whose
    use has been discouraged for years for multiple reasons.

    A long-standing issue on a FIPS-enabled system is that using ::Digest
    results in crashing the Ruby process, because the low-level API lacks
    the mechanism to report an error (the policy violation) and thus kills
    the process as a last resort[1][2]. Also, the upcoming OpenSSL 3.0 will
    deprecate it for future removal[3]. Compiling with
    -Wdeprecated-declarations will start to emit warnings.

    A proper fix for this is to make it use the EVP API instead. This is a
    non-trivial work as it requires backwards-incompatible changes to the
    framework interface of Digest::Base and rb_digest_metadata_t.

    It is more than 15 years ago that the openssl library became part of the
    standard library. It has implemented the exactly same functionality as
    OpenSSL::Digest, in fact, as a subclass of Digest::Class. There is not
    much point in having an identical code in the digest library. Let's
    just get rid of OpenSSL within digest. This leaves the C implementations
    and the CommonCrypto engine for Apple systems.

    A patch is being prepared for the openssl library to provide ::Digest
    constants for better performance[4].

    [1] https://bugs.ruby-lang.org/issues/6946
    [2] https://bugs.ruby-lang.org/issues/13681
    [3] https://www.openssl.org/docs/OpenSSL300Design.html
    [4] https://github.com/ruby/openssl/pull/377

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3149

commit 95bb49d42568802e36b213a7139176dbf9f58672
  Author: Cristian Greco <cristian@regolo.cc>
  Date:   2020-10-22 23:34:53 +0900

    Fix code example in Readline::HISTORY documentation.

    Wrapping the example into a <code> block to avoid it being rendered as a link.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3686

commit 82dc0c6aa380ea736adcd5ea54ec8f77a9269007
  Author: Kenta Murata <mrkn@mrkn.jp>
  Date:   2020-12-02 09:42:05 +0900

    memory_view.c: Check availability in rb_memory_view_get

commit 7172272c4ca290b0b8d5bed4dd9de84eb1561303
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-01 21:42:02 +0900

    Added dependencies for net-ftp

commit afba96f9f5cc94ecbd717e792c568511ed0729fe
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-01 21:41:24 +0900

    Added dependencies for net-http

commit 48149d8fe7634a521a41be7bc1b9c49a39104d65
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-01 21:39:59 +0900

    Added dependencies for net-smtp

commit b0f4cccfaea3fcd65cf22931b481c405bc759b64
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-01 21:38:52 +0900

    Added dependencies for net-protocol

commit f8435f424bd634cfafef137d2a18b6d3e8f4dddf
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-01 21:23:04 +0900

    Added dependencies for tmpdir

commit 10d6a2733415e3184bf87534969a531e19416faa
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-01 21:21:33 +0900

    Added dependencies for erb

commit c364865bdf2bafbdb7cd1338ddda25d32ce0db5e
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-01 21:19:39 +0900

    Added dependencies for pp

commit 56141d38a3f3910d883e1dde754998ce10b79a58
  Author: Alan Wu <XrXr@users.noreply.github.com>
  Date:   2020-11-26 07:33:09 +0900

    Fix docs about movement for rb_gc_register_mark_object()

    This API in fact pins objects passed to it. See vm.c:2546.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3815

commit 984ba8de75ab306bb87c8f4767dd179bb81ee308
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-02 00:40:39 +0900

    * 2020-12-02 [ci skip]

commit 21bc330e5f190d9b40c3e0fd4945247bdd68d5ab
  Author: Soutaro Matsumoto <matsumoto@soutaro.com>
  Date:   2020-12-02 00:40:09 +0900

    Bundle rbs 0.18.1 (#3825)

  Notes:
    Merged-By: soutaro <matsumoto@soutaro.com>

commit 0c57438ccfe394050142171c4d5bba3ae1885534
  Author: jacopo <1753245+intrip@users.noreply.github.com>
  Date:   2020-12-01 20:19:05 +0900

    Update fixnum.h

    Fix a typo: "nevative" => "negative" in `rb_fix_plus_fix`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3834

commit ad0c2232b1743f329b882977f068aecdbd6e0d8f
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-01 19:14:36 +0900

    Added dependencies for open-uri

commit ac29c405f6816fbb3c52d4d10d85e224ed9dc455
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-01 19:14:07 +0900

    Added dependencies for time

commit 0115ae5ffcf88c5e49ad291ce7be9eefca3f2575
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-01 19:09:06 +0900

    Added dependencies for prime

commit 6ac5e3c06a29dd51b8c8ab7bee21c29c50f779e0
  Author: Hiroshi SHIBATA <hsbt@ruby-lang.org>
  Date:   2020-12-01 18:32:20 +0900

    Added dependencies for weakref

commit 764de7566ffa3fe828abf13ec93d76515ba27dd1
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-01 16:34:59 +0900

    should not use rb_str_modify(), too

    Same as 8247b8edde, should not use rb_str_modify() here.

    https://bugs.ruby-lang.org/issues/17343#change-88858

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3833

commit d5e16161f6871793bf2f148b5a6901a1a3f6d326
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-12-01 17:35:28 +0900

    Update ext/.document

commit 1ca9facab6c85264168b4c0a18c24f489cabcc9f
  Author: Kazuhiro NISHIYAMA <zn@mbf.nifty.com>
  Date:   2020-12-01 16:07:14 +0900

    Add monitor to document files

commit 182fb73c40351f917bf44626c44c1adb6cb1aa5a
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-11-30 16:18:43 +0900

    rb_ext_ractor_safe() to declare ractor-safe ext

    C extensions can violate the ractor-safety, so only ractor-safe
    C extensions (C methods) can run on non-main ractors.
    rb_ext_ractor_safe(true) declares that the successive
    defined methods are ractor-safe. Otherwiwze, defined methods
    checked they are invoked in main ractor and raise an error
    if invoked at non-main ractors.

    [Feature #17307]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3824

commit 8247b8eddeb2a504a5c9776d1f77d413c8146897
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-01 11:14:36 +0900

    should not use rb_ary_modify()

    ractor_copy() used rb_ary_modify() to make sure this array is not
    sharing anything, but it also checks frozen flag. So frozen arrays
    raises an error. To solve this issue, this patch introduces new
    function rb_ary_cancel_sharing() which makes sure the array does not
    share another array and it doesn't check frozen flag.
    [Bug #17343]

    A test is quoted from https://github.com/ruby/ruby/pull/3817

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3831

commit d2cfb5228a89678a712efd381e049391800373e1
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-01 11:10:19 +0900

    show with sharing info

commit a67cd8a8886eed7579c3ffbaf84beecda7ab7d2f
  Author: James Koenig <Koenig.James@Live.com>
  Date:   2020-12-01 05:48:31 +0900

    -> creates a lambda so this updates the documentation to reflect that

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3828

commit 67693d8d806e67d6e50b303dd0be6ec06b81c853
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-11-28 04:39:09 +0900

    ractor local storage C-API

    To manage ractor-local data for C extension, the following APIs
    are defined.

    * rb_ractor_local_storage_value_newkey
    * rb_ractor_local_storage_value
    * rb_ractor_local_storage_value_set
    * rb_ractor_local_storage_ptr_newkey
    * rb_ractor_local_storage_ptr
    * rb_ractor_local_storage_ptr_set

    At first, you need to create a key of storage by
    rb_ractor_local_(value|ptr)_newkey().
    For ptr storage, it accepts the type of storage,
    how to mark and how to free with ractor's lifetime.

    rb_ractor_local_storage_value/set are used to access a VALUE
    and rb_ractor_local_storage_ptr/set are used to access a pointer.

    random.c uses this API.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3822

commit e79f1941b29738d95b42f8cb5bdb159e7138cf49
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-12-01 01:27:04 +0900

    tune parallel test

    This patch contains the fowllowing hacks:

    (1) Add "--timetable-data=FILE" option for test-all
        This option enables to dump timeline event
        contains worker, suite, and start/end time.
    (2) remove TestJIT in test_jit_debug.rb on parallel test.
        it is duplicated test.
    (3) move test_jit.rb and test_jit_debug.rb at first
        because these two tests are bottleneck of parallel tests.

    On my environment, `make test-all TESTS=-j12` reduced the total time
    190 seconds -> 140 seconds.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3826

commit e25165b3fc72166a85ed10e49609153d72333388
  Author: Marc-Andre Lafortune <github@marc-andre.ca>
  Date:   2020-12-01 05:51:30 +0900

    Fix `Ractor.make_shareable` for recursive structures with unfreezable components

    Followup to #3823

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3827

commit 750e2d9e5ef40f3d69cee957c263a925ff3a3ad6
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-12-01 07:45:56 +0900

    * 2020-12-01 [ci skip]

commit 56bb6e7d582f2e73c23f05594cd89d6deea9c318
  Author: Aaron Patterson <tenderlove@ruby-lang.org>
  Date:   2020-12-01 06:28:24 +0900

    Only check if the current ep is a local or not, then mark

    The vm mark function should only check if the current frame is a local
    or not and then mark values in that frame.  Since it's walking up the
    stack looking at each cfp, then all ep's should be examined.

    This fixes a bug in the Rails tests where we're seeing segv in railties.

    Thanks Yasuo Honda for giving me a reliable repro!

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3829

commit 89774a938a5681193297c5346eeab4ee1dac563b
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-11-30 19:06:25 +0900

    [DOC] Update -l option [ci skip]

    `-l` option has used `chomp!` since Ruby 2.5.  [Bug #12926]

commit b4e21ce25cfa6bf8a04cdeba8875215c5aabfaf1
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-11-30 16:55:47 +0900

    Clean temproray directory created by test-spec

commit d92f427d5ae71da27028770d5c1bd6747d64b6ec
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-11-30 16:54:07 +0900

    Clean static-ruby

commit 6bef49427ab2a9d3bc338f1cffcd086153a59f44
  Author: Jean Boussier <jean.boussier@gmail.com>
  Date:   2020-11-18 21:57:01 +0900

    Fix rb_interned_str_* functions to not assume static strings

    Fixes [Feature #13381]

    When passed a `fake_str`, `register_fstring` would create new strings
    with `str_new_static`. That's not what was expected, and answer
    almost no use cases.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3786

commit 930a135524382ddd80c0608a7593b6cdfceee846
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-11-30 16:07:36 +0900

    Fixed Ractor.shareable? on cross-recursive objects [Bug #17344]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3823

    Merged-By: nobu <nobu@ruby-lang.org>

commit 555bd83a8e8b1e859f698089cbbd9ad938159a0e
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-11-30 15:19:49 +0900

    Raise when loading unprovided builtin function [Bug #17192]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/3622

    Merged-By: nobu <nobu@ruby-lang.org>

commit 73a337e21461469290005f169c05bc1791112d67
  Author: Kenta Murata <mrkn@users.noreply.github.com>
  Date:   2020-11-30 14:53:13 +0900

    Keep references of memory-view-exported objects (#3816)

    * memory_view.c: remove a reference in view->obj at rb_memory_view_release

    * memory_view.c: keep references of memory-view-exported objects

    * Update common.mk

    * memory_view.c: Use st_update

  Notes:
    Merged-By: mrkn <mrkn@ruby-lang.org>

commit 7e1dbe59759247ae0df26ef3f669009f00e058fd
  Author: Nobuyoshi Nakada <nobu@ruby-lang.org>
  Date:   2020-11-30 12:18:21 +0900

    [DOC] Fixed st_udpate comment [ci skip]

    Clarified that the first and second arguments to the callback
    function are pointers to the KEY and the VALUE, but not those
    values themselves.

commit b408d32bf2f8c7f952691388ad1307cf99019882
  Author: git <svn-admin@ruby-lang.org>
  Date:   2020-11-30 05:12:18 +0900

    * 2020-11-30 [ci skip]

commit 77936ad679d63a6d0e7b585db4c31db5507f5586
  Author: Koichi Sasada <ko1@atdot.net>
  Date:   2020-11-30 05:07:28 +0900

    support SIGSEGV/BUS while read_barrier_handler()

